import Bladex
import CharStats
import Reference
import Actions
import math
import whrandom
import B3DLib
import ItemTypes
import darfuncs
import EnemyTypes
import GameStateAux

import EnemyNPCTypes






Bladex.AddParticleGType("Tierra3","GenericParticle",Reference.B_PARTICLE_GTYPE_BLEND,60)

for i in range(60):
	aux=(60-i)/60
	r=40
	g=30
	b=0
	a=255*(1.0-aux/2.0)
	size=60.0*(1.0-aux)
	Bladex.SetParticleGVal("Tierra3",i,r,g,b,a,size)
	
	
	
Bladex.AddParticleGType("Tierra2","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,64)

for i in range(64):
	aux=(64.0-i)/64.0
	r=210
	g=190
	b=140
	a=255.0*(1.0-aux)**0.5
	size=80.0+aux*400.0
	Bladex.SetParticleGVal("Tierra2",i,r,g,b,a,size)


Bladex.AddParticleGType("Tierra2sub","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,64)

for i in range(64):
	aux=(64.0-i)/64.0
	r=200
	g=140
	b=100
	a=255.0*(1.0-aux)**0.5
	size=80.0+aux*400.0
	Bladex.SetParticleGVal("Tierra2sub",i,r,g,b,a,size)
	
	
##########################################################################################################################################################
### SkeletonDRTP uses specialy designed blade. They are awkward for other chars to weild so you can't pick them up.

	
SklScytheHit=[5,8,15,25,35,50,65,85,100,120,150,190,240,300,380,460,550,650,820,950]
SklScytheDef=[0,-3, -5, -10, -15, -20, -25,-30, -35, -40, -45, -50, -55, -60, -65, -70,-75, -80,-85]
	
Weps=["Garrote","Hacha","Hacha3","Maza","Garropin","Orksword","Espadaelfica","Maza2","HookSword","Martillo2","Espadacurva","EgyptSword","Dagesse","Cimitarra","Garrote2","Maza3","DoubleSword","DoubleSword","Espadafilo","Espada"]
	
	


	


class SkelHole (ItemTypes.PersistantItemType):

	def __init__(self, me, entitykind):
		ItemTypes.PersistantItemType.__init__(self, me)
		
		self.Active=1
		self.Name=me.Name
		self.Skelnum=0
		self.trsectorname=""
		self.EntityKind=entitykind
		self.DustFX=1
		self.Enabled=1
		self.ExtDeadFunc=""
		self.ExtDeadArgs=()
		
		self.GenSound=Bladex.CreateEntity (me.Name+"GenSound", "Entity Sound", 0, 0, 0)
		self.GenSound.SetSound("..\\..\\Sounds\\M-GENERADOR-ENTIERRA3.wav")
		self.GenSound.MinDistance=5000
		self.GenSound.MaxDistance=20000
		
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, self.SetTrigger, ())
		


	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		state[1]["SkelHole"]=(self.trsector_name,
						self.Active,
						self.Skelnum,
						self.GenSound.Name,
						self.Name,
						self.EntityKind,
						self.DustFX,
						self.Enabled,
						GameStateAux.SaveFunctionAux(self.ExtDeadFunc),
						self.ExtDeadArgs
						)
		return state
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["SkelHole"]
			self.trsector_name=parms[0]
			self.Active=parms[1]
			self.Skelnum=parms[2]
			self.GenSound= Bladex.GetEntity(parms[3])
			self.Name=parms[4]
			self.EntityKind=parms[5]
			self.DustFX=parms[6]
			self.Enabled=parms[7]
			GameStateAux.LoadFunctionAux(parms[8],self,"ExtDeadFunc")
			self.ExtDeadArgs=parms[9]
			
		else:
			self.trsector_name=""
			self.Active=1
			self.Skelnum=0
			self.GenSound= Bladex.GetEntity(self.Name+"GenSound")
			self.Name=""
			self.EntityKind="Skeleton"
			self.DustFX=1
			self.Enabled=1
			self.ExtDeadFunc=""
			self.ExtDeadArgs=()


	def SetTrigger(self, radius=2000.0, floor_displ=1000.0, roof_displ=2000.0):
		x = Bladex.GetEntity(self.Name).Position[0]
		y = Bladex.GetEntity(self.Name).Position[1]
		z = Bladex.GetEntity(self.Name).Position[2]
		dx=radius/2.0
		dz=radius*((math.sqrt(3.0))/2.0)
		self.trsector_name=self.Name+"_TrSector"
		Bladex.AddTriggerSector(self.trsector_name, "SectoresTriggerSkelHole", y+floor_displ, y-roof_displ, [(x+dx, z+dz), (x-dx, z+dz), (x-radius, z), (x-dx, z-dz), (x+dx, z-dz), (x+radius, z)])
		Bladex.SetTriggerSectorFunc(self.trsector_name, "OnLeave", self.InitSpawnSkel)
		print "Hole Trigger Set"
		

	def InitSpawnSkel(self,sector,entity):
		if not self.Enabled:
			return
		per=Bladex.GetEntity(entity)
		if per.Name=="Player1":
			if per.Life>0:
				if self.Active==1:
					self.Active=0
					print"Try to spawn Skel"
					self.TryToSpawnSkel(self.Name)
				
				
				
	def TryToSpawnSkel(self,EntityName):
		x, y, z = Bladex.GetEntity(EntityName).Position
		ents=Bladex.GetEntitiesAt(x, y, z, 3000)
		for id in ents:
			o = Bladex.GetEntity(id)
			if o.Person:
				if o.Life > 0:
					if o.Alpha >0.01:
						print "Trying to do it, but",id,"is bothering. Next try in 3 seconds."
						Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, self.TryToSpawnSkel,(self.Name,))
						return
		self.CreateSkel(EntityName)
		print"All clear -> create SKEL"
		
		
		
	def SkelIsDead(self, skl_name):
		skl = Bladex.GetEntity(skl_name)
		skl.Data.OldImDeadFunc(skl_name)
		if self.ExtDeadFunc:
			apply(self.ExtDeadFunc, self.ExtDeadArgs)
		

					
	def CreateSkel(self,EntityName):
		print "start spawn Imp"
		x, y, z = Bladex.GetEntity(EntityName).Position
		char= Bladex.GetEntity("Player1")
		lvl=char.Level
		self.Skelnum = self.Skelnum +1
		if not self.EntityKind:
			return
		if self.EntityKind not in ("Skeleton", "Lich", "Knight_Zombie","Ghoul_A"):
			return
		
		skl=Bladex.CreateEntity(self.Name+"GenSkel"+`self.Skelnum`,self.EntityKind, x, y+1100, z,"Person")
		if skl.Kind=="SkeletonDRTP":
			skl.Data=SkeletonDRTPTypes.SkeletonDRTP(skl)
			print "Spawned TP skel getting data"
		elif skl.Kind=="Skelette_A":
			skl.Data=SkeletonDRTPTypes.SkeletonDRTP(skl)
			meshnames=("Skelette_A","Skelette_B","Skelette_C","Skelette_D","Skelette_E","Skelette_F","Skelette_G","Skelette_H","Skelette_I")
			randnum=whrandom.randint(0,len(meshnames))
			print "random skelette mesh is ",randnum
			skl.SetMesh(meshnames[randnum-1])
		elif skl.Kind=="Zomby":
			skl.Data=ZombyTypes.Zomby(skl)
			meshnames=("Momie","Zomby","Zomby_A","Zomby_B","Zomby_C","Zomby_D","Zomby_E","Zomby_F")
			randnum=whrandom.randint(0,len(meshnames))
			print "random zomby mesh is ",randnum
			skl.SetMesh(meshnames[randnum-1])
		elif skl.Kind=="Ghoul_A":
			meshnames=("Ghoul_B","Ghoul_A","Ghoul_C","Ghoul_D")
			randnum=whrandom.randint(0,len(meshnames))
			skl.SetMesh(meshnames[randnum-1])
			skl.Data=EnemyNPCTypes.Ghoul(skl)
			
		else:
			EnemyTypes.EnemyDefaultFuncs(skl)
		skl.Data.OldImDeadFunc=skl.ImDeadFunc
		skl.ImDeadFunc=self.SkelIsDead
		skl.Angle=0.0
		skl.Level=lvl
		skl.Blind=1
		skl.Deaf=1
		skl.Freeze()
		
		skl.SendTriggerSectorMsgs=1
		skl.Life=CharStats.GetCharMaxLife(skl.Kind,skl.Level)
		if self.EntityKind=="SkeletonDRTP":
			rwp=Bladex.CreateEntity(skl.Name+"WP","ProSklScythe1",0,0,0,"Weapon")
			
			if lvl>=19:
				damfact=1000
				defact=-120
			else:
				damfact=SklScytheHit[skl.Level]
				defact=SklScytheDef[skl.Level]
			
			Reference.EntitiesObjectData[rwp.Name]=[Reference.OBJ_WEAPON, damfact , defact, 2.0,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
		else:
			if self.EntityKind=="Ghoul_A":
				rwp=""
				Reference.EntitiesObjectData[skl.Name]=Reference.DefaultObjectData[skl.Kind]
				power=lvl+4
				Reference.EntitiesObjectData[skl.Name][1]=power
				
				
			else:
				WEAPONTYPE=Weps[skl.Level]
				rwp=Bladex.CreateEntity(skl.Name+"WP",WEAPONTYPE,0,0,0,"Weapon")
		if rwp:
			Actions.TakeObject(skl.Name,rwp.Name)
		darfuncs.HideBadGuy(skl.Name)
		self.SpawnSkel(EntityName,skl.Name)
		
		
		
	def SpawnSkel(self,EntityName,SkelName):
		x, y, z = Bladex.GetEntity(EntityName).Position
		char= Bladex.GetEntity("Player1")
		skl=Bladex.GetEntity(SkelName)
		
		pos=skl.Position
		if self.DustFX:
			v=char.Position[0]-pos[0], 0.0, char.Position[2]-pos[2]
			v=B3DLib.Normalize(v)
			v1=v[0]*500.0, 0.0, v[2]*500.0
			v2=v1[0]*math.cos(1.7453)-v1[2]*math.sin(1.7453), 0.0, v1[0]*math.sin(1.7453)+v1[2]*math.cos(1.7453)
			v3=v2[0]*math.cos(2.7925)-v2[2]*math.sin(2.7925), 0.0, v2[0]*math.sin(2.7925)+v2[2]*math.cos(2.7925)
			saltatie=Bladex.CreateEntity("TierraSaltando", "Entity Particle System D1", pos[0], pos[1]-1200.0, pos[2])
			saltatie.ParticleType="Tierra3"
			saltatie.PPS=1024
			saltatie.YGravity=4900.0
			saltatie.Friction=0.05
			saltatie.Velocity=0.0, -600.0, 0.0
			saltatie.RandomVelocity=50.0
			saltatie.Time2Live=60
			saltatie.DeathTime=Bladex.GetTime()+10.0/60.0
			saltati2=Bladex.CreateEntity("TierraSaltando2", "Entity Particle System D1", pos[0], pos[1]-1200.0, pos[2])
			saltati2.ParticleType="Tierra2"
			saltati2.PPS=128
			saltati2.YGravity=200.0
			saltati2.Friction=0.1
			saltati2.Velocity=0.0, -300.0, 0.0
			saltati2.RandomVelocity=15.0
			saltati2.Time2Live=32
			saltati2.DeathTime=Bladex.GetTime()+10.0/60.0
			Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, self.RemueveTierra, (pos, v1, v2, v3,))
			self.GenSound.Position=x, y, z
			self.GenSound.PlaySound(0)
		skl.Blind=1
		skl.Deaf=1
		
		darfuncs.UnhideBadGuy(skl.Name)
		skl.SetTmpAnmFlags(1,1,1,0,5,1,0)
		skl.LaunchAnimation("Skl_appears1")
		
		#skl.AnmEndedFunc=self.Despierta # this don't work ???
		#skl.Wuea= Reference.WUEA_ENDED
		#skl.LaunchAnmType("appears1")
		
		
		alfa=B3DLib.GetEntity2EntityAngle(skl.Name, "Player1")
		skl.Angle=alfa
		darfuncs.CreateFalseCube(skl.Position,-1.0,skl.Name)
		anmtime=Bladex.GetAnimationDuration("Skl_appears1")
		Bladex.AddScheduledFunc(Bladex.GetTime()+anmtime,self.Despierta,(SkelName,))
		
				

	
	def RemueveTierra(self, pos, v1, v2, v3):
		tierra=Bladex.CreateEntity("TierraRemoviendose", "Entity Particle System D3", pos[0]+v1[0], pos[1]-1200.0, pos[2]+v1[2])
		tierra.D1=v2[0]-v1[0], 0.0, v2[2]-v1[2]
		tierra.D2=v3[0]-v1[0], 0.0, v3[2]-v1[2]
		tierra.ParticleType="Tierra2"
		tierra.PPS=64
		tierra.YGravity=200.0
		tierra.Friction=0.1
		tierra.Velocity=0.0, -400.0, 0.0
		tierra.RandomVelocity=15.0
		tierra.Time2Live=64
		tierra.DeathTime=Bladex.GetTime()+2.0	
				
				
	def Despierta(self,SkelName):
		print "Despierta"
		o = Bladex.GetEntity(SkelName + "quad")
		if o:
			o.SubscribeToList("Pin")
		skl=Bladex.GetEntity(SkelName)
		skl.SetOnFloor()
		Bladex.AddScheduledFunc(Bladex.GetTime()+180.0, self.RemoveMe,(skl.Name,))
				
				
	def RemoveMe(self,SkelName):
		self.Active=1
		skl = Bladex.GetEntity(SkelName)
		if skl:
			if skl.Life>0:
				skl.Life=0
		else:
			print "Skel already killed"


		
def CreateSkelHole(name, pos, visible=1, dustfx=1, EntityKind="Skeleton", scale=1.2):
	offset=1000   # Knight hight
	hole=Bladex.CreateEntity(name,"ProGeyser1",pos[0],pos[1]+offset,pos[2])
	hole.Scale=scale
	hole.Orientation=(0.707,0.707,0.0,0.0)
	if not visible:
		hole.Alpha=0
		hole.CastShadows=0
	hole.Data=SkelHole(hole, EntityKind)
	if dustfx:
		hole.Data.DustFX=1
	else:
		hole.Data.DustFX=0
	return hole	
	
	
