import Bladex
import Enm_Def
import Reference
import AllyCombat
import AniSound
import BCopy
import math
import whrandom
import Actions
import CharStats
import ItemTypes
import AuxFuncs
import InitDataField
import B3DLib
import Damage
import darfuncs
import Ally_Def
import EnemyTypes
import Basic_Funcs
import GameStateAux
import GenFX
import ScorerActions
import os
import pocimac

import PlayerTypes
import AniSoundAmzB




TRUE = 1==1
FALSE = not TRUE


W_FLAG_1H=0     #One handed _whatever_ weapon
W_FLAG_2W=1	#Two handed sword
W_FLAG_AXE=2	#Two handed axe
W_FLAG_SP=3     #Two handed spear


PI = math.pi
TWOPI = PI*2

CHOOSE_FIRST  = -1
CHOOSE_SECOND =  1
CHOOSE_EITHER =  0

ROUTE_WATCH=0  #Watch mode
ROUTE_BAY=1    #Performing a bay route
ROUTE_CHASE=2  #Chase a character
ROUTE_SINGLE=3 #Following a single route (going to just a point)
ROUTE_BOWING=4 #Bowing (OR trying to bow) an enemy


ATK_UNIQUE=0
ATK_RANDOM=1
ATK_SEQUENTIAL=2


def AmIRelaxing(entity):
	per=Bladex.GetEntity(entity)
	if per.AnimName[:3] == "rlx" or per.AnimName[:3] == "Rlx":
		return 1
	return 0
	
	

	
	
def CheckIfAlly (EntityName):
	me=Bladex.GetEntity(EntityName)
	if me:				
		try:
	           enemyName=me.Data.EnemyName
	           return FALSE                  # returns TRUE for enemies of Player
	        except AttributeError:  
	 	   return TRUE
	 	   
	 	   
	 	   
def UsePotion (EntityName):
	import pocimac
	me=Bladex.GetEntity(EntityName)	
	if me and me.Life >0:
		inv = me.GetInventory()
		for x in range (inv.nObjects):
			item_name = inv.GetObject(x)
			item = Bladex.GetEntity(item_name)
			if item.Data and item.Data.__class__==pocimac.Pocima:
				max_life= CharStats.GetCharMaxLife(me.Kind, me.Level)
				if (me.Life <= max_life/4.0) or (item.Data.Increment and me.Life+item.Data.Increment<=max_life or me.Data.Poisoned):
					# we have found a potion, I hope its the life giving one...
					me.Data.obj_used=item
					item.Data.UsedBy = EntityName
					item.UseFunc(item_name, Actions.USE_FROM_INV)
					return 1
	return 0
	


UnarmedDamage=[1,3,6,10,16,22,30,40,50,60,75,95,120,150,180,240,300,360,450,600]   
	 	   
	 	      
def GetUnarmedDamage(EntityName):
	me=Bladex.GetEntity(EntityName)
	global UnarmedDamage
	lvl=me.Level
	if lvl>=19:
		return UnarmedDamage[19]
	else:
		return UnarmedDamage[lvl]
		
			
	
def GiveWeaponType(entity):
	per=Bladex.GetEntity(entity)
	inv = per.GetInventory()
	rwp=per.InvRight
	if rwp:
		wpflag=Reference.GiveObjectFlag(rwp)
		if wpflag==Reference.OBJ_STANDARD:
			return W_FLAG_1H
	for x in range(inv.nWeapons):
		weapon_name = inv.GetWeapon(x)
		wp = Bladex.GetEntity(weapon_name)
		if wp:
			if Reference.EntitiesObjectData.has_key(weapon_name):
				object_data = Reference.EntitiesObjectData[weapon_name]
			else:
				object_data = Reference.DefaultObjectData[wp.Kind]
			
			if not object_data[0]==Reference.OBJ_BOW:
				return object_data[5][0]
				break
		else:
			return None
			
			

def DumpMe(entity):
	per=Bladex.GetEntity(entity)		
	per.Position=0,30000,0
		
def RemoveMyCorpse(PersonName, dx, dz):
	me = Bladex.GetEntity(PersonName)
	me.Alpha=1.00
	me.RasterMode="Read"
	me.CastShadows=0
	AuxFuncs.FadeObject(PersonName, 1.00, 0.0, 4.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, me.SubscribeToList,("Pin",))
	
	
def RemoveMyWeapon(WeaponName):
	wp = Bladex.GetEntity(WeaponName)
	wp.Alpha=1.00
	wp.RasterMode="Read"
	wp.CastShadows=0
	AuxFuncs.FadeObject(WeaponName, 1.00, 0.0, 4.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, DumpMe,(wp.Name,))





Bladex.AddParticleGType("NPCLevelUpParticle","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>25:
		traux=(30.0-i)/5.0 
		aux=traux**0.5
	else:
		traux=i/25.0 
		aux=traux**2.0
	r=255
	g=255
	b=255
	a=255.0*traux
	size=200.0*aux
	Bladex.SetParticleGVal("NPCLevelUpParticle",i,r,g,b,a,size)
	
	
def LoadXtraAnims():
	Bladex.LoadSampledAnimation("..\\..\\Anm\\Tkn_fury.BMV","Fury",1,"Dwarf_N")
	Bladex.AddBipedAction("Dwarf_N","Fury","Tkn_fury",0.0,1.0,0)

	Bladex.LoadSampledAnimation("..\\..\\Anm\\Tkn_fury.BMV","Fury",1,"Barbarian_N")
	Bladex.AddBipedAction("Barbarian_N","Fury","Tkn_fury",0.0,1.0,0)

	Bladex.LoadSampledAnimation("..\\..\\Anm\\Tkn_fury.BMV","Fury",1,"Knight_N")
	Bladex.AddBipedAction("Knight_N","Fury","Tkn_fury",0.0,1.0,0)

	Bladex.LoadSampledAnimation("..\\..\\Anm\\Tkn_fury.BMV","Fury",1,"Amazon_B")
	Bladex.AddBipedAction("Amazon_B","Fury","Tkn_fury",0.0,1.0,0)

	Bladex.LoadSampledAnimation("..\\..\\Anm\\Tkn_fury.BMV","Fury",1,"IrDwarf_N")
	Bladex.AddBipedAction("IrDwarf_N","Fury","Tkn_fury",0.0,1.0,0)
	
	
	
	
	
###########################################################################################################################################################


	
	
def TakeNewArmour(EntityName, ArmourMesh):
	per=Bladex.GetEntity(EntityName)
	if per.MeshName==ArmourMesh:
		print EntityName+" has already got mesh "+ArmourMesh
		return
	# Possible for Barb/Amz to have weapon in LEFT hand at the moment they level up and this gets relinked to left hand.....
	if Actions.StatR == Actions.RA_NO_WEAPON:
		Bladex.AddScheduledFunc(Bladex.GetTime()+ 0.3,TakeNewArmour,(EntityName, ArmourMesh,))
		print EntityName+" is not holding wep in RH. Try armour again in 0.3 secs"
	else:
		right= per.InvRight
		left= per.InvLeft
		rightback= per.InvRightBack
		leftback= per.InvLeftBack

		inv= per.GetInventory()
		inv.LinkRightHand ("")
		inv.LinkLeftHand ("")
		inv.LinkBack("")

		per.Data.UnlinkAll (EntityName, "")  # Dettatch arrows
		if ArmourMesh:
			per.SetMesh(ArmourMesh)
			print EntityName+" should have taken "+ArmourMesh
		if rightback:
			inv.LinkRightHand (rightback)
			inv.LinkRightBack(rightback)
		if leftback:
			inv.LinkLeftHand (leftback)
			inv.LinkLeftBack(leftback)
		if right:
			inv.LinkRightHand (right)
		if left:
			inv.LinkLeftHand (left)
		print EntityName+" has finished taking mesh "+ArmourMesh
	

def GetArmourType(EntityName):
	per=Bladex.GetEntity(EntityName)
	lvl=per.Level
	kind=per.Kind
	mesh=per.MeshName
	if mesh[3:7]=="Skin":
		per.Data.armour_prot_factor=50
		print EntityName+" No armour mesh - increase protection"
		return None
	print EntityName+" Earned New Armour"
	if lvl>3 and lvl<=8:
		if kind=="Amazon_N":
			per.Data.armour_prot_factor=25
			return "Amazon_L"
		elif kind=="Dwarf_N":
			per.Data.armour_prot_factor=15
			return "Dwarf_L"
		elif kind=="Barbarian_N":
			per.Data.armour_prot_factor=25
			return "Barbarian_L"
		elif kind=="Knight_N":
			per.Data.armour_prot_factor=15
			return "Knight_L"
		elif kind=="Valkyrie_A":
			per.Data.ProtectionLevel=2
			if mesh=="Valkyrie_C":
				return "Valkyrie_D"
			else:
				return "Valkyrie_B"
		elif kind=="ProAribeth_A":
			per.Data.armour_prot_factor=25
			return None
	elif lvl>8 and lvl<=13:
		if kind=="Amazon_N":
			return None
		elif kind=="Dwarf_N":
			per.Data.armour_prot_factor=35
			return "Dwarf_M"
		elif kind=="Barbarian_N":
			return None
		elif kind=="Knight_N":
			per.Data.armour_prot_factor=40
			return "Knight_M"
		elif kind=="Valkyrie_A":
			return None
		elif kind=="ProAribeth_A":
			per.Data.armour_prot_factor=40
			return None
	elif lvl>13:
		if kind=="Amazon_N":
			return None
		elif kind=="Dwarf_N":
			return None
		elif kind=="Barbarian_N":
			return None
		elif kind=="Knight_N":
			per.Data.armour_prot_factor=80
			return "Knight_F"
		elif kind=="Valkyrie_A":
			return None
		elif kind=="ProAribeth_A":
			per.Data.armour_prot_factor=80
			return None
	return None




###########################################################################################################################################################

TakeNoPlayerDamage=1

def AllyDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded):
	if AttackerName:
		attacker=Bladex.GetEntity(AttackerName)
		if attacker and attacker.Person: 
			if AttackerName == "Player1" and TakeNoPlayerDamage:
				return
			if not CheckIfAlly(AttackerName):
				return
		if AttackerName=="Player1" and WeaponName:
			if WeaponName[:6]=="Entity":
				return
			wp=Bladex.GetEntity(WeaponName)
			try:
				weaponData = Reference.DefaultObjectData[wp.Kind]
			except KeyError:
				weaponData = Reference.EntitiesObjectData[WeaponName]
				
			if weaponData and len (weaponData) > 6:
				for special in weaponData[6:]:
					if special[0]=="Venom":
						print "I have been poisoned by Player1 but I am Immune"
						return	
	Damage.CalculateDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded)
	


	
	
	
###########################################################################################################################################################
########################   Levelup Functions ##############################################################################################################
AllyWeps={} 
AllyWeps["Enano1"]=["Hacha","Maza","Hacha5","Espadaromana","Orksword","Garropin","Hacha4Pro","Hacha3","Maza2","Martillo","HookSword","EgyptSword","Espadacurva","Martillo2","Garrote2","MazaDoble","Cimitarra","Hacha6","Hacha2","Martillo3"]
AllyWeps["Enano7"]=["Hacha","Maza","Hacha5","Espadaromana","Orksword","Garropin","Hacha4Pro","Hacha3","Maza2","Martillo","HookSword","EgyptSword","Espadacurva","Martillo2","Garrote2","MazaDoble","Cimitarra","Hacha6","Hacha2","Martillo3"]
AllyWeps["Dwarf_N"]=["Hacha","Maza","Hacha5","Espadaromana","Orksword","Garropin","Hacha4Pro","Hacha3","Maza2","Martillo","HookSword","Espadacurva","Martillo2","Dagesse","Garrote2","Cimitarra","MazaDoble","Hacha6","Hacha2","Martillo3"]
AllyWeps["Knight_N"]=["Gladius","Gladius","Maza","Orksword","Espadaromana","Espadaelfica","Espadaelfica","Maza2","HookSword","LightEdge","Espadacurva","EgyptSword","Dagesse","Cimitarra","Katana","Maza3","DoubleSword","Espadafilo","Espada"]
AllyWeps["Amazon_N"]=["Bo","Bichero","Lanza","IceWand","Naginata","FireBo","Naginata","SteelFeather","Tridente","Axpear","Axpear","DeathBo","Crosspear","Crosspear","Hachacuchilla","CrushBo","Arpon","Naginata2","LanzaAncha","LanzaAncha"]
AllyWeps["Barbarian_N"]=["Chaosword","Chaosword","Eclipse","DeathSword","DeathSword","IceAxe","FireBigSword","Guadanya","Alfanje","LongSword","LongSword","Hacha2hojas","FlatSword","BigSword","BigSword","RhinoClub","RhinoClub","Hacharrajada","SawSword","SawSword"]
AllyWeps["Wilf_A"]=["Hacha","Maza","Hacha5","Espadaromana","Orksword","Hacha4Pro","Espadaelfica","Hacha3","Maza2","Martillo","HookSword","Martillo2","Espadacurva","EgyptSword","Garrote2","Cimitarra","MazaDoble","Hacha6","Hacha2","Martillo3"]
AllyShields=["Escudo5","Escudo5","Escudo2","Escudo2","Escudo1","Escudo1","Escudo1","KingShield","KingShield","KingShield","Escudo8","Escudo8","Escudo9","Escudo9","Escudo3","Escudo4","Escudo4","Escudo7","Escudo6","Escudo6"]




# Keyed to MeshName not Kind....
AllySheildholders=["Enano1","Enano2","Enano3","Enano4","Enano7","Enano7_B","Dwarf_N","Dwarf_L","Dwarf_M","Knight_N","Knight_M","Knight_F","Militia_A","Wilf_A","Amazon_B"]



AmazonSwordHit=[5,8,15,25,35,50,65,85,100,120,150,190,240,300,380,460,550,650,820,950]
AmazonSwordDef=[0,-3, -5, -10, -15, -20, -25,-30, -35, -40, -45, -50, -55, -60, -65, -70,-75, -80,-85]



def AribethLevelUpFunc(EntityName):
	print EntityName+" I have leveled up"
	PlayerTypes.CheckHighestLevel(EntityName)
	armourmesh=GetArmourType(EntityName)
	if armourmesh:
		TakeNewArmour(EntityName,armourmesh)
	global FemArcherSwordHit
	global AmazonSwordDef
	per=Bladex.GetEntity(EntityName)
	charlvl=per.Level
	realvl=charlvl+3
	extradam=realvl*3
	if per.Life>0:
		lvl=per.Level
		inv=per.GetInventory()
		if lvl>19:
			NEWDAMAGE=1200
			NEWDEFENSE=-120
		else:
			NEWDAMAGE=FemArcherSwordHit[lvl]
			NEWDEFENSE=AmazonSwordDef[lvl]
		if GiveWeaponType(EntityName)== W_FLAG_2W:
			rwp=Bladex.GetEntity(per.InvRight)
			if rwp:
				Reference.EntitiesObjectData[rwp.Name]= [Reference.OBJ_WEAPON,5, -10, 4.0,  Reference.THR_SPINNING, [Reference.W_FLAG_2W,Reference.PI,2000,750,14000,140000,Reference.GolpeArmaEscudoMetal]]
				Reference.EntitiesObjectData[rwp.Name][1]= NEWDAMAGE
				Reference.EntitiesObjectData[rwp.Name][2]= NEWDEFENSE
				Reference.EntitiesObjectData[rwp.Name].append(['Electric',+extradam])
				print EntityName+" My Sword is upgraded"
		
	
	
def BarbarianLevelUpFunc(EntityName):
	print EntityName+" I have leveled up"
	PlayerTypes.CheckHighestLevel(EntityName)
	armourmesh=GetArmourType(EntityName)
	if armourmesh:
		TakeNewArmour(EntityName,armourmesh)
		print EntityName+" got new armour"
	global AmazonSwordHit
	global AmazonSwordDef
	per=Bladex.GetEntity(EntityName)
	charlvl=per.Level
	realvl=charlvl+2
	extradam=realvl*2
	if per.Life>0:
		lvl=per.Level
		inv=per.GetInventory()
		if lvl>19:
			NEWDAMAGE=1000
			NEWDEFENSE=-120
		else:
			NEWDAMAGE=AmazonSwordHit[lvl]
			NEWDEFENSE=AmazonSwordDef[lvl]
		flag=GiveWeaponType(EntityName)
		rwp=Bladex.GetEntity(per.InvRight)
		if rwp:
			if flag == W_FLAG_2W:
				Reference.EntitiesObjectData[rwp.Name]= [Reference.OBJ_WEAPON,5, -10, 4.0,  Reference.THR_SPINNING, [Reference.W_FLAG_2W,Reference.PI,2000,750,14000,140000,Reference.GolpeArmaEscudoMetal]]
				Reference.EntitiesObjectData[rwp.Name][1]= NEWDAMAGE
				Reference.EntitiesObjectData[rwp.Name][2]= NEWDEFENSE
				Reference.EntitiesObjectData[rwp.Name].append(['Electric',+extradam])
				print EntityName+" My Sword is upgraded"
			if flag == W_FLAG_AXE:
				Reference.EntitiesObjectData[rwp.Name]= [Reference.OBJ_WEAPON,5, -10, 4.0,  Reference.THR_SPINNING, [Reference.W_FLAG_AXE,Reference.PI,2000,750,14000,140000,Reference.GolpeArmaEscudoMetal]]
				Reference.EntitiesObjectData[rwp.Name][1]= NEWDAMAGE
				Reference.EntitiesObjectData[rwp.Name][2]= NEWDEFENSE
				Reference.EntitiesObjectData[rwp.Name].append(['Electric',+extradam])
				print EntityName+" My Axe is upgraded"
	
	
	
def ValkyrieLevelUpFunc(EntityName):
	print EntityName+" I have leveled up"
	PlayerTypes.CheckHighestLevel(EntityName)
	armourmesh=GetArmourType(EntityName)
	if armourmesh:
		TakeNewArmour(EntityName,armourmesh)
	global AmazonSwordHit
	global AmazonSwordDef
	per=Bladex.GetEntity(EntityName)
	charlvl=per.Level
	realvl=charlvl+2
	extradam=realvl*2
	if per.Life>0:
		lvl=per.Level
		inv=per.GetInventory()
		if lvl>19:
			NEWDAMAGE=1000
			NEWDEFENSE=-120
		else:
			NEWDAMAGE=AmazonSwordHit[lvl]
			NEWDEFENSE=AmazonSwordDef[lvl]
		#rwp=Bladex.GetEntity(EntityName+"WP")
		rwp=Bladex.GetEntity(per.InvRight)
		if rwp:
			if GiveWeaponType(EntityName)== W_FLAG_2W:
				Reference.EntitiesObjectData[rwp.Name]= [Reference.OBJ_WEAPON,5, -10, 4.0,  Reference.THR_SPINNING, [Reference.W_FLAG_2W,Reference.PI,2000,750,14000,140000,Reference.GolpeArmaEscudoMetal]]
				print EntityName+" My Sword is upgraded"
			if GiveWeaponType(EntityName)== W_FLAG_SP:
				print EntityName+" My SPear is upgraded"
				Reference.EntitiesObjectData[rwp.Name]= [Reference.OBJ_WEAPON,5, -10, 4.0,  Reference.THR_SPINNING, [Reference.W_FLAG_SP,Reference.PI,2000,750,14000,140000,Reference.GolpeArmaEscudoMetal]]
			if GiveWeaponType(EntityName)== W_FLAG_1H:
				print EntityName+" My 1H sword is upgraded"
				Reference.EntitiesObjectData[rwp.Name]= [Reference.OBJ_WEAPON,5, -10, 4.0,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
				sh=Bladex.GetEntity(per.InvLeft)
				# only get a new shield if you have broken the old one
				if not sh: 
					newshd=None
					if per.Kind in AllySheildholders:
						if lvl>19:
							NEWSHTYPE=AllyShields[19]
						else:
							NEWSHTYPE=AllyShields[lvl]
						newsh=Bladex.CreateEntity(EntityName+"_Shield_Level"+`lvl`,NEWSHTYPE,0,40000,0,"Weapon")
						ItemTypes.ItemDefaultFuncs(newsh)
						if newshd:
							inv.AddShield(newsh.Name)
							Bladex.AddScheduledFunc(Bladex.GetTime()+ 2.5, GetNewShield, (EntityName,newsh.Name,))
			Reference.EntitiesObjectData[rwp.Name][1]= NEWDAMAGE
			Reference.EntitiesObjectData[rwp.Name][2]= NEWDEFENSE
			Reference.EntitiesObjectData[rwp.Name].append(['Electric',+extradam])
			print EntityName+": My Weapon is upgraded "
		



def AllyLevelUpFunc(EntityName):
	print EntityName+" I have leveled up"
	global Weps
	global AllyShields
	global AllySheildholders
	per=Bladex.GetEntity(EntityName)
	charlvl=per.Level
	realvl=charlvl*2
	extradam=realvl
	if per.Kind=="Militia_A":
		print EntityName+" WHY AM I CALLING THIS FUNCTION?"
		return
	if per.Life>0:
		lvl=per.Level
		inv=per.GetInventory()
		if lvl>19:
			NEWWPTYPE=AllyWeps[per.Kind][19]
		else:
			NEWWPTYPE=AllyWeps[per.Kind][lvl]
		newwp=Bladex.CreateEntity(EntityName+"_Weapon_Level"+`lvl`,NEWWPTYPE,0,40000,0,"Weapon")
		ItemTypes.ItemDefaultFuncs(newwp)
		flag=Reference.GiveWeaponFlag(newwp.Name)
		per.Data.RegisterObjectAsTaken(newwp.Name)
		inv.AddWeapon(newwp.Name,flag)
		if per.Kind in ("Knight_N","Dwarf_N"):
			Reference.EntitiesObjectData[newwp.Name]=Reference.DefaultObjectData[newwp.Kind]
			Reference.EntitiesObjectData[newwp.Name].append(['Electric',+extradam])
			
		Bladex.AddScheduledFunc(Bladex.GetTime()+ 1.5, GetNewWeapon, (EntityName,newwp.Name,))
		sh=Bladex.GetEntity(per.InvLeft)
		# only get a new shield if you have broken the old one
		if not sh: 
			newshd=None
			if per.MeshName in AllySheildholders:
				if lvl>19:
					NEWSHTYPE=AllyShields[19]
				else:
					NEWSHTYPE=AllyShields[lvl]
				newsh=Bladex.CreateEntity(EntityName+"_Shield_Level"+`lvl`,NEWSHTYPE,0,40000,0,"Weapon")
				ItemTypes.ItemDefaultFuncs(newsh)
				inv.AddShield(newsh.Name)
			else: 
				if per.MeshName=="Wilf_A":
					newsh=Bladex.CreateEntity(EntityName+"_Shield_Level"+`lvl`,Escudo7,0,40000,0,"Weapon")
					ItemTypes.ItemDefaultFuncs(newsh)
					inv.AddShield(newsh.Name)
			if not newshd:
				return
			Bladex.AddScheduledFunc(Bladex.GetTime()+ 2.5, GetNewShield, (EntityName,newsh.Name,))
			
			
Wepdamages={}
Wepdamages["Default"]=    [3,6,12,18,25,35,48,60,70,75,85,95 ,120,145,180,220,280,350,400,520]
Wepdamages["Amazon_N"]=   [3,8,14,20,30,40,50,60,70,75,85,95 ,120,150,175,210,290,350,400,500]
Wepdamages["Barbarian_N"]=[5,8,16,24,30,40,50,60,70,75,90,110,140,165,200,260,320,360,450,600]
Wepdamages["Knight_N"]=   [3,6,12,18,25,35,48,60,70,75,85,95 ,120,145,180,220,280,350,400,520]
Wepdamages["Dwarf_N"]=    [3,8,14,18,25,30,40,55,70,75,90,110,140,160,190,220,250,320,420,550]
Wepdamages["Valkyrie_A"]= [4,6,10,16,24,32,45,55,65,72,80,95,120,135,160,200,280,340,400,500]
Wepdamages["Nasher_A"]=   [4,6,10,18,25,35,45,55,65,75,90,110,140,165,200,260,320,360,450,600]
Wepdamages["Enano7"]=     [5,9,17,22,30,40,50,65,80,95,100,130,160,200,250,320,450,560,720,850]


Wepdef={}
Wepdef["Default"]=   [0,-5,-10,-15,-20,-25,-30,-35,-40,-45,-50,-55,-60,-65,-70,-75,-80,-85,-90]
Wepdef["Amazon_N"]=   [0,-5,-10,-15,-20,-25,-30,-35,-40,-45,-50,-55,-60,-65,-70,-75,-80,-85,-90]
Wepdef["Barbarian_N"]=[0,-5,-10,-15,-20,-25,-30,-35,-40,-45,-50,-55,-60,-65,-70,-75,-80,-85,-90]
Wepdef["Knight_N"]=   [0,-5,-10,-15,-20,-25,-30,-35,-40,-45,-50,-55,-60,-65,-70,-75,-80,-85,-90]
Wepdef["Dwarf_N"]=    [0,-5,-10,-15,-20,-25,-30,-35,-40,-45,-50,-55,-60,-65,-70,-75,-80,-85,-90]
Wepdef["Valkyrie_A"]= [0,-5,-10,-15,-20,-25,-30,-35,-40,-45,-50,-55,-60,-65,-70,-75,-80,-85,-90]
Wepdef["Nasher_A"]=   [0,-5,-10,-15,-20,-25,-30,-35,-40,-45,-50,-55,-60,-65,-70,-75,-80,-85,-90]



def Sargon_Naglfar_LevelUpFunc(EntityName):
	print EntityName+" I have leveled up"
	armourmesh=GetArmourType(EntityName)
	if armourmesh:
		TakeNewArmour(EntityName,armourmesh)
	global AllyShields
	global AllySheildholders
	per=Bladex.GetEntity(EntityName)
	lvl=per.Level
	global Wepdamages
	global Wepdef
	inv = per.GetInventory()
	race=per.Kind
	realvl=lvl+2
	extradam=realvl
	if lvl>19:
		damagefactor=600
		defensefactor=-120
	else:
		if Wepdamages.has_key(race):
			damages=Wepdamages[race]
		else:
			damages=Wepdamages["Default"]
		damagefactor=damages[lvl]
		if Wepdef.has_key(race):
			defenses=Wepdef[race]
		else:
			defenses=Wepdef["Default"]
		defensefactor=defenses[lvl]
	rwp=Bladex.GetEntity(per.InvRight)
	if rwp:
		Reference.EntitiesObjectData[rwp.Name]=Reference.DefaultObjectData[rwp.Kind]
		Reference.EntitiesObjectData[rwp.Name][1]=damagefactor
		Reference.EntitiesObjectData[rwp.Name][2]=defensefactor
		Reference.EntitiesObjectData[rwp.Name].append(['Electric',+extradam])
		print "Knight_Dwarf  Weapon Upgraded"
	sh=Bladex.GetEntity(per.InvLeft)
	# only get a new shield if you have broken the old one
	if not sh: 
		if per.MeshName in AllySheildholders:
			if lvl>19:
				NEWSHTYPE=AllyShields[19]
			else:
				NEWSHTYPE=AllyShields[lvl]
			newsh=Bladex.CreateEntity(EntityName+"_Shield_Level_"+`lvl`,NEWSHTYPE,0,40000,0,"Weapon")
			ItemTypes.ItemDefaultFuncs(newsh)
			inv.AddShield(newsh.Name)
			Bladex.AddScheduledFunc(Bladex.GetTime()+ 2.5, GetNewShield, (EntityName,newsh.Name,))
			
			
			
			
					
			
def  GetNewShield(EntityName,ShieldName):
	per=Bladex.GetEntity(EntityName)
	inv=per.GetInventory()
	nshd=Bladex.GetEntity(ShieldName)
	if inv.HoldingBow:
		# If you shot something, tough luck. No new shield
		return
	per.Wuea=Reference.WUEA_ENDED	
	per.InterruptCombat()	
	per.LaunchAnmType("Chg_l")
	inv.LinkLeftHand(ShieldName)
	per.SetOnFloor()


def  GetNewWeapon(EntityName,WeaponName):
	per=Bladex.GetEntity(EntityName)
	inv=per.GetInventory()
	nwep=Bladex.GetEntity(WeaponName)
	owep=Bladex.GetEntity(per.InvRight)
	if inv.HoldingBow:
		# If you shot something, tough luck. No new weapon
		return
	if owep:
		per.Wuea=Reference.WUEA_ENDED	
		per.InterruptCombat()	
		per.LaunchAnmType("Chg_r_l")
		inv.LinkRightHand("")
		inv.RemoveWeapon(owep.Name)
		owep.Position=0,30000,0
		inv.LinkRightHand(WeaponName)			
		per.SetOnFloor()
			


WhoKilledTheBoss=""


def RegisterBossKill(entity):
	global WhoKilledTheBoss
	WhoKilledTheBoss=entity


			
###########################################################################################################################################################
########## Base Ally Class  ###############################################################################################################################

class AllyChar (Ally_Def.NPCAlly):

	DeathFunc=None
	DeathArgs=()
	NPCLevelUpParticleData=[]
	LevelupFunc=None
	LevelupArgs=()
	Combatant=1
	Dusted=0
	OnGuard=0
	GuardPoint=50.0,-1000.0,50.0
	GuardLookPoint=0.0,0.0
	Agenum=0
	ThrowingObject=0
	AttackOnSight=1
	
	def __init__(self, me):
		
		Ally_Def.NPCAlly.__init__(self, me)
	
		me.ImDeadFunc=self.NewImDeadFunc
		me.DamageFunc=AllyDamage
		
		self.NPCLevelUpParticleData=[]
		self.Combatant=0
		self.OnGuard=0
		self.GuardPoint=0,0,0
		self.GuardLookPoint=0,0
		self.OnWatch=0
		self.Agenum=0
		self.ThrowingObject=0
		self.AttackOnSight=1
		
		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 
				aux=traux**0.5
			else:
				traux=i/25.0 
				aux=traux**2.0
			r=255
			g=255
			b=255
			a=255.0*traux
			size=200.0*aux
			self.NPCLevelUpParticleData.append(a)
			self.NPCLevelUpParticleData.append(size)
			Bladex.SetParticleGVal("NPCLevelUpParticle",i,r,g,b,a,size)
		
		self.lupsnd1=Bladex.CreateSound("..\\..\\Sounds\\aparicion-escudo.wav", "LUPSnd1")
		self.lupsnd1.Volume=1.0
		self.lupsnd1.MinDistance=10000
		self.lupsnd1.MaxDistance=30000	
		
		self.SetUnarmedDamage()
		
		
		
		
	def ResetCombat (self,EntityName):		
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttackNPCTime = 100
			self.AttacksOwnKind=TRUE
		
		
	def NewImDeadFunc (self,EntityName):
		#print EntityName+": NEW ImDeadFunc"
		me=Bladex.GetEntity(EntityName)
		rwp=Bladex.GetEntity(me.InvRight)
		lwp=Bladex.GetEntity(me.InvLeft)
		try:
			Ally_Def.NPCAlly.StdImDead(self,EntityName)
		except:
			pass
		if self.Dusted:
			Bladex.AddScheduledFunc(Bladex.GetTime()+32,RemoveMyCorpse,(EntityName,100,0,))
			if rwp:
				Reference.EntitiesSelectionData[rwp.Name]=()
				Bladex.AddScheduledFunc(Bladex.GetTime()+35,RemoveMyWeapon,(rwp.Name,))
			if lwp:
				Reference.EntitiesSelectionData[lwp.Name]=()
				Bladex.AddScheduledFunc(Bladex.GetTime()+36,RemoveMyWeapon,(lwp.Name,))
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
		nents= Bladex.nEntities()
		for i in range(nents):
			ent= Bladex.GetEntity(i)
			if (ent.Person):
				if ent.Life>0:
					try:
						if ent.Data.NameOfEnemy==EntityName: 
							ent.ResetChase()
					except:
						pass
						
	
	
	def MutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		if self.Dusted:
			limb= Bladex.GetEntity(obj_name)
			InitDataField.Initialise(limb)
			Bladex.AddScheduledFunc(Bladex.GetTime()+20, RemoveMyWeapon,(obj_name,))
	
	
	
	def StdSeeEnemyUnreachable(self,EntityName,check1aaTo2aa=1):
		#me = Bladex.GetEntity(EntityName)
		pass
		
	
	
	

	def StdChaseFailed(self,EntityName, oldActionMode):	
		me = Bladex.GetEntity(EntityName)
		if self.IsArcher():
			return 
		Ally_Def.NPCAlly.StdChaseFailed(self,EntityName,oldActionMode)
	
	
	def StopAttackingNPC (self,EntityName):
		if self.AttackingNPC:
			me = Bladex.GetEntity(EntityName)
			if me and me.Life>0:
			     	ename=self.MyGetEnemyName()
			     	if ename:
					enemy = Bladex.GetEntity(ename)
					if not enemy:                                        
						#print EntityName+": Cannot access handle to Player, in StopAttackingNPC()"
						Bladex.AddScheduledFunc(Bladex.GetTime() + self.AttackNPCTime, self.StopNPCsAttacking,(EntityName,))
						return
					
						
					#print EntityName+": Stopping attacking "+self.MyGetEnemyName()+" at time: "+`Bladex.GetTime()`
					Damage.DropInvalidObjectsOnImpact (EntityName)
					me.Wuea=Reference.WUEA_ENDED
					me.InterruptCombat()
					if me.SetEnemy(enemy):
						self.AttackingNPC=FALSE
						MaxCombatDist = Bladex.GetCharType(me.CharType,me.CharTypeExt).MaxCombatDist
						if me.SQDistance2(enemy) < (MaxCombatDist*MaxCombatDist) or me.CanISee(enemy):
							me.SetActiveEnemy(enemy)
							me.Chase(enemy, me.ActionAreaMax)
							if me.GetActionMode()==ROUTE_CHASE and self.IsArcher():
								self.Switch2MeleeWeapons(EntityName)
						else:
							me.LaunchWatch()
							Damage.DropInvalidObjectsOnImpact (EntityName)
							me.Wuea=Reference.WUEA_ENDED
							me.LaunchAnmType("attack_look",1)
						self.CheckToJoin (EntityName)
					else:
						#print EntityName+": Cannot SetEnemy to Player, in StopAttackingNPC()"
						Bladex.AddScheduledFunc(Bladex.GetTime() + self.AttackNPCTime, self.StopNPCsAttacking,(EntityName,))
						return


		
	def LookAround90(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		inv=me.GetInventory()
		if inv.HasBow or self.OnGuard:	
			return
		trand= whrandom.randint(1,12)
		tvar=10+trand
		if self.Asleep:
			angle = me.Angle+PI*0.5
			if angle >= TWOPI:
				angle = angle - TWOPI
			me.Face(angle)
			Bladex.AddScheduledFunc(Bladex.GetTime()+ tvar, self.LookAround90,(EntityName,))
		
		
	def GetMyBowOut(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		inv= me.GetInventory()
		life = me.Life
		if life > 0.0:		
			left_type= Reference.GiveObjectFlag(me.InvLeft)
			if left_type != Reference.OBJ_BOW:
				me.SwitchToBow()
				if inv.GetSelectedWeapon() != me.InvRight and inv.GetSelectedWeapon() != me.InvLeft:
					# Launch the swap weapons animation
					out= ScorerActions.CB_WeaponOutX(EntityName,0)
					if not out:
						me.AnmEndedFunc= ScorerActions.CB_WeaponOutX
					Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, self.GetMyBowOut,(EntityName,),EntityName+"ReGetMyBowOut")

		
	
		
	def CheckDirection(self, EntityName):
		me=Bladex.GetEntity(self.Name)
		if self.OnGuard and not me.InCombat:
			Actions.TurnToFacePos(EntityName,self.GuardLookPoint[0],self.GuardLookPoint[1])
			self.GetMyBowOut(EntityName)
		#if me.RouteEndedFunc:
		#	me.RouteEndedFunc=None	
		#print "checking I am looking right way ",EntityName
				
	
	
	def AmIAtMyPost(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if self.OnGuard:
			gx,gy,gz=self.GuardPoint
			for pname in Bladex.GetEntitiesAt(gx,gy,gz, 1000):
				ent=Bladex.GetEntity(pname)
				if ent and ent.Person:
					if ent.Life>0:
						if ent.Name==me.Name:
							#print EntityName+": I am already near my post "
							return 1
						else:
							#print EntityName+": I cannot return to post as someone is in the way "
							return 1
			return 0
	
	
	
	def GoBackToPost(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if self.OnGuard and not me.InCombat:
		
			if not self.AmIAtMyPost(EntityName):
				me.GoTo(self.GuardPoint[0],self.GuardPoint[1],self.GuardPoint[2])
				me.RouteEndedFunc=self.CheckDirection
				#print EntityName+": I am returning to my post"
			else:
				self.CheckDirection(EntityName)
		
		
		
		
	def SetGuardPoint(self,lx=0.0,ly=0.0):
		me=Bladex.GetEntity(self.Name)
		x,y,z=me.Position
		self.GuardPoint=x,y,z
		self.GuardLookPoint=lx,ly
		
		
		
	def StdEnemyDead(self,EntityName):
		Ally_Def.NPCAlly.StdEnemyDead(self,EntityName)
		me=Bladex.GetEntity(EntityName)
		#Reference.debugprint(EntityName+": My enemy is really dead.He he ! - py")
		newene= self.CheckForBadGuys()
		if newene and not me.InCombat:
			Actions.TurnToFaceEntity(EntityName, newene)
		else:
			if self.OnGuard:
				Bladex.AddScheduledFunc(Bladex.GetTime()+ 2.5, self.GoBackToPost,(EntityName,))
		

					
	def LookAround(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if me.RouteEndedFunc:
			me.RouteEndedFunc=None
		if me.Life>0:
			if not me.InCombat:
				if self.OnGuard and not self.CheckForBadGuys():
					self.GoBackToPost(EntityName)
					#me.RouteEndedFunc=self.CheckDirection(EntityName)
				else:
					nearene=self.CheckForBadGuys()
					if nearene:
						Actions.TurnToFaceEntity(me.Name,nearene)
						#print "Looking to enemy"
					else:
						Actions.Turn180(me.Name)
					
					
				
	def DoINeedADrink(self,EntityName):
		me=Bladex.GetEntity(EntityName)
		if me.Life>0:
			if not me.InCombat:
				AllyCombat.UsePotion(EntityName)

	
	def OnKilledEnemy(self,KilledEntityName):
		Reference.debugprint ("Ally Char: I have killed something!")
		KilledEntity=Bladex.GetEntity(KilledEntityName)
		if KilledEntity is None:
			return
		if KilledEntity.Name=="Player1":
			Reference.debugprint ("Ally Char: I have killed the Player")
			return
		if KilledEntity.Name=="VMBlackKnight1":
			Reference.debugprint ("Ally Char: I have killed the Black Knight")
			RegisterBossKill(self.Name)
		me=Bladex.GetEntity(self.Name)
		
		Bladex.AddScheduledFunc(Bladex.GetTime()+ 3.5, self.LookAround, (self.Name,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+ 4.5, self.DoINeedADrink,(self.Name,))
		me.PartialLevel=me.PartialLevel+CharStats.GetCharExperienceReward(KilledEntity.CharType,KilledEntity.Level)
		LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
		import Scorer
		if me.PartialLevel>=LevelLimit and me.Life>0:
			while me.PartialLevel>=LevelLimit:
				me.PartialLevel=me.PartialLevel-LevelLimit
				me.Level=me.Level+1
				LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
			maxlevel=CharStats.GetMaxLevel()
			maxsize=50+(140/maxlevel)*me.Level 
			maxPPS=120+(600/maxlevel)*me.Level 
			maxint=0.5+(4.5/maxlevel)*me.Level 
			AuraParams=(5, 0, 1, 0, 0, 1)
			AuraGradient=(2, 0.4, 0.6, 1.0, 0.5, 0.0, 0.1, 0.2, 1.0, 0.0, 0.8)
			AuraVar1Args=(5, maxsize, 0, 1, 0.5)
			AuraVar2Args=(maxsize, 5, 1, 0, 1.0)
			PSParams=(self.NPCLevelUpParticleData, "NPCLevelUpParticle", 30, 50, 150, 255, maxPPS, -600, 0.0, 2, 2, 0.4, 30, 0.5)
			GenFX.LevelUpFX(me.Name, 1, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, maxint, "Timer15", 15)
			if me.Life >0: # If an enemy death by poison or trowed weapons and.. You are death!
				me.ResetWounds()
				if me.Data.Poisoned:
					me.Data.UnVenom()
				me.Life = CharStats.GetCharMaxLife(me.Kind, me.Level)
			self.lupsnd1.Play(me.Position[0],me.Position[1],me.Position[2],0)
			if self.LevelupFunc:
				apply(self.LevelupFunc,self.LevelupArgs)
				me=Bladex.GetEntity(self.Name)
				#print "Applying Level Up Func -> ", me.Name
			self.SetUnarmedDamage()
			self.ResetCombat(self.Name)
				
				
	def SetUnarmedDamage(self):
		me=Bladex.GetEntity(self.Name)
		if not Reference.EntitiesObjectData.has_key(self.Name):
			Reference.EntitiesObjectData[self.Name]= [Reference.OBJ_WEAPON,   1,  0, 1.0,  Reference.THR_SPINNING, []]
		undam=GetUnarmedDamage(self.Name)
		Reference.EntitiesObjectData[self.Name][1]=undam
		#print self.Name+": Setting Unarmed Damage",undam
				
			
				
	def IsValidEnemy (self, entity):
		me=Bladex.GetEntity(self.Name)
		if not self.AttackOnSight:
			return FALSE
		if entity.Name=="Player1":
			return FALSE
		if entity.Person and entity.Life >0 and entity.Name != self.Name and not AllyCombat.CheckAlly (entity.Name) and (me.CanISee(entity)):
			return TRUE
		else:
			return FALSE
	

	
	def MyGetEnemyName (self):
		me=Bladex.GetEntity(self.Name)
		###########################################################################
		"""
		if self.EnemyName:
			
			if self.EnemyName == "Player1": # This should not happen.....
				print me.Name+": I have Player1 as an enemy!!! This can't happen!!!"
				self.EnemyName=None
				return None
			
			## Strange Bug Catcher..... If enemy corpses are deleted and an Ally still has them in Data
			## as opponent, weird things happen when their non-existant attributes are attempted to be accessed.
			
			try:
				if Bladex.GetEntity(self.EnemyName).Life <=0:
					print self.Name+" Has as enemy "+self.EnemyName+" who is actually dead"
					self.EnemyName=None
			except AttributeError:
				print self.Name+": Has as enemy: "+self.EnemyName+" and he or she does not like it"
				self.EnemyName=None
		"""
				
		
		###########################################################################
	        if not self.EnemyName or Bladex.GetEntity(self.EnemyName).Life <=0:
                   	pjp = me.Position
		   	enemyList=[]
		   	pj_dir=me.Rel2AbsVector(0.0,-1.0,0.0)
			pjp=me.Position
			for ename in Bladex.GetEnemiesVisibleFrom(pjp,50000,pj_dir,0.0):
                       		ene=Bladex.GetEntity(ename)
                       		if self.IsValidEnemy(ene):
                         		enemyList.append(ene.Name)
                   	if len (enemyList) == 0: 
                   		#print "no baddies"
                   		self.EnemyName=None
                   		return None
                   	enemyList.sort(self.ChooseNearest)
                   	self.EnemyName=enemyList[0]
		enemy=Bladex.GetEntity(self.EnemyName)
		if self.EnemyName == "Player1": # This should not happen.....
			print me.Name+": I have still have Player1 as an enemy!!!"
			return None
                me.SetEnemy(enemy)
		return self.EnemyName		
	
	
	
	def StdEnterClose(self,EntityName):
		Ally_Def.NPCAlly.StdEnterClose(self,EntityName)
		self.RaiseAlarm(EntityName)
	
	
	def RaiseAlarm(self,EntityName):
		# called when an ally engages an enemy. Make all other allies turn to face enemy if they are not busy....
		me=Bladex.GetEntity(EntityName)
		#print "Alarm raised by ",me.Name
		x,y,z=me.Rel2AbsPoint(0,2000,0)
		px,py,pz=me.Position
		for aname in Bladex.GetEntitiesAt(px,py,pz, 40000):
			ally=Bladex.GetEntity(aname)
                        if ally and ally.Person:
                        	
                		if ally.Life>0 and not ally.Blind and ally.Alpha>0.9 and not CheckIfAlly(ally.Name) and ally.Name!=me.Name and ally.Name!="Player1":
                			
                			dist=B3DLib.GetXZDistance(EntityName, ally.Name)
                			try:
						if not ally.CanISee(me) and not ally.InCombat and not ally.Data.OnGuard and ally.Data.Combatant and not ally.Name[:10]=="MagicDemon":
			
							if dist>12000 and dist <40000:
								ally.GoToJogging=1
								if ally.AstarState<>Ally_Def.ASTAR_SOLVED and not me.GetActionMode()!=Ally_Def.ROUTE_CHASE:
									ally.GoTo(x,y,z)
									me.RouteEndedFunc=self.LaunchMyWatch
									#print ally.Name," I am responding to alert from ",me.Name
							else:
								Actions.TurnToFaceEntity(ally.Name,me.Name)
								me.RouteEndedFunc=self.LaunchMyWatch
								print ally.Name," I have been alerted"
					except AttributeError:
						print ally.Name+" Is provoking attribute error!"
	
	

	def StdSeeTheEnemy(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		life = me.Life
		if life > 0.0:		
			if not self.MyGetEnemyName(): 
				return
			#Reference.debugprint (EntityName + ": Who goes there!")
			
			ene=Bladex.GetEntity(self.MyGetEnemyName())
			if ene:
				########
				if ene.Name=="Player1":
					Reference.debugprint (EntityName + " Why have I got Player as enemy?")
				#########
				if self.IsValidEnemy(ene):
				
					#Reference.debugprint (EntityName + " I see "+ene.Name+". - I will CARVE him up!")
					if self.Asleep:
						self.WakeMeUp(EntityName)
				me.LookAtEntity(ene.Name)
			
				#Just in case we were doing a wait animation
				if me.GetActionMode() == Ally_Def.ROUTE_BAY:	
					me.Wuea=Reference.WUEA_ENDED

				self.CheckToJoin(EntityName)
				if me.GetActionMode()!=Ally_Def.ROUTE_CHASE:
					self.StdStartChase(EntityName)
				
				if me.GetActionMode()==Ally_Def.ROUTE_BOWING: 
					if self.AimPressed:
						angle= Reference.TARGET_ANGLE_MAX- me.Accuracy*(Reference.TARGET_ANGLE_MAX-Reference.TARGET_ANGLE_MIN)
						if me.AimOffTarget<angle:
							print "Releasing Arrow"
							Actions.TestReleaseArrow(EntityName)
					else: 
						if me.Wuea!=Reference.WUEA_WAIT:
							print "Drawing Bow"
							Actions.TestDrawBow (EntityName)
				elif me.Aim or Actions.CurrentlyBowing(EntityName):
					me.Wuea=Reference.WUEA_ENDED
					Actions.EndBowMode(EntityName)
					me.SetOnFloor()
			else:
				print (EntityName + ": Cannot get a handle on me")
	
		
				

	
	def RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded):
		# launch appropriate hurt anim
		if self.Asleep:
			self.WakeMeUp(EntityName)
		if not self.AttackOnSight:	
			self.AttackOnSight=1
		Basic_Funcs.PlayerPerson.RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded)
		if AttackerName and AttackerName != 'BWorld' and AttackerName != EntityName:
			me = Bladex.GetEntity(EntityName)
			if me and me.Life > 0:
				#####################################################################
				# consider getting furious
				
				#chartype = Bladex.GetCharType(me.CharType,me.CharTypeExt)
				#if me.Life <= CharStats.GetCharMaxLife(me.Kind, me.Level)*0.25 and whrandom.random() < self.ChanceOfFuryOnHurt:
				#	self.GetFurious (EntityName)
					
				# consider attacking attacker back
				#damage_factor = DamagePoints / (me.Life+DamagePoints)
				#if damage_factor > me.Data.DamageFactorNone:
				#	# Only if I'm still alive... Death events handled apart
				####################################################################
				Reference.debugprint(EntityName+": Im being attacked by "+AttackerName)
					
				if self.EnemyName and self.EnemyName != AttackerName:
					Reference.debugprint(AttackerName+": Is NOT my current enemy")
					attacker = Bladex.GetEntity(AttackerName)
					##########################################
					
					
					#if attacker and (self.AttacksOwnKind or attacker.Kind != me.Kind):
					if attacker and CheckIfAlly(attacker.Name) and attacker.Name != "Player1": 
						if self.Asleep:
							self.WakeMeUp(EntityName)
						if attacker.Name=="Player1":
							Reference.debugprint(EntityName+": I will not retaliate against the Player")
							return
						# Only attack NPCs if not already, otherwise we get multiple scheduled funcs
						if (not attacker.Data.NPC) or (not self.AttackingNPC):
							#Reference.debugprint("attacker.Data.NPC: "+ `attacker.Data.NPC`+ ", self.AttackingNPC: " + `self.AttackingNPC`)
								
							Damage.DropInvalidObjectsOnImpact (EntityName)
							me.Wuea=Reference.WUEA_ENDED
							me.InterruptCombat()
							me.SetEnemy(attacker)
							me.SetActiveEnemy(attacker)
							me.Chase(attacker, me.ActionAreaMax)
							if me.GetActionMode()==Enm_Def.ROUTE_CHASE and self.IsArcher():
								self.Switch2MeleeWeapons(EntityName)		

	
	def CheckForBadGuys(self):
		me=Bladex.GetEntity(self.Name)
		mypos=me.Position
		localenemylist=[]
		for ename in Bladex.GetEntitiesAt(mypos[0],mypos[1],mypos[2], 20000):
                	ene=Bladex.GetEntity(ename)
                	if ene:
                		if ene.Person:
                			if ene.Life>0 and ene.Alpha>0.9 and CheckIfAlly(ene.Name) and ene.Name!=me.Name and ene.Name!="Player1":
                				localenemylist.append(ene.Name)
                if len (localenemylist) == 0: 
                   	return None
		localenemylist.sort(self.ChooseNearest)
                return localenemylist[0]
	
	
	def ChooseNearest (self,entity1name, entity2name):
		p1 = Bladex.GetEntity(entity1name)
		p2 = Bladex.GetEntity(entity2name)
		if not p1 and not p2:
			return CHOOSE_EITHER
		elif not p1:
			return CHOOSE_SECOND
		elif not p2:
			return CHOOSE_FIRST
		me=Bladex.GetEntity(self.Name)
		val = me.SQDistance2(p1) - me.SQDistance2(p2)

		if val < 0:
			return CHOOSE_FIRST
		elif val > 0:
			return CHOOSE_SECOND
		else:
			return CHOOSE_EITHER

	

	def LookForAnotherOpponent(self,EntityName):
		#Reference.debugprint(EntityName+": I am looking for another opponent")
		me = Bladex.GetEntity(EntityName)
		if me.InCombat:
			return
		self.LaunchMyWatch (EntityName)
		mep=me.Position
		allyenelist=[]
		ents=Bladex.GetEntitiesAt(mep[0],mep[1],mep[2], 25000)
		for ename in ents:
			en=Bladex.GetEntity(ename)
			if en.Person:
				if self.IsValidEnemy(en) and en.Name != me.Name:
					allyenelist.append(en.Name)
		if len (allyenelist) == 0: 
                   	return 
                allyenelist.sort(self.ChooseNearest)
                nearest=Bladex.GetEntity(allyenelist[0])
                if nearest and not me.InCombat:
			me.GoToJogging=0
			me.GoTo(nearest.Position[0],nearest.Position[1],nearest.Position[2])
			#print EntityName+" I have found a new enemy and I am going to sort the bugger out "
					
                    				
                    				
	
	def StdDelayNoSeen(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me.Life > 0:
			if not self.MyGetEnemyName():
				if (not self.Asleep) and (not me.Blind):
					if me.Aim or Actions.CurrentlyBowing(EntityName):
						me.Wuea=Reference.WUEA_ENDED
						Actions.EndBowMode(EntityName)
						me.SetOnFloor()
					#Reference.debugprint(EntityName+": Im in NEWStdDelayNoSeen")
					me.StopLooking()
					self.PutMeToSleep(EntityName)
					if not self.EnemyName and not self.OnGuard:
						self.LookForAnotherOpponent(EntityName)
						return
						
					if self.OnGuard:
						self.LookAround(EntityName)
						
					#Reference.debugprint(EntityName+": I have got bored and dropped off to sleep")		
					
					if me.GetActionMode() != Ally_Def.ROUTE_CHASE:
						if me.GetActionMode() != Ally_Def.ROUTE_SINGLE and me.GetActionMode() != Ally_Def.ROUTE_BAY:
							Reference.debugprint(EntityName+": I am not chasing")
							self.LaunchMyPatrol(EntityName)
					else:
						Reference.debugprint(EntityName+": I am chasing")
						if me.AstarState<>Ally_Def.ASTAR_SOLVED:
							# Face enemy as much as possible
							lastseenpos = me.EnemyLastSeen
							me.StartLooking(lastseenpos[0], lastseenpos[1], lastseenpos[2])
							if Actions.IsFacingPos(EntityName, lastseenpos[0], lastseenpos[2]):
								self.LaunchMyWatch (EntityName)
						else:
							Actions.TurnToFacePos(EntityName, lastseenpos[0], lastseenpos[2])
							me.RouteEndedFunc=self.LaunchMyWatch
			else:
				Reference.debugprint(EntityName+": I can't go to sleep yet, I have an enemy")
		
		
		
				
	def PutMeToSleep(self,EntityName):
		if not self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=1  
			self.Asleep = TRUE

	def WakeMeUp(self,EntityName):
		if self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=0  
			self.Asleep = FALSE
			
			
	def ReturnToStart(self,EntityName):
		me=Bladex.GetEntity(EntityName)
		me.GoTo(self.GuardPoint[0],self.GuardPoint[1],self.GuardPoint[2])
		#Reference.debugprint(EntityName+": I am going back to start")
	


	
	
	
	# Functions for loading and saving state
	def __getstate__(self):	
		NPCPerson_state=Ally_Def.NPCAlly.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["AllyChar"]=(GameStateAux.SaveFunctionAux(self.DeathFunc),
						self.DeathArgs,
		                                GameStateAux.SaveFunctionAux(self.LevelupFunc),
		                                self.LevelupArgs,
		                                self.Combatant,
		                                self.Dusted,
		                                self.OnGuard,
		                                self.GuardPoint,
		                                self.Agenum,
		                                self.ThrowingObject,
		                                self.AttackOnSight)
		return NPCPerson_state
	
	def __setstate__(self,parm):
		Ally_Def.NPCAlly.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["AllyChar"]
			GameStateAux.LoadFunctionAux(parms[0],self,"DeathFunc")
			self.DeathArgs=parms[1]
			GameStateAux.LoadFunctionAux(parms[2],self,"LevelupFunc")
			self.LevelupArgs=parms[3]
			self.Combatant=parms[4]
			self.Dusted=parms[5]
			self.OnGuard=parms[6]
		        self.GuardPoint=parms[7]
		        self.Agenum=parms[8]
		        self.ThrowingObject=parms[9]
		        self.AttackOnSight=parms[10]
		self.NPCLevelUpParticleData=[]
		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 
				aux=traux**0.5
			else:
				traux=i/25.0
				aux=traux**2.0
			r=255
			g=255
			b=255
			a=255.0*traux
			size=200.0*aux
			self.NPCLevelUpParticleData.append(a)
			self.NPCLevelUpParticleData.append(size)
		Bladex.SetParticleGVal("NPCLevelUpParticle",i,r,g,b,a,size)
				
		self.lupsnd1=Bladex.CreateSound("..\\..\\Sounds\\aparicion-escudo.wav", "LUPSnd1")
		self.lupsnd1.Volume=1.0
		self.lupsnd1.MinDistance=10000
		self.lupsnd1.MaxDistance=30000	
		me=Bladex.GetEntity(self.Name)
		me.ImDeadFunc=self.NewImDeadFunc
		
		
		


		
########################################################################################################################################################
######################### Race Sub-Classes #############################################################################################################



class AllyDwarf (AllyChar):
	def __init__(self, me):
		AllyChar.__init__(self, me)
		
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		
		
	
	def ResetSounds(self, EntityName):
		me = Bladex.GetEntity(EntityName)
		AniSound.AsignarSonidosEnano(EntityName)
		if me.MeshName=="DwfSkin1" and os.path.exists("../../FugSkins/glof.bmp"):
			Bladex.ReadBitMap("../../FugSkins/glof.bmp","GlofrorIcon")
			Reference.EnemiesScorerData[self.Name]=("GlofrorIcon","Dwf")	
		elif me.MeshName=="DwfSkin2" and os.path.exists("../../FugSkins/herb.bmp"):
			Bladex.ReadBitMap("../../FugSkins/herb.bmp","HerbertIcon")
			Reference.EnemiesScorerData[self.Name]=("HerbertIcon","Dwf")	
		else:
			Bladex.ReadBitMap("../../Data/Icons/icono enano.bmp","Dwarf_NIcon")
			Reference.EnemiesScorerData[self.Name]=("Dwarf_NIcon","Dwf")	
			
		




	def ResetCombat (self,EntityName):		
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			me.BlockingPropensity = 0.8
			self.AttackNPCTime = 100
			me.AttackList = BCopy.deepcopy(AllyDwarfAttackData)
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00
			if me.Level>1:
				me.AttackList.append([AllyCombat.ATTACK, 0.08, ("GM43_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>3:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM30_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>5:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM31_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>7:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM15_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>9:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM17_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>12:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM26_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>13:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM11_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>17:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM22_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
							
					
					
					
			
AllyDwarfAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],

           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            #[AllyCombat.DODGE,  0.30, "RDA",                500.0, 1200.0, 2800.0, 0.35],
            #[AllyCombat.DODGE,  0.30, "LDA",                500.0, 1200.0, 2800.0, 0.35],
            
            # basic attacks
	    [AllyCombat.ATTACK, 0.50, ("GI_1H",),            500, 1500.0, 2500.0, 0.35], # Light Attack 
	    [AllyCombat.ATTACK, 0.40, ("GM12_1H",),          500, 1500.0, 2500.0, 0.35], # Light High Attack 
	    [AllyCombat.ATTACK, 0.30, ("GM18_1H",),          500, 1500.0, 2500.0, 0.35], # Light Low Attack 
	    [AllyCombat.ATTACK, 0.40, ("GM16_1H",),          500, 1500.0, 2500.0, 0.35], # Light Left Attack 
	    [AllyCombat.ATTACK, 0.40, ("GM14_1H",),          500, 1500.0, 2500.0, 0.35], # Light Right Attack 
	    
	    [AllyCombat.MOVE,   0.03, "tr",                5000.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.MOVE,   0.03, "tl",                5000.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.MOVE,   0.05, "tb",                5000.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.MOVE,   0.03, "tf",                5000.0, 7000.0, 9000.0, 0.50],
            
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
            
            [AllyCombat.MOVE,   0.25, AllyCombat.TempMoveInProc,      3000.0,  7000.0, 9000.0, 0.35, 1],
]


###########################################################################################################################################################
# Original RAS Amazon

class AllyAmazon (AllyChar):

	def __init__(self, me):
		AllyChar.__init__(self, me)
		
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		

	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		AniSound.AsignarSonidosAmazona(EntityName)
		Bladex.ReadBitMap("../../Data/Icons/icono amazona.bmp","AmazonIcon")
		Reference.EnemiesScorerData[self.Name]=("AmazonIcon","Amz")	
		
	
	
	def ResetCombat (self,EntityName):		
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			self.AttackNPCTime = 100
			me.AttackList = BCopy.deepcopy(AmazonAttackData)
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00
			me.BlockingPropensity = 0.6
			
			if me.Level>1:
				me.AttackList.append ([AllyCombat.ATTACK, 0.15, ("GM15_SP",),1200.0, 1600.0, 2500.0, 0.35],)
			if me.Level>3:
				me.AttackList.append ([AllyCombat.ATTACK, 0.05, ("GM2_SP",),1200.0, 1600.0, 2500.0, 0.35],)
			if me.Level>5:
				me.AttackList.append ([AllyCombat.ATTACK, 0.05, ("GM10_SP",),1200.0, 1600.0, 2500.0, 0.35],)
			if me.Level>8:
				me.AttackList.append ([AllyCombat.ATTACK, 0.05, ("GI_SP","GM32_SP",),1700.0, 2000.0, 2500.0, 0.35],)
			if me.Level>10:
				me.AttackList.append ([AllyCombat.ATTACK, 0.05, ("GM31_SP",),1200.0, 1600.0, 2500.0, 0.35],)
			if me.Level>12:
				me.AttackList.append ([AllyCombat.ATTACK, 0.05, ("GM28_SP",),1200.0, 1600.0, 2500.0, 0.35],)
			

			
AmazonAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
             # outer zone moves:
            [AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            
            # inner zone moves:
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [AllyCombat.ATTACK, 0.25, ("GI_SP",) ,		1200.0, 1800.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.25, ("GM1_SP",),		1200.0, 1800.0, 2500.0, 0.35], 
	    [AllyCombat.ATTACK, 0.25, ("GM8_SP",),		1200.0, 1800.0, 2500.0, 0.35], 
	    [AllyCombat.ATTACK, 0.15, ("GM6_SP",),		1200.0, 1800.0, 2500.0, 0.35], 
	    [AllyCombat.ATTACK, 0.15, ("GM3_SP",),		1200.0, 1800.0, 2500.0, 0.35], 
	    
	        	    
	    [AllyCombat.MOVE,   0.15, AllyCombat.TempMoveInProc,      5000.0, 7000.0, 9000.0, 0.35],
            
           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.30, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.ATTACK, 0.30, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
            [AllyCombat.MOVE,   0.05, AllyCombat.UsePotion,   3000.0, 7000.0, 9000.0, 1.00],
]

###########################################################################################################################################################




class AllyKnight (AllyChar):

	def __init__(self, me):
		AllyChar.__init__(self, me)
		
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		

	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		AniSound.AsignarSonidosCaballero(EntityName)
		Bladex.ReadBitMap("../../Data/Icons/icono caballero.bmp","KnightIcon")
		Reference.EnemiesScorerData[self.Name]=("KnightIcon","Kgt")	
		
	
	
	def ResetCombat (self,EntityName):		
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			self.AttackNPCTime = 100
			me.AttackList = BCopy.deepcopy(AllyKnightAttackData)
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00
			me.BlockingPropensity = 0.6
			if me.Level>2:
				me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM4_1H",),1000.0, 1400.0, 2500.0, 0.35],)
				me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM7_1H",),1000.0, 1500.0, 2500.0, 0.35],)
			if me.Level>3:
				me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM9_1H",),1200.0, 1600.0, 2500.0, 0.35],)
				me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM2_1H",),1200.0, 1600.0, 2500.0, 0.35],)
			if me.Level>5:
				me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM38_1H",),1200.0, 1600.0, 2500.0, 0.35],)
				me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM23_1H",),1200.0, 1600.0, 2500.0, 0.35],)
			if me.Level>6:
				me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM35_1H",),1200.0, 1600.0, 2500.0, 0.35],)
			if me.Level>7:
				me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM39_1H",),1200.0, 1600.0, 2500.0, 0.35],)
			if me.Level>8:
				me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM5_1H",),1200.0, 1600.0, 2500.0, 0.35],)
				me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM23_1H","GM24_1H"),1200.0, 1600.0, 2500.0, 0.35],)
			if me.Level>9:
				me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM20_1H",),1200.0, 1600.0, 2500.0, 0.35],)
			if me.Level>10:
				me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM34_1H",),1200.0, 1600.0, 2500.0, 0.35],)
			if me.Level>12:
				me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM21_1H",),1200.0, 1600.0, 2500.0, 0.35],)
			
			
			
			
AllyKnightAttackData = [
	# inner zone blocks:
	[AllyCombat.BLOCK,  0.20, "tr",                 750.0, 1500.0, 3500.0, 0.50],
	[AllyCombat.BLOCK,  0.20, "tl",                 750.0, 1500.0, 3500.0, 0.50],
	[AllyCombat.BLOCK,  0.20, "tb",                 750.0, 1500.0, 3500.0, 0.50],
    	[AllyCombat.BLOCK,  0.40, "tf",                 750.0, 1500.0, 3500.0, 0.50],

    	# outer zone blocks:
    	[AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
    	[AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
    	[AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
    	[AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],

	# dodges
    	[AllyCombat.DODGE,  0.15, "d_r",                0.0, 1200.0, 2800.0, 0.35],
    	[AllyCombat.DODGE,  0.15, "d_l",                0.0, 1200.0, 2800.0, 0.35],
    	[AllyCombat.DODGE,  0.10, "d_b",                0.0, 1200.0, 2800.0, 0.35],
    	
    	#[AllyCombat.DODGE,  0.20, "RDA",                0.0, 1200.0, 2800.0, 0.35],
    	#[AllyCombat.DODGE,  0.20, "LDA",                0.0, 1200.0, 2800.0, 0.35],

	# basic attacks
	[AllyCombat.ATTACK, 0.05, ("GI_1H",),             1000.0, 1400.0, 2500.0, 0.35], 
	[AllyCombat.ATTACK, 0.05, ("GM1_1H",),            1000.0, 1400.0, 2500.0, 0.35], 
	[AllyCombat.ATTACK, 0.05, ("GM3_1H",),            1000.0, 1400.0, 2500.0, 0.35], 
	[AllyCombat.ATTACK, 0.05, ("GM6_1H",),            1000.0, 1400.0, 2500.0, 0.35], 
	[AllyCombat.ATTACK, 0.05, ("GM8_1H",),            1000.0, 1400.0, 2500.0, 0.35], 

    	# inner zone moves:
    	[AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
    	[AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
    	[AllyCombat.MOVE,   0.15, "tb",                   0.0, 2000.0, 5000.0, 0.35],
    	[AllyCombat.MOVE,   0.10, "tf",                   0.0, 2000.0, 5000.0, 0.35],
        [AllyCombat.MOVE,   0.25, AllyCombat.TempMoveInProc,      5000.0, 7000.0, 9000.0, 0.35],
    	[AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
]
	
##########################################################################################################################################################




class AllyBarbarian (AllyChar):
	def __init__(self, me):	
		AllyChar.__init__(self, me)
		
		

		# Set up orc specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		self.DamageFactorNone  = 0.15
		self.DamageFactorLight = 0.25


	def ResetSounds(self, EntityName):
		me = Bladex.GetEntity(EntityName)
		AniSound.AsignarSonidosBarbaro(EntityName)
		if me.MeshName=="BarSkin1" and os.path.exists("../../FugSkins/eric.bmp"):
			Bladex.ReadBitMap("../../FugSkins/eric.bmp","EricIcon")
			Reference.EnemiesScorerData[self.Name]=("EricIcon","Bar")
		else:
			Bladex.ReadBitMap("../../Data/Icons/icono barbaro.bmp","BarbarianIcon")
			Reference.EnemiesScorerData[self.Name]=("BarbarianIcon","Bar")
		

	def ResetCombat (self,EntityName):
		AllyChar.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			self.AttackNPCTime = 100
			me.BlockingPropensity = 0.5
			flag=GiveWeaponType(EntityName)
			if flag==W_FLAG_2W:
				me.AttackList = BCopy.deepcopy(AllyBarbarian2HAttackData)
				if me.Level>=2:
					me.AttackList.append ([AllyCombat.ATTACK, 0.12, ("GM4_2H","GM5_2H",),1200.0, 1600.0, 2500.0, 0.35],) 
				if me.Level>=3:
					me.AttackList.append ([AllyCombat.ATTACK, 0.12, ("GM7_2H","GM8_2H",),1200.0, 1600.0, 2500.0, 0.35],) 
					me.AttackList.append ([AllyCombat.ATTACK, 0.12, ("GM10_2H","GM11_2H",),1200.0, 1600.0, 2500.0, 0.35],) 
					me.AttackList.append ([AllyCombat.ATTACK, 0.12, ("GM1_2H","GM6_2H",),1200.0, 1600.0, 2500.0, 0.35],)  # ChaosSword
				if me.Level>=5:
					me.AttackList.append ([AllyCombat.ATTACK, 0.05, ("GM1_2H","GM12_2H",),1200.0, 1600.0, 2500.0, 0.35],) 
				if me.Level>=7:
					me.AttackList.append ([AllyCombat.ATTACK, 0.12, ("GM7_2H","GM41_2H",),1200.0, 1600.0, 2500.0, 0.35],) # DeathSword
					me.AttackList.append ([AllyCombat.ATTACK, 0.05, ("GM1_2H","GM2_2H",),1200.0, 1600.0, 2500.0, 0.35],) 
				if me.Level>=9:
					me.AttackList.append ([AllyCombat.ATTACK, 0.03, ("GM11_2H","GM15_2H",),1200.0, 1600.0, 2500.0, 0.35],) # SlayingSword
				if me.Level>=11:
					me.AttackList.append ([AllyCombat.ATTACK, 0.09, ("GI_2H","GM23_2H",),1200.0, 1600.0, 2500.0, 0.35],) 
					me.AttackList.append ([AllyCombat.ATTACK, 0.09, ("GI_2H","GM42_2H",),1200.0, 1600.0, 2500.0, 0.35],) 
				if me.Level>=14:
					me.AttackList.append ([AllyCombat.ATTACK, 0.15, ("GI_2H","GM23_2H","GM24_2H",),1500.0, 2000.0, 2500.0, 0.35],) 
				if me.Level>=18:
					me.AttackList.append ([AllyCombat.ATTACK, 0.09, ("GM1_2H","GM40_2H",),1200.0, 1600.0, 2500.0, 0.35],) 				
			elif flag==W_FLAG_AXE:
				me.AttackList = BCopy.deepcopy(AllyBarbarianAXEAttackData)
				if me.Level>=2:
					me.AttackList.append ([AllyCombat.ATTACK, 0.15, ("GM28_AXE","GM29_AXE",),1200.0, 1600.0, 2500.0, 0.35],)
				if me.Level>=4:
					me.AttackList.append ([AllyCombat.ATTACK, 0.15, ("GM19_AXE","GM32_AXE",),1200.0, 1600.0, 2500.0, 0.35],) 
				if me.Level>=5:
					me.AttackList.append ([AllyCombat.ATTACK, 0.15, ("GM21_AXE","GM26_AXE",),1200.0, 1600.0, 2500.0, 0.35],) 
				if me.Level>=8:
					me.AttackList.append ([AllyCombat.ATTACK, 0.15, ("GM17_AXE","GM31_AXE",),1200.0, 1600.0, 2500.0, 0.35],) 
				if me.Level>=10:
					me.AttackList.append ([AllyCombat.ATTACK, 0.15, ("GM19_AXE","GM27_AXE",),1200.0, 1600.0, 2500.0, 0.35],)
					me.AttackList.append ([AllyCombat.ATTACK, 0.15, ("GM20_AXE",),1200.0, 1600.0, 2500.0, 0.35],)  
			else:
				pass


AllyBarbarian2HAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],

           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.40, "d_b",                500.0, 1200.0, 2800.0, 0.35],

            
            [AllyCombat.ATTACK, 1.00, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],

	    [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            
            [AllyCombat.MOVE,   0.25, AllyCombat.TempMoveInProc,      5000.0, 7000.0, 9000.0, 0.35],
            [AllyCombat.MOVE,   0.05, AllyCombat.UsePotion,           3000.0, 7000.0, 9000.0, 1.00],
            
            [AllyCombat.ATTACK, 0.50, ("GI_2H",), 1500.0, 2500.0, 3500.0, 0.35],
            [AllyCombat.ATTACK, 0.40, ("GM1_2H",),1500.0, 2500.0, 3500.0, 0.35],
	    [AllyCombat.ATTACK, 0.25, ("GM10_2H",),1500.0, 2500.0, 3500.0, 0.35],
	    [AllyCombat.ATTACK, 0.25, ("GM7_2H",),1500.0, 2500.0, 3500.0, 0.35],
	    

]	

AllyBarbarianAXEAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],

           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.40, "d_b",                500.0, 1200.0, 2800.0, 0.35],

            
            [AllyCombat.ATTACK, 1.00, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],

	    [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            
            [AllyCombat.MOVE,   0.25, AllyCombat.TempMoveInProc,      5000.0, 7000.0, 9000.0, 0.35],
            [AllyCombat.MOVE,   0.05, AllyCombat.UsePotion,           3000.0, 7000.0, 9000.0, 1.00],	
            
            [AllyCombat.ATTACK, 0.12, ("GI_AXE",), 1500.0, 2500.0, 3500.0, 0.35],
	    [AllyCombat.ATTACK, 0.12, ("GM17_AXE",),1500.0, 2500.0, 3500.0, 0.35],
	    [AllyCombat.ATTACK, 0.12, ("GM19_AXE",),1500.0, 2500.0, 3500.0, 0.35], 
	    [AllyCombat.ATTACK, 0.15, ("GM21_AXE",),1500.0, 2500.0, 3500.0, 0.35],

]	


###########################################################################################################################################################
##### Amazon_B (aka. 'Super Zoe')

class AllyAmazon_B(AllyChar):
	
	def __init__(self, me):
		AllyChar.__init__(self, me)
		
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		me.MeshName="AmzSkin2"
		
		
		
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		AniSoundAmzB.AsignarSonidosAmazonB(EntityName)
		Bladex.ReadBitMap("../../Data/Icons/icono amazona.bmp","AmazonIcon")
		Reference.EnemiesScorerData[self.Name]=("AmazonIcon","Amb")	
		
	
		
	# Functions for loading and saving state
	def __getstate__(self):	
		NPCAlly_state=AllyChar.__getstate__(self)
		if(NPCAlly_state[0]!=1):
			return NPCAlly_state
		NPCAlly_state[1]["AllyAmazon_B"]=()
		return NPCAlly_state
	
	
	def __setstate__(self,parm):
		AllyChar.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["AllyAmazon_B"]
			me=Bladex.GetEntity(self.Name)



	def ResetCombat (self,EntityName):		
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		inv=me.GetInventory()
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			self.AttackNPCTime = 100
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00
			flag=GiveWeaponType(EntityName)
			
			if flag==W_FLAG_1H or inv.HoldingBow:
				me.AttackList = BCopy.deepcopy(Amazon_B1HAttackData)
				if me.Level>=2:
					me.AttackList.append ([AllyCombat.ATTACK, 0.25,("GM23_1H",),1000.0, 1400.0, 2500.0, 0.35],)
				elif me.Level>=3:
					me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM5_1H",),1200.0, 1600.0, 2500.0, 0.35],)
				elif me.Level>=5:
					me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM38_1H",),1200.0, 1600.0, 2500.0, 0.35],)
				elif me.Level>=8:
					me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM35_1H",),1200.0, 1600.0, 2500.0, 0.35],)
				elif me.Level>=11:
					me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM39_1H",),1200.0, 1600.0, 2500.0, 0.35],)
				elif me.Level>=12:
					me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM34_1H",),1200.0, 1600.0, 2500.0, 0.35],)
				elif me.Level>=14:
					me.AttackList.append ([AllyCombat.ATTACK, 0.2, ("GM18_1H",),1200.0, 1600.0, 2500.0, 0.35],)
				
			elif flag==W_FLAG_2W:
				me.AttackList = BCopy.deepcopy(Amazon_B2HAttackData)
				if me.Level>=2:
					me.AttackList.append ([AllyCombat.ATTACK, 0.12,("GM1_2H","GM9_2H",),1000.0, 1500.0, 2800.0, 0.35],)
				elif me.Level>=3:
					me.AttackList.append ([AllyCombat.ATTACK, 0.12,("GM2_2H","GM10_2H",),1000.0, 1500.0, 2800.0, 0.35],)
				elif me.Level>=5:
					me.AttackList.append ([AllyCombat.ATTACK, 0.12,("GM3_2H","GM8_2H",),1000.0, 1500.0, 2800.0, 0.35],)
				elif me.Level>=6:
					me.AttackList.append ([AllyCombat.ATTACK, 0.12,("GM4_2H","GM11_2H",),1000.0, 1500.0, 2800.0, 0.35],)
				elif me.Level>=8:
					me.AttackList.append ([AllyCombat.ATTACK, 0.15,("GM23_2H",),800.0, 1500.0, 2800.0, 0.35],)
				elif me.Level>=9:
					me.AttackList.append ([AllyCombat.ATTACK, 0.18,("GM12_2H",),1000.0, 1500.0, 2800.0, 0.35],)
				elif me.Level>=13:
					me.AttackList.append ([AllyCombat.ATTACK, 0.18,("GM15_2H",),1000.0, 1500.0, 2800.0, 0.35],)				
				
			elif flag==W_FLAG_SP:
				me.AttackList = BCopy.deepcopy(Amazon_BSPAttackData)
				if me.Level>=2:
					me.AttackList.append ([AllyCombat.ATTACK, 0.12,("GM15_SP",),1000.0, 1500.0, 2800.0, 0.35],)
				elif me.Level>=4:
					me.AttackList.append ([AllyCombat.ATTACK, 0.12,("GM2_SP"),1000.0, 1500.0, 2800.0, 0.35],)
				elif me.Level>=5:
					me.AttackList.append ([AllyCombat.ATTACK, 0.12,("GM27_SP",),1000.0, 1500.0, 2800.0, 0.35],)
				elif me.Level>=6:
					me.AttackList.append ([AllyCombat.ATTACK, 0.12,("GM7_SP",),1000.0, 1500.0, 2800.0, 0.35],)
				elif me.Level>=8:
					me.AttackList.append ([AllyCombat.ATTACK, 0.12,("GM32_SP",),800.0, 1500.0, 2800.0, 0.35],)
				elif me.Level>=9:
					me.AttackList.append ([AllyCombat.ATTACK, 0.12,("GM10_SP",),1000.0, 1500.0, 2800.0, 0.35],)
				elif me.Level>=13:
					me.AttackList.append ([AllyCombat.ATTACK, 0.12,("GM31_SP",),1000.0, 1500.0, 2800.0, 0.35],)
				elif me.Level>=14:
					me.AttackList.append ([AllyCombat.ATTACK, 0.12,("GM15_SP","GM24_SP",),1500.0, 1800.0, 2800.0, 0.35],)
			else:
				me.AttackList = BCopy.deepcopy(Amazon_BUnarmedAttackData)
				
		

			
Amazon_B1HAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            [AllyCombat.ATTACKDOWN, 1.00, ("STAIRS",),         1200.0, 1600.0, 2500.0, 0.35],
            
             # outer zone moves:
            [AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            
            # inner zone moves:
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [AllyCombat.ATTACK, 0.12,("GM1_1H",),500.0, 1000.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.12,("GM2_1H",),500.0, 1000.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.12,("GM3_1H",),500.0, 1000.0, 2500.0, 0.35],      # left
	    [AllyCombat.ATTACK, 0.12,("GM4_1H",),500.0, 1000.0, 2500.0, 0.35],      # right
	    [AllyCombat.ATTACK, 0.12,("GI_1H",), 500.0, 1000.0, 2500.0, 0.35],
	   
           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.MOVE,   0.35, AllyCombat.TempMoveInProc,      5000.0, 7000.0, 9000.0, 0.35],
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
            [AllyCombat.MOVE,   0.05, AllyCombat.UsePotion,           3000.0, 7000.0, 9000.0, 1.00],
]		



Amazon_B2HAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            [AllyCombat.ATTACKDOWN, 1.00, ("STAIRS",),         1200.0, 1600.0, 2500.0, 0.35],
            
             # outer zone moves:
            [AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            
            # inner zone moves:
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
	    [AllyCombat.ATTACK, 0.15,("GI_2H",),500.0, 1000.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.12,("GM4_2H",),500.0, 1000.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.12,("GM2_2H",),500.0, 1000.0, 2500.0, 0.35],      
	    [AllyCombat.ATTACK, 0.12,("GM3_2H",),500.0, 1000.0, 2500.0, 0.35],      
	    [AllyCombat.ATTACK, 0.12,("GM1_2H",),500.0, 1000.0, 2500.0, 0.35],

            
           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.MOVE,   0.35, AllyCombat.TempMoveInProc,      5000.0, 7000.0, 9000.0, 0.35],
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
            [AllyCombat.MOVE,   0.05, AllyCombat.UsePotion,           3000.0, 7000.0, 9000.0, 1.00],
]		
            
       
Amazon_BSPAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            [AllyCombat.ATTACKDOWN, 1.00, ("STAIRS",),         1200.0, 1600.0, 2500.0, 0.35],
            
             # outer zone moves:
            [AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            
            # inner zone moves:
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
	   
	    [AllyCombat.ATTACK, 0.15, ("GI_SP",) ,1200.0, 1800.0, 2500.0, 0.35], 
	    [AllyCombat.ATTACK, 0.15, ("GM1_SP",),1200.0, 1800.0, 2500.0, 0.35], 
	    [AllyCombat.ATTACK, 0.15, ("GM8_SP",),1200.0, 1800.0, 2500.0, 0.35], 
	    [AllyCombat.ATTACK, 0.15, ("GM6_SP",),1200.0, 1800.0, 2500.0, 0.35], 
	    [AllyCombat.ATTACK, 0.15, ("GM3_SP",),1200.0, 1800.0, 2500.0, 0.35], 
            
           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.MOVE,   0.25, AllyCombat.TempMoveInProc,      5000.0, 7000.0, 9000.0, 0.35],
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
            [AllyCombat.MOVE,   0.05, AllyCombat.UsePotion,           3000.0, 7000.0, 9000.0, 1.00],
]		
   
   
Amazon_BUnarmedAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            [AllyCombat.ATTACKDOWN, 1.00, ("STAIRS",),         1200.0, 1600.0, 2500.0, 0.35],
            
             # outer zone moves:
            [AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            
            # inner zone moves:
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [AllyCombat.ATTACK, 0.05, ("GM21_NO",),500.0, 1000.0, 1500.0, 0.35],
	    [AllyCombat.ATTACK, 0.05, ("GM22_NO",),500.0, 1000.0, 1500.0, 0.35],
	    [AllyCombat.ATTACK, 0.05, ("GM23_NO",),500.0, 1000.0, 1500.0, 0.35],

           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.MOVE,   0.35, AllyCombat.TempMoveInProc,      5000.0, 7000.0, 9000.0, 0.35],
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
            [AllyCombat.MOVE,   0.05, AllyCombat.UsePotion,           3000.0, 7000.0, 9000.0, 1.00],
]		
       
       
##########################################################################################################################################################

import AniSoundIrDwarf



class AllyIrlichDwarf (AllyChar):

	IrDwarfWeps=["Hacha","Martillo","Hacha3","Garrote2","Garropin","Espadaromana","Hacha4","Martillo2","Maza3","IceHammer"]
	IrDwarfShds=["Escudo1","Escudo2","Escudo9","Escudo7",""]

	def __init__(self, me):
		AllyChar.__init__(self, me)
		
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		
		
	
	def ResetSounds(self, EntityName):
		me = Bladex.GetEntity(EntityName)
		AniSoundIrDwarf.AsignarSonidosIrDwarf(EntityName)
		Bladex.ReadBitMap("../../Maps/ProsperoArena1/NUFiles/IrlichDwarfStuff/IrDwarf_NIcon.bmp","IrDwarfIcon")
		Reference.EnemiesScorerData[self.Name]=("IrDwarfIcon","Ird")	
		
		
	def ToolUp(self):
		me = Bladex.GetEntity(self.Name)
		rwptype=self.IrDwarfWeps[whrandom.randint(0, len(self.IrDwarfWeps)-1)]
		lwptype=self.IrDwarfShds[whrandom.randint(0, len(self.IrDwarfShds)-1)]
		if rwptype:
			rwp=Bladex.CreateEntity(me.Name+"RightWeapon",rwptype,0,0,0,"Weapon")
			ItemTypes.ItemDefaultFuncs(rwp)
			Actions.TakeObject(me.Name,rwp.Name)
		if lwptype:
			lwp=Bladex.CreateEntity(me.Name+"Shield",lwptype,0,0,0,"Weapon")
			ItemTypes.ItemDefaultFuncs(lwp)
			Actions.TakeObject(me.Name,lwp.Name)
		
		
		



	def ResetCombat (self,EntityName):		
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			me.BlockingPropensity = 0.8
			self.AttackNPCTime = 100
			me.AttackList = BCopy.deepcopy(AllyIrDwarfAttackData)
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00
			if me.Level>1:
				me.AttackList.append([AllyCombat.ATTACK, 0.08, ("GM43_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>3:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM30_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>5:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM31_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>7:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM15_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>9:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM17_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>12:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM26_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>12:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM11_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>17:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM22_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
							
					
					
					
			
AllyIrDwarfAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],

           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            
            
            
            [AllyCombat.DODGE,  0.30, ("RDA",),                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.30, ("LDA",),                500.0, 1200.0, 2800.0, 0.35],
            
            
            # basic attacks
	    [AllyCombat.ATTACK, 0.50, ("GI_1H",),            500, 1500.0, 2500.0, 0.35], # Light Attack 
	    [AllyCombat.ATTACK, 0.40, ("GM12_1H",),          500, 1500.0, 2500.0, 0.35], # Light High Attack 
	    [AllyCombat.ATTACK, 0.30, ("GM18_1H",),          500, 1500.0, 2500.0, 0.35], # Light Low Attack 
	    [AllyCombat.ATTACK, 0.40, ("GM16_1H",),          500, 1500.0, 2500.0, 0.35], # Light Left Attack 
	    [AllyCombat.ATTACK, 0.40, ("GM14_1H",),          500, 1500.0, 2500.0, 0.35], # Light Right Attack 
	    
	    [AllyCombat.MOVE,   0.03, "tr",                5000.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.MOVE,   0.03, "tl",                5000.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.MOVE,   0.05, "tb",                5000.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.MOVE,   0.03, "tf",                5000.0, 7000.0, 9000.0, 0.50],
            
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
            
            [AllyCombat.MOVE,   0.25, AllyCombat.TempMoveInProc,      3000.0,  7000.0, 9000.0, 0.35, 1],
]
