import Bladex
import Enm_Def
import AuxFuncs
import CharStats
import GenFX
import whrandom
import Actions
import Reference
import GameStateAux
import AniSound
import Combat
import BCopy
import Basic_Funcs
import Damage
import ItemTypes
import InitDataField
import Sparks
import Interpolator
import ObjStore
import ScorerActions
import dust
import B3DLib
import math
import darfuncs

import PlayerTypes
import Armour

TRUE = 1==1
FALSE = not TRUE



CHOOSE_FIRST  = -1
CHOOSE_SECOND =  1
CHOOSE_EITHER =  0


W_FLAG_1H=0     #One handed _whatever_ weapon
W_FLAG_2W=1	#Two handed sword
W_FLAG_AXE=2	#Two handed axe
W_FLAG_SP=3     #Two handed spear







def CheckIfEnemy (EntityName):
	me=Bladex.GetEntity(EntityName)
	if me:		
		try:
	           	enemyName=me.Data.EnemyName
	           	return TRUE                       
	        except AttributeError:  
	 	   	return FALSE   

	 	   
def IsHoldingBow(EntityName):
	me=Bladex.GetEntity(EntityName)
	ObjectName=me.InvLeft
	object_flag=Reference.GiveObjectFlag(ObjectName)
	if object_flag==Reference.OBJ_BOW:
		return TRUE
	return FALSE
		
		
		
def KeepDistance (EntityName):
	me= Bladex.GetEntity(EntityName)
	return me.AnimName!="rlx"
	
	
		
def DumpMe(entity):
	per=Bladex.GetEntity(entity)		
	per.Position=0,30000,0
	
		
def RemoveMyCorpse(PersonName, dx, dz):
	me = Bladex.GetEntity(PersonName)
	me.Alpha=1.00
	me.RasterMode="Read"
	me.CastShadows=0
	AuxFuncs.FadeObject(PersonName, 1.00, 0.0, 4.0)
	# If corpses are deleted, Allies get confused.....
	#Bladex.AddScheduledFunc(Bladex.GetTime()+4.1,me.SubscribeToList,("Pin",))
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.1,DumpMe,(me.Name,))
	
	
def RemoveMyWeapon(WeaponName):
	wp = Bladex.GetEntity(WeaponName)
	if wp:
		wp.Alpha=1.00
		wp.RasterMode="Read"
		wp.CastShadows=0
		AuxFuncs.FadeObject(WeaponName, 1.00, 0.0, 4.0)
		Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, DumpMe,(wp.Name,))
		
		
		
def GiveWeaponType(entity):
	per=Bladex.GetEntity(entity)
	inv = per.GetInventory()
	rwp=per.InvRight
	if rwp:
		wpflag=Reference.GiveObjectFlag(rwp)
		if wpflag==Reference.OBJ_STANDARD:
			return W_FLAG_1H
	for x in range(inv.nWeapons):
		weapon_name = inv.GetWeapon(x)
		wp = Bladex.GetEntity(weapon_name)
		if wp:
			if Reference.EntitiesObjectData.has_key(weapon_name):
				object_data = Reference.EntitiesObjectData[weapon_name]
			else:
				object_data = Reference.DefaultObjectData[wp.Kind]
			
			if not object_data[0]==Reference.OBJ_BOW:
				return object_data[5][0]
				break
		else:
			return None
	
	
###########################################################################################################################################################
###### Arms


def  GetNewShield(EntityName,ShieldName):
	per=Bladex.GetEntity(EntityName)
	inv=per.GetInventory()
	nshd=Bladex.GetEntity(ShieldName)
	inv.LinkLeftHand(ShieldName)
	if inv.HoldingBow:
		# If you shot something, tough luck. No new shield
		return
	if per.Kind in ("Ork","Great_Ork","Knight_Traitor","Dark_Knight"):
		# These races have no change left anim 
		return
	per.Wuea=Reference.WUEA_ENDED	
	per.InterruptCombat()	
	per.LaunchAnmType("Chg_l")
	


def  GetNewWeapon(EntityName,WeaponName):
	per=Bladex.GetEntity(EntityName)
	inv=per.GetInventory()
	nwep=Bladex.GetEntity(WeaponName)
	owep=Bladex.GetEntity(per.InvRight)
	if inv.HoldingBow:
		# If you shot something, tough luck. No new weapon
		return
	if owep:
		per.Wuea=Reference.WUEA_ENDED	
		per.InterruptCombat()	
		per.LaunchAnmType("Chg_r_l")
		inv.LinkRightHand("")
		inv.RemoveWeapon(owep.Name)
		owep.Position=0,30000,0
		inv.LinkRightHand(WeaponName)


Weps={}  
Weps["Knight_Traitor"]=["Gladius","Maza","Hacha5","Espadaromana","Orksword","Orksword","Espadaelfica","Maza2","HookSword","KingSword","EgyptSword","Espadacurva","Dagesse","Cimitarra","Katana","Maza3","DoubleSword","DoubleSword","Espadafilo","Espada"]
Weps["Dark_Knight"]=   ["Gladius","Maza","Hacha5","Espadaromana","Orksword","Orksword","Espadaelfica","Maza2","HookSword","KingSword","EgyptSword","Espadacurva","Dagesse","Cimitarra","Katana","Maza3","DoubleSword","DoubleSword","Espadafilo","Espada"]
Weps["Goblin_A"]=      ["HookSword","HookSword","HookSword","HookSword","Hacha4","HookSword","Maza2","Maza2","Hacha6","Hacha6","Hacha6","Hacha6","Hacha6","Hacha6","Hacha6","Hacha6","Hacha6","Hacha6","Hacha6","Hacha6"]
Weps["Skeleton"]=      ["Gladius","Maza","Hacha5","Espadaromana","Hacha4","Espadaelfica","Hacha5","Maza2","HookSword","KingSword","EgyptSword","Espadacurva","Dagesse","Cimitarra","Katana","Maza3","DoubleSword","DoubleSword","Espadafilo","Espada"]



Shields=["Escudo5","Escudo5","Escudo2","Escudo2","Escudo1","Escudo1","Escudo1","KingShield","KingShield","KingShield","Escudo8","Escudo8","Escudo9","Escudo9","Escudo3","Escudo4","Escudo4","Escudo7","Escudo6","Escudo6"]

EnemyShieldholders=["Ork","Great_Ork","Knight_Traitor","Dark_Knight","Skeleton"]

############################################################################################################################################################
# LevelUp Functions. To set existing weapon damage as per Level or to switch weapons for more powerful one and replace broken shields.

def EnemyLevelUpFunc(EntityName):
	print EntityName+" I have leveled up"
	PlayerTypes.CheckHighestLevel(EntityName)
	global Weps
	global Shields
	global EnemyShieldholders
	per=Bladex.GetEntity(EntityName)
	if per.Life>0:
		lvl=per.Level
		inv=per.GetInventory()
		if lvl>19:
			NEWWPTYPE=Weps[per.Kind][19]
		else:
			NEWWPTYPE=Weps[per.Kind][lvl]
		newwp=Bladex.CreateEntity(EntityName+"_Weapon_Level"+`lvl`,NEWWPTYPE,0,40000,0,"Weapon")
		ItemTypes.ItemDefaultFuncs(newwp)
		flag=Reference.GiveWeaponFlag(newwp.Name)
		per.Data.RegisterObjectAsTaken(newwp.Name)
		inv.AddWeapon(newwp.Name,flag)
		Bladex.AddScheduledFunc(Bladex.GetTime()+ 1.5, GetNewWeapon, (EntityName,newwp.Name,))
		sh=Bladex.GetEntity(per.InvLeft)
		# only get a new shield if you have broken the old one
		if not sh and per.Kind in EnemyShieldholders:
			if lvl>19:
				NEWSHTYPE=Shields[19]
			else:
				NEWSHTYPE=Shields[lvl]
			newsh=Bladex.CreateEntity(EntityName+"_Shield_Level"+`lvl`,NEWSHTYPE,0,40000,0,"Weapon")
			ItemTypes.ItemDefaultFuncs(newsh)
			inv.AddShield(newsh.Name)
			Bladex.AddScheduledFunc(Bladex.GetTime()+ 2.5, GetNewShield, (EntityName,newsh.Name,))

						
	
###########################################################################################################################################################
############################# Base Enemy Class ####


class EnemyChar (Enm_Def.NPCPerson):

	DeathFunc=None
	DeathArgs=()
	LevelupFunc=None
	LevelupArgs=()
	NPCLevelUpParticleData=[]
	NameOfEnemy=None
	Dusted=1
	AttackOnSight=1

	def __init__(self, me):
		Enm_Def.NPCPerson.__init__(self, me)
		
		me.ImDeadFunc=self.NewImDeadFunc
		self.AttackOnSight=1
		self.NPCLevelUpParticleData=[]
		
		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 
				aux=traux**0.5
			else:
				traux=i/25.0 
				aux=traux**2.0
			r=255
			g=255
			b=255
			a=255.0*traux
			size=200.0*aux
			self.NPCLevelUpParticleData.append(a)
			self.NPCLevelUpParticleData.append(size)
			Bladex.SetParticleGVal("NPCLevelUpParticle",i,r,g,b,a,size)
			
		self.lupsnd1=Bladex.CreateSound("..\\..\\Sounds\\aparicion-escudo.wav", "LUPSnd1")
		self.lupsnd1.Volume=1.0
		self.lupsnd1.MinDistance=10000
		self.lupsnd1.MaxDistance=30000	
		
		
		
		
	def NewImDeadFunc (self,EntityName):
		print EntityName+": NEW ImDeadFunc"
		me = Bladex.GetEntity(EntityName)
		rwp=Bladex.GetEntity(me.InvRight)
		lwp=Bladex.GetEntity(me.InvLeft)
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		if self.Dusted:
			Bladex.AddScheduledFunc(Bladex.GetTime()+30,RemoveMyCorpse,(EntityName,100,0,))
			if rwp:
				Reference.EntitiesSelectionData[rwp.Name]=()
				Bladex.AddScheduledFunc(Bladex.GetTime()+35,RemoveMyWeapon,(rwp.Name,))
			if lwp:
				Reference.EntitiesSelectionData[lwp.Name]=()
				Bladex.AddScheduledFunc(Bladex.GetTime()+36,RemoveMyWeapon,(lwp.Name,))
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
			
		#nents= Bladex.nEntities()
		#for i in range(nents):
		#	ent= Bladex.GetEntity(i)
		#	if (ent.Person):
		#		if ent.Life>0:
		#			try:
		#				if ent.Data.EnemyName==EntityName:
		#					ent.Data.EnemyName=None
		#					ent.ResetChase()
		#			except AttributeError:
		#				pass
							

	def MutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		limb= Bladex.GetEntity(obj_name)
		InitDataField.Initialise(limb)
		Bladex.AddScheduledFunc(Bladex.GetTime()+20, RemoveMyWeapon,(obj_name,))
			
			
			
	def StdEnemyDead(self,EntityName):
		Enm_Def.NPCPerson.StdEnemyDead(self,EntityName)
		Reference.debugprint(EntityName+": My enemy is really dead.He he ! - py")
		if not self.MyGetEnemyName():
			self.LookForAnotherOpponent(EntityName)
		
	
	
	
	
	
	def StopNPCsAttacking (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			enemy=Bladex.GetEntity(self.MyGetEnemyName())
			self.StopAttackingNPC (EntityName)
			if enemy and enemy.Life > 0 and enemy.Data.NPC:
				enemy.Data.StopAttackingNPC (enemy.Name)	
	

	def StopAttackingNPC (self,EntityName):
		if self.AttackingNPC:
			me = Bladex.GetEntity(EntityName)
			if me and me.Life>0:
				
				enemy=Bladex.GetEntity(self.MyGetEnemyName())
				
				if not enemy or enemy.Data.NPC:
					enemy = Bladex.GetEntity("Player1")
					if not enemy:
						print EntityName+": Cannot access handle to Player, in StopAttackingNPC()"
						Bladex.AddScheduledFunc(Bladex.GetTime() + self.AttackNPCTime, self.StopNPCsAttacking,(EntityName,))
						return
					
					Damage.DropInvalidObjectsOnImpact (EntityName)
					me.Wuea=Reference.WUEA_ENDED
					me.InterruptCombat()
					if me.SetEnemy(enemy):
						self.AttackingNPC=FALSE
						MaxCombatDist = Bladex.GetCharType(me.CharType,me.CharTypeExt).MaxCombatDist
						if me.SQDistance2(enemy) < (MaxCombatDist*MaxCombatDist) or me.CanISee(enemy):
							me.SetActiveEnemy(enemy)
							me.Chase(enemy, me.ActionAreaMax)
							if me.GetActionMode()==Enm_Def.ROUTE_CHASE and self.IsArcher():
								self.Switch2MeleeWeapons(EntityName)
						else:
							me.LaunchWatch()
							Damage.DropInvalidObjectsOnImpact (EntityName)
							me.Wuea=Reference.WUEA_ENDED
							me.LaunchAnmType("attack_look",1)
						self.CheckToJoin (EntityName)
					else:
						print EntityName+": Cannot SetEnemy to Player, in StopAttackingNPC()"
						Bladex.AddScheduledFunc(Bladex.GetTime() + self.AttackNPCTime, self.StopNPCsAttacking,(EntityName,))
						return	


	def LaunchMyWatch(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me and me.Life > 0:
			#possenemy=self.MyGetEnemyName()
			#if possenemy:
			#	enemy=Bladex.GetEntity(self.MyGetEnemyName())
			
			#if not enemy or not me.CanISee(enemy):
			#	me.StopLooking()
			#Just in case . This is the best place 4 this
			me.GoToJogging=0
			me.GoToSneaking=0
			me.LaunchWatch()

	
	def StdEndChase2(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		# Check I'm not dead
		if me and me.Life > 0:
			Reference.debugprint(EntityName + ": I have ended a chase without combat (StdEndChase2)")
			me.RouteEndedFunc=self.StdRouteEnded
			me.StopLooking()
			self.InvestigatingSound = FALSE
			enemy=Bladex.GetEntity(self.MyGetEnemyName())
			if not enemy:
				return
			enemy_in_sight = enemy and me.CanISee(enemy)
			if enemy_in_sight and enemy.InsideActionArea(me.ActionAreaMax):
				if Actions.IsFacingEntity(EntityName, self.NameOfEnemy):
					self.LaunchMyWatch (EntityName)
				else:
					Actions.TurnToFaceEntity(EntityName, self.NameOfEnemy)
					me.RouteEndedFunc=self.LaunchMyWatch
			else:		
				if enemy_in_sight:
					self.StdSeeEnemyUnreachable (EntityName)
				else:
					Damage.DropInvalidObjectsOnImpact (EntityName)
					me.Wuea=Reference.WUEA_ENDED
					if me.GetActionMode() != Enm_Def.ROUTE_WATCH:
						self.LaunchMyWatch (EntityName)
					me.LaunchAnmType("look_around",1)
				# The enemy has disappeared for us around here
				# If we cannot find him, change our behaviour from the standard no seen function
				me.DelayNoSeenFunc=self.EndChaseDelayNoSeen
				if me.Data.imusic_noseen_warp==1:
					DMusic.RestoreMusicWarperDelayNoSeenFunc(EntityName)
								
						
	
	def StdStartChase2(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		enemy=Bladex.GetEntity(self.MyGetEnemyName())
		
		oldActionMode = me.GetActionMode()		
		if (oldActionMode == Enm_Def.ROUTE_WATCH) or (oldActionMode == Enm_Def.ROUTE_BOWING):
			# We could have got here after turning, so reset the RouteEndedFunc.
			me.RouteEndedFunc=self.StdRouteEnded
		if oldActionMode == Enm_Def.ROUTE_CHASE:
			pass
		else:
			self.ResetCombat(EntityName)
			last_time_seen=me.LastTimeSeen       #Note that the "Chase" function updates the LastSeenTime!
			me.Chase(enemy, me.ActionAreaMax)
			if me.GetActionMode()==Enm_Def.ROUTE_CHASE:
				if self.IsArcher():
					self.Switch2MeleeWeapons(EntityName)
				else:
					if Bladex.GetTime()-last_time_seen>40 or last_time_seen<0:
						me.LaunchAnmType("alarm01",1)
					#else:
					#	print "Too early to alarm..." + str(me.LastTimeSeen)

				self.InvestigatingSound = FALSE
				me.RouteEndedFunc=self.StdEndChase 
				if me.Aim or Actions.CurrentlyBowing(EntityName):
					me.Wuea=Reference.WUEA_ENDED
					Actions.EndBowMode(EntityName)
			else:
				self.StdChaseFailed (EntityName, oldActionMode)
	
	
	def StdStartChase(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if not self.NameOfEnemy:
			enemy=Bladex.GetEntity(self.MyGetEnemyName())
		else:
			enemy=Bladex.GetEntity(self.NameOfEnemy)
		if not enemy:
			return
		me.AnmEndedFunc=self.StdAnmEnded
		if enemy.InsideActionArea(me.ActionAreaMax) or (self.IsArcher() and me.InsideActionArea(me.ActionAreaMax)):
			if not IsHoldingBow(enemy.Name):
				self.StdStartChase2 (EntityName)
				if self.NameOfEnemy:
					print EntityName+" I am chasing "+self.NameOfEnemy
		else:
			# The following is to turn to face the enemy when we are already at an illegal border
			self.StdSeeEnemyUnreachable (EntityName)	
		
		

	def StdSeeEnemyUnreachable(self,EntityName,check1aaTo2aa=1):
		me = Bladex.GetEntity(EntityName)
		Reference.debugprint(EntityName + ": Enemy Unreachable")
		
		if Bladex.GetTime()-self.LastThrownHurtTime<Enm_Def.THROWNHURTTIME_GAP:
			return
		if me.InsideActionArea(me.ActionAreaMin) and (check1aaTo2aa and not me.Will1aaTo2aa):

			if me.Data.goto_limit2aa:
				back_area_min=me.ActionAreaMin
				back_area_max=me.ActionAreaMax
				me.ActionAreaMin=0
				me.ActionAreaMax=0
				
				enemy=Bladex.GetEntity(self.MyGetEnemyName())
				
				if not enemy:
					return
				if enemy and IsHoldingBow(enemy.Name):
					print EntityName+" I am chasing an archer!!"
					return
				des_pos=enemy.Position
				me.GoToJogging=1
				if me.GoTo(des_pos[0],des_pos[1],des_pos[2]):
					me.ActionAreaMin=back_area_min
					me.ActionAreaMax=back_area_max
				else: 
					Reference.debugprint(EntityName + ": GoTo enemy_pos not working, with action area 0!")
					me.ActionAreaMin=back_area_min
					me.ActionAreaMax=back_area_max
			return

		elif me.InsideActionArea(me.ActionAreaMin):
			if me.GetActionMode() != Enm_Def.ROUTE_WATCH:
				self.LaunchMyWatch (EntityName)
			if not self.NameOfEnemy:
				enemy=Bladex.GetEntity(self.MyGetEnemyName())
			else:
				enemy=Bladex.GetEntity(self.NameOfEnemy)
			if not enemy:
				return
			if not Actions.IsFacingEntity(EntityName, self.NameOfEnemy):
				Actions.TurnToFaceEntity(EntityName, self.NameOfEnemy)
			else:
				curr_time=Bladex.GetTime()
				if curr_time-self.last_insulting_time_1AA>4:
					insult_prob=whrandom.uniform(0.0, 1.0)
					if insult_prob<0.8:
						Combat.Insult(EntityName)
					insult_var=whrandom.uniform(-2.0, 1.0)
					self.last_insulting_time_1AA=Bladex.GetTime()+insult_var
		else:
			back_area_min=me.ActionAreaMin
			back_area_max=me.ActionAreaMax
			me.ActionAreaMax= 0
			me.ActionAreaMin= 0
			
			init_pos=me.InitPos
			me.InvertedRoute=1 # Move backwards
			if me.GoTo(init_pos[0],init_pos[1],init_pos[2]):
				me.ActionAreaMin=back_area_min
				me.ActionAreaMax=back_area_max
			else:
				Reference.debugprint(EntityName + ": GoTo init_pos not working, with action area 0!")
				me.ActionAreaMin=back_area_min
				me.ActionAreaMax=back_area_max
		
		
		

	def StdChaseFailed(self,EntityName, oldActionMode):	# Try to restore our state to whatever we were doing before attempting to chase	
		me = Bladex.GetEntity(EntityName)
		newActionMode = me.GetActionMode()
		if newActionMode == Enm_Def.ROUTE_BOWING:
			Reference.debugprint(EntityName + ": I cannot start a chase so I will bow")	
			pass
		#NOTA : R_WATCH incluye _BAY (al fallar un GoTo desde una W_BAY se pasa AUTOMATICAMEnTE a watch!!!)
		elif oldActionMode == Enm_Def.ROUTE_WATCH:
			Reference.debugprint(EntityName + ": I cannot start a chase so I will watch again")
			self.LaunchMyWatch(EntityName)

			enemy=Bladex.GetEntity(self.MyGetEnemyName())
			
			if enemy and me.CanISee(enemy) and me.InsideActionArea(me.ActionAreaMin):
				inv = me.GetInventory()
				if inv.HasBow and me.RangeActive:
					#print "StdChaseFailed-> Just facing due to carry bow"
					enemy_pos=me.EnemyLastSeen
					if not Actions.IsFacingPos(EntityName, enemy_pos[0], enemy_pos[2]):
						Actions.TurnToFacePos(EntityName, enemy_pos[0], enemy_pos[2])
				else:
					self.StdSeeEnemyUnreachable (EntityName,0)



	def StdHearFunc(self,EntityName, SoundName, x, y, z, Volume):
		me = Bladex.GetEntity(EntityName)
		if me and Bladex.InsideActionArea(me.ActionAreaMax, x , y , z)==0:
			return
		if me and me.Life > 0 and me.Deaf<>1:
			# Is the sound below audible range
			if Volume < Bladex.GetCharType(me.CharType,me.CharTypeExt).HearMinVolume:
				return
			# No need to bother responding if we're already in combat
			if me.InCombat:
				return
			sound_type= self.GetSoundType(SoundName)
			# Is the sound unknown
			if sound_type==Reference.SND_UNCLASSIFIED:
				return
			# If our enemy is dead, don't bother going to investigate
			if self.NameOfEnemy:
				enemy=Bladex.GetEntity(self.NameOfEnemy)
			else:
				if self.MyGetEnemyName()!= None:
					enemy=Bladex.GetEntity(self.MyGetEnemyName())
				else:
					return
			
			if (not enemy) or (not enemy.Person) or enemy.Life <= 0:
					return
					
			# for footsteps etc, Check they belong to the player, not realistic, but quick
			if sound_type==Reference.SND_NOISYPC:
				if enemy.LastSound != SoundName:
					return
					
				elsp= enemy.LastSoundPosition
				if elsp[0]!= x or elsp[1]!=y or elsp[2]!=z:
					return
				
			# Was the sound generated by oureself
				
			if me.LastSound==SoundName:
				lsp= me.LastSoundPosition
				if lsp[0]== x and lsp[1]==y and lsp[2]==z:
					return
				
			# Is the sound from our last thrown hurt ?
			if Bladex.GetTime()-self.LastThrownHurtTime<Enm_Def.THROWNHURTTIME_GAP*0.5:
				return	
				
			# The see functions will take care of this
			if me.CanISee(enemy):
				return
			if self.Asleep:
				self.WakeMeUp(EntityName)

			if me.GetActionMode() == Enm_Def.ROUTE_BAY and not me.CanGoTo(x,y,z):
				return 
			if self.group_leader:
				# record that we have dealt with the sound
				self.DealtWithSound= SoundName
				self.DealtWithSoundX= x
				self.DealtWithSoundY= y
				self.DealtWithSoundZ= z
					
				# Assign an investigator
				investigator = self.GetGroupFighter(EntityName)
				if (not investigator) or (investigator.Name != me.Name):
					if (not investigator) or investigator.GetActionMode()==Enm_Def.ROUTE_CHASE or investigator.InCombat or not investigator.CanGoTo(x,y,z):
						investigator = me
			else:
				group_leader = self.GetGroupLeader(EntityName)
				if group_leader and not (group_leader.InCombat or group_leader.GetActionMode()==Enm_Def.ROUTE_CHASE):
					# does the leader know already?
					try:
						ldr_data= group_leader.Data
						if SoundName==ldr_data.DealtWithSound and x==ldr_data.DealtWithSoundX and y==ldr_data.DealtWithSoundY and z==ldr_data.DealtWithSoundZ:
							return
					except:
						pass
					group_leader.HearFunc(group_leader.Name, SoundName, x, y, z, Volume)
					# leader will tell investigator what to do
					# but we can take the initiative to turn around
					if (not me.InCombat) and (me.GetActionMode()!=Enm_Def.ROUTE_CHASE):
						if not Actions.IsFacingPos(EntityName, x, z):
							Actions.QuickTurnToFacePos(EntityName, x, z)
					return
				else:
					# leader is busy, investigate ourself
					investigator = me
	
			if investigator.Data.InvestigatingSound and SoundName == investigator.Data.InvestigatingSoundName and x == investigator.Data.InvestigatingSoundX and y == investigator.Data.InvestigatingSoundY and z == investigator.Data.InvestigatingSoundZ:
				# investigator is already investigating this sound		
				return 
			elif investigator.Data.IsSoundHigherPriority(investigator.Name, SoundName, Volume) and investigator.GetActionMode()!=Enm_Def.ROUTE_CHASE and not investigator.InCombat:
				me.StartLooking(x, y, z)
	
				# Turn to face the sound
				if not Actions.IsFacingPos(EntityName, x, z):
					Actions.QuickTurnToFacePos(EntityName, x, z)

				# React to the sound, with alarm
				if investigator.Name != EntityName: 
					# Tell investigator to turn to face the sound
					if not Actions.IsFacingPos(investigator.Name, x, z):
						Actions.QuickTurnToFacePos(investigator.Name, x, z)
						
					if (not investigator.Data.InvestigatingSound):
						if (me.AnimName[:4] != "hurt" and me.AnimName[:5] != "sleep"):
							if investigator.Data.CanGoTo(investigator.Name, x, y, z):
								me.Wuea=Reference.WUEA_ENDED
								me.SetTmpAnmFlags(1,0,1,0,1,1) 
								me.LaunchAnmType("alarm01",1)
	
				# Send off fighter to investigate
				investigator.Data.InvestigatingSound = TRUE
				investigator.Data.InvestigatingSoundName = SoundName
				investigator.Data.InvestigatingSoundVolume = Volume
				investigator.Data.InvestigatingSoundX = x
				investigator.Data.InvestigatingSoundY = y
				investigator.Data.InvestigatingSoundZ = z
	
				if me.AnimName=="alarm01":
					if EntityName != investigator.Name:
						self.NextOrdersTo = []
						self.NextOrdersTo.append(investigator.Name)
						self.NextOrders = investigator.Data.StdInvestigateSound
						me.AnmEndedFunc=self.GiveOrders
					else:
						me.AnmEndedFunc=self.StdInvestigateSound
				else:
					if EntityName != investigator.Name:
						self.NextOrdersTo = []
						self.NextOrdersTo.append(investigator.Name)
						self.NextOrders = investigator.Data.StdInvestigateSound
						self.GiveOrders (EntityName)
					else:
						self.StdInvestigateSound (EntityName)

	
	
	def StdEnemyNoAllowedArea(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		enemy=Bladex.GetEntity(self.MyGetEnemyName())
		
		if me.GetActionMode()<>Enm_Def.ROUTE_CHASE:
			return
		init_pos=me.InitPos
		if (not me.InsideActionArea(me.ActionAreaMin)) and me.InsideActionArea(me.ActionAreaMax):
			me.InvertedRoute=1
		else:
			me.InvertedRoute=0
		me.GoTo(init_pos[0],init_pos[1],init_pos[2])####################### do I want this???
		Reference.debugprint(EntityName + ": My enemy has entered a non-allowed area")
	
	
	
	def CheckGoodGroupFormation(self,EntityName, include_me):
		me = Bladex.GetEntity(EntityName)

		if me.CombatGroup:
			memberlist = me.GetGroupMembers()
			if len(memberlist) > 1:
				fighter_found = None
				leader_found = None
				
				enemy=Bladex.GetEntity(self.MyGetEnemyName())
				
				if not enemy:
					return
				for member_name in memberlist:
					if include_me or member_name != EntityName:
						member = Bladex.GetEntity (member_name)

						if (not leader_found) and member and member.Data.group_leader and member.Life > 0:
							if (not member.Data.group_fighter) and (not member.Data.Furious):
								member.CombatDistFlag = 1
							leader_found = member.Name
						else:
							member.Data.group_leader = FALSE

						if (not fighter_found) and member and member.Data.group_fighter and member.Life > 0 and enemy and member.CanISee(enemy):
							member.CombatDistFlag = 0
							fighter_found = member.Name
						else:
							if member.Data.group_fighter:
								if not member.Data.Furious:
									member.CombatDistFlag = 1
								member.Data.group_fighter = FALSE

				if fighter_found and leader_found and (fighter_found != leader_found):
					return

				# If we get to this point then we're either missing a group leader or a group fighter
				self.SetGroupFormation (EntityName, include_me, not leader_found)
	
			else:
				if include_me:
					self.group_leader= TRUE
					self.group_fighter= TRUE
					me.CombatDistFlag= 0
				return	
	

	def Respond2Thrown(self, EntityName, AttackerName):
		me = Bladex.GetEntity(EntityName)
		if self.Asleep:
			self.WakeMeUp(EntityName)
		if AttackerName:
			enemy=Bladex.GetEntity(self.MyGetEnemyName())
			if enemy and not enemy.InsideActionArea(me.ActionAreaMax):
				self.LastThrownHurtTime=Bladex.GetTime()
				init_pos=me.InitPos
				me.InvertedRoute=0 #Just in case
				me.GoToJogging=1
				if me.GoTo(init_pos[0],init_pos[1],init_pos[2]):
					me.RouteEndedFunc= self.Turn180AndWatch
			else:
				if me.GetActionMode() == Enm_Def.ROUTE_WATCH:
					#print "FIX?"
					Actions.QuickTurnToFaceEntity(EntityName,AttackerName)
				else:
					print "Respond2Thrown->Bug?"
	

	def Switch2MeleeWeapons(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me and me.Life > 0 and not me.RangeActive:
			inv= me.GetInventory()
			right_type= Reference.GiveObjectFlag(me.InvRight)
						
			# Do we have an item in the hand we can fight with			
			if inv.HoldingBow or not (right_type== Reference.OBJ_STANDARD or right_type== Reference.OBJ_WEAPON):
				# Don't change if the enemy is unreachable
				enemy=Bladex.GetEntity(self.MyGetEnemyName())
				if me.AstarState!=Enm_Def.ASTAR_NOSOLVED:
					me.SwitchTo1H()
					weapon_name= inv.GetSelectedWeapon()
					if weapon_name and (weapon_name != me.InvRight and weapon_name != me.InvLeft):
						# Launch the swap weapons animation
						out= ScorerActions.CB_WeaponOutX(EntityName,0)
						if not out:
							me.AnmEndedFunc= ScorerActions.CB_WeaponOutX
						Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, self.Switch2MeleeWeapons,(EntityName,),EntityName+"ReSwitch2MeleeWeapons")
					Actions.EndBowMode(EntityName)


	
	def OnKilledEnemy(self,KilledEntityName):
		print "Enemy Leveling up"
		KilledEntity=Bladex.GetEntity(KilledEntityName)
		if KilledEntity is None:
			return
		me=Bladex.GetEntity(self.Name)
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, self.LookForAnotherOpponent,(self.Name,))
		me.PartialLevel=me.PartialLevel+CharStats.GetCharExperienceReward(KilledEntity.CharType,KilledEntity.Level)
		LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
		if me.PartialLevel>=LevelLimit and me.Life>0:
			while me.PartialLevel>=LevelLimit:
				me.PartialLevel=me.PartialLevel-LevelLimit
				me.Level=me.Level+1
				LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
			maxlevel=CharStats.GetMaxLevel()
			maxsize=50+(140/maxlevel)*me.Level 
			maxPPS=120+(600/maxlevel)*me.Level 
			maxint=0.5+(4.5/maxlevel)*me.Level 
			AuraParams=(5, 0, 1, 0, 0, 1)
			AuraGradient=(2, 0.4, 0.6, 1.0, 0.5, 0.0, 0.1, 0.2, 1.0, 0.0, 0.8)
			AuraVar1Args=(5, maxsize, 0, 1, 0.5)
			AuraVar2Args=(maxsize, 5, 1, 0, 1.0)
			print "Levelup PS params set"
			PSParams=(self.NPCLevelUpParticleData, "NPCLevelUpParticle", 30, 50, 150, 255, maxPPS, -600, 0.0, 2, 2, 0.4, 30, 0.5)
			GenFX.LevelUpFX(me.Name, 1, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, maxint, "Timer15", 15)
			if me.Life >0: # If an enemy death by poison or trowed weapons and.. You are death!
				me.ResetWounds()
				me.Life = CharStats.GetCharMaxLife(me.Kind, me.Level)
			self.lupsnd1.Play(me.Position[0],me.Position[1],me.Position[2],0)
			if self.LevelupFunc:
				apply(self.LevelupFunc,self.LevelupArgs)
			
						

			
				
	def MyGetEnemyName (self):
		me=Bladex.GetEntity(self.Name)
	        if not self.NameOfEnemy or Bladex.GetEntity(self.NameOfEnemy).Life <=0:
                   	pjp = me.Position
		   	enemyList=[]
		   	pj_dir=me.Rel2AbsVector(0.0,-1.0,0.0)
			pjp=me.Position
			for ename in Bladex.GetEnemiesVisibleFrom(pjp,50000,pj_dir,0.0):
                       		ene=Bladex.GetEntity(ename)
                       		if self.IsValidEnemy(ene):
                         		enemyList.append(ene.Name)
                   	if len (enemyList) == 0: 
                   		char=Bladex.GetEntity("Player1")
                   		if me.CanISee(char) and self.AttackOnSight:
	  				self.NameOfEnemy="Player1"
                   			enemy=Bladex.GetEntity(self.NameOfEnemy)
                			me.SetEnemy(enemy)
					return self.NameOfEnemy			
                   		else:
                   			return None
                   	enemyList.sort(self.ChooseNearest)
                   	self.NameOfEnemy=enemyList[0]
		enemy=Bladex.GetEntity(self.NameOfEnemy)
                me.SetEnemy(enemy)
		return self.NameOfEnemy			
				
				
		
	def IsValidEnemy (self, entity):
		me=Bladex.GetEntity(self.Name)
		if not self.AttackOnSight:
			return FALSE
		
		if not entity.Person: 
			return FALSE
		if not entity.Life > 0:
			return FALSE
		if entity.Alpha<0.9:
			return FALSE
		if entity.Kind=="LookoutMan":
			return FALSE
		if entity.Name == self.Name:
			return FALSE
		if entity.Kind==me.Kind:
			return FALSE
		if IsHoldingBow(entity.Name):
			return FALSE
		if  CheckIfEnemy(entity.Name): 
			return TRUE
		else:
			return FALSE
			

	def ChooseNearest (self,entity1name, entity2name):
		p1 = Bladex.GetEntity(entity1name)
		p2 = Bladex.GetEntity(entity2name)
		if not p1 and not p2:
			return CHOOSE_EITHER
		elif not p1:
			return CHOOSE_SECOND
		elif not p2:
			return CHOOSE_FIRST
		me=Bladex.GetEntity(self.Name)
		val = me.SQDistance2(p1) - me.SQDistance2(p2)
		if val < 0:
			return CHOOSE_FIRST
		elif val > 0:
			return CHOOSE_SECOND
		else:
			return CHOOSE_EITHER


	def StdSeeTheEnemy(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		life = me.Life
		if life > 0.0:		
			if not self.MyGetEnemyName(): 
				return
			Reference.debugprint (EntityName + ": I spy a GOOD guy")
			ene=Bladex.GetEntity(self.MyGetEnemyName())
			if ene:
				if self.IsValidEnemy(ene):
					Reference.debugprint (EntityName + ": Your Name is "+ene.Name+ " I will do you over")
					if self.Asleep:
						self.WakeMeUp(EntityName)
				me.LookAtEntity(ene.Name)
				#Just in case we were doing a wait animation
				if me.GetActionMode() == Enm_Def.ROUTE_BAY:	
					me.Wuea=Reference.WUEA_ENDED

				self.CheckToJoin(EntityName)
				if me.GetActionMode()!=Enm_Def.ROUTE_CHASE:
					self.StdStartChase(EntityName)
				
				if me.GetActionMode()==Enm_Def.ROUTE_BOWING: 
					if self.AimPressed:
						angle= Reference.TARGET_ANGLE_MAX- me.Accuracy*(Reference.TARGET_ANGLE_MAX-Reference.TARGET_ANGLE_MIN)
						if me.AimOffTarget<angle:
							print "Releasing Arrow"
							Actions.TestReleaseArrow(EntityName)
					else: 
						if me.Wuea!=Reference.WUEA_WAIT:
							#print "Drawing Bow"
							Actions.TestDrawBow (EntityName)
				elif me.Aim or Actions.CurrentlyBowing(EntityName):
					me.Wuea=Reference.WUEA_ENDED
					Actions.EndBowMode(EntityName)
					me.SetOnFloor()




					
	def RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded):
		# launch appropriate hurt anim
		if self.Asleep:
			self.WakeMeUp(EntityName)
		if not self.AttackOnSight:
			self.AttackOnSight=1
		Basic_Funcs.PlayerPerson.RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded)
		
		if AttackerName and AttackerName != 'BWorld' and AttackerName != EntityName:
			me = Bladex.GetEntity(EntityName)
			if me and me.Life > 0:
				#####################################################################
				# consider getting furious
				chartype = Bladex.GetCharType(me.CharType,me.CharTypeExt)
				if me.Life <= CharStats.GetCharMaxLife(me.Kind, me.Level)*0.25 and whrandom.random() < self.ChanceOfFuryOnHurt:
					self.GetFurious (EntityName)
				# consider attacking attacker back
				#damage_factor = DamagePoints / (me.Life+DamagePoints)
				#if damage_factor > me.Data.DamageFactorNone:
				#	# Only if I'm still alive... Death events handled apart
				####################################################################
				#Reference.debugprint(EntityName+": Im being attacked by "+AttackerName)
					
				if self.NameOfEnemy and self.NameOfEnemy != AttackerName:
					#Reference.debugprint(AttackerName+": Is NOT my current enemy")
					attacker = Bladex.GetEntity(AttackerName)
					##########################################
					if IsHoldingBow(AttackerName):
						print EntityName+" My Enemy is an Archer"
						return
					
					if attacker and (self.AttacksOwnKind or attacker.Kind != me.Kind):
						
						Reference.debugprint(EntityName+": I will respond")
						# Only attack NPCs if not already, otherwise we get multiple scheduled funcs
						if (not attacker.Data.NPC) or (not self.AttackingNPC):
							#Reference.debugprint("attacker.Data.NPC: "+ `attacker.Data.NPC`+ ", self.AttackingNPC: " + `self.AttackingNPC`)
								
							Damage.DropInvalidObjectsOnImpact (EntityName)
							me.Wuea=Reference.WUEA_ENDED
							me.InterruptCombat()
							me.SetEnemy(attacker)
							me.SetActiveEnemy(attacker)
							me.Chase(attacker, me.ActionAreaMax)
							if me.GetActionMode()==Enm_Def.ROUTE_CHASE and self.IsArcher():
								self.Switch2MeleeWeapons(EntityName)		
	
				
	def StdDelayNoSeen(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me.Life > 0:
			if (not self.Asleep) and (not me.Blind):
				if me.Aim or Actions.CurrentlyBowing(EntityName):
					me.Wuea=Reference.WUEA_ENDED
					Actions.EndBowMode(EntityName)
					me.SetOnFloor()
				me.StopLooking()
				self.PutMeToSleep(EntityName)
				if not self.NameOfEnemy:
					self.LookForAnotherOpponent(EntityName)
				Reference.debugprint(EntityName+": I have got bored and dropped to sleep")
				
							
				
				
	def LookForAnotherOpponent(self,EntityName):
		Reference.debugprint(EntityName+": I am looking for another opponent")
		me = Bladex.GetEntity(EntityName)
		if me.InCombat:
			return
		mep=me.Position
		enelist=[]
		ents=Bladex.GetEntitiesAt(mep[0],mep[1],mep[2], 30000)
		for ename in ents:
			en=Bladex.GetEntity(ename)
			if en.Person:
				if self.IsValidEnemy(en) and en.Name != me.Name:
					enelist.append(en.Name)
		if len (enelist) == 0: 
                   	return 
                enelist.sort(self.ChooseNearest)
                nearest=Bladex.GetEntity(enelist[0])
                if nearest:
			me.GoToJogging=0
			me.GoTo(nearest.Position[0],nearest.Position[1],nearest.Position[2])
			if me.AstarState==Enm_Def.ASTAR_SOLVED:
				me.LaunchWatch()
			print EntityName+" I have found a new enemy and I am going to sort the bugger out "
					
                    				
		       			

	def ResetCombat (self,EntityName):		
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttackNPCTime = 100
	
	
	def PutMeToSleep(self,EntityName):
		if not self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=1  
			me.Deaf=1
			self.Asleep = TRUE


	def WakeMeUp(self,EntityName):
		if self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=0  
			me.Deaf=0
			self.Asleep = FALSE
			
		
				
	
	# Functions for loading and saving state
	def __getstate__(self):	
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["EnemyChar"]=(GameStateAux.SaveFunctionAux(self.DeathFunc),
		                                 self.DeathArgs,
		                                 GameStateAux.SaveFunctionAux(self.LevelupFunc),
		                                 self.LevelupArgs,
		                                 self.NameOfEnemy,
						 self.Dusted,
						 self.AttackOnSight)
		return NPCPerson_state
	
	
	def __setstate__(self,parm):
		Enm_Def.NPCPerson.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["EnemyChar"]
			GameStateAux.LoadFunctionAux(parms[0],self,"DeathFunc")
			self.DeathArgs=parms[1]
			GameStateAux.LoadFunctionAux(parms[2],self,"LevelupFunc")
			self.LevelupArgs=parms[3]
			self.NameOfEnemy=parms[4]
			self.Dusted=parms[5]
			self.AttackOnSight=parms[6]
		self.NPCLevelUpParticleData=[]
		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 
				aux=traux**0.5
			else:
				traux=i/25.0 
				aux=traux**2.0
			r=255
			g=255
			b=255
			a=255.0*traux
			size=200.0*aux
			self.NPCLevelUpParticleData.append(a)
			self.NPCLevelUpParticleData.append(size)
		Bladex.SetParticleGVal("NPCLevelUpParticle",i,r,g,b,a,size)
		me=Bladex.GetEntity(self.Name)
		
				
		self.lupsnd1=Bladex.CreateSound("..\\..\\Sounds\\aparicion-escudo.wav", "LUPSnd1")
		self.lupsnd1.Volume=1.0
		self.lupsnd1.MinDistance=10000
		self.lupsnd1.MaxDistance=30000	
		me.ImDeadFunc=self.NewImDeadFunc
		
		
##########################################################################################################################################################
#### Ras Skels


def SkelHelmetDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded):
		
	if WeaponName:	
		 if DamageZone==Reference.BODY_HEAD:
			print VictimName+": Hahahaha I have my helmet on!"
			return
	
	Damage.CalculateDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded)



def SkelArmourDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded):
		
	if WeaponName:	
		 if DamageZone in (Reference.BODY_FRONT, Reference.BODY_BACK):
		 	vict=Bladex.GetEntity(VictimName)
		 	vict.Wuea=Reference.WUEA_ENDED
			vict.InterruptCombat()
			vict.LaunchAnmType("hurt_f_big")
			print VictimName+": Hahahaha I an armoured!"
			return
	
	Damage.CalculateDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded)


class ArmouredSkeleton(EnemyChar):

	Helmet=0
	Bodyarmour=0
	Scaryhead=0
	headhitsnd=""

	def __init__(self, me):
				
		EnemyChar.__init__(self, me)

		self.SoundPriorities[Reference.SND_ARROW]   =  1.0
		self.SoundPriorities[Reference.SND_HIT]     =  1.0
		self.SoundPriorities[Reference.SND_NPC]     = -1.0
		self.SoundPriorities[Reference.SND_NOISYPC] =  3.0
		self.SoundPriorities[Reference.SND_PC]      =  2.0
		
		
		
		self.headhitsnd= Bladex.CreateSound ("..\\..\\Sounds\\golpe-arma-escudo.wav","SonidoHeadHit")
		self.headhitsnd.Volume=1
		self.headhitsnd.MinDistance=2000
		self.headhitsnd.MaxDistance=30000
		

		
	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosEsqueleto(EntityName)



	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			me.BlockingPropensity = 0.6
			me.AttackList = BCopy.deepcopy(Combat.SkeletonAttackData)


	def NewImDeadFunc (self,EntityName):
		print EntityName+": NEW ImDeadFunc"
		me = Bladex.GetEntity(EntityName)
		rwp=Bladex.GetEntity(me.InvRight)
		lwp=Bladex.GetEntity(me.InvLeft)
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		if self.Dusted:
			Bladex.AddScheduledFunc(Bladex.GetTime()+30,RemoveMyCorpse,(EntityName,100,0,))
			if rwp:
				Reference.EntitiesSelectionData[rwp.Name]=()
				Bladex.AddScheduledFunc(Bladex.GetTime()+35,RemoveMyWeapon,(rwp.Name,))
			if lwp:
				Reference.EntitiesSelectionData[lwp.Name]=()
				Bladex.AddScheduledFunc(Bladex.GetTime()+36,RemoveMyWeapon,(lwp.Name,))
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
		
		if self.Scaryhead==1:
			hed=Bladex.GetEntity(EntityName+"ScaryHead")
			Bladex.AddScheduledFunc(Bladex.GetTime()+10.6, RemoveMyWeapon,(hed.Name))
			print "El scaryhead se convertira en polvo"
		if self.Bodyarmour==1:
			arm=Bladex.GetEntity(EntityName+"Armour")
			Reference.DefaultSelectionData[arm.Name]=(0.0,0.0,"")
			Bladex.AddScheduledFunc(Bladex.GetTime()+10.6, RemoveMyWeapon,(arm.Name,))
			print "El armour se convertira en polvo"
		if self.Helmet==1:
			helm=Bladex.GetEntity(EntityName+"Helmet")
			Bladex.AddScheduledFunc(Bladex.GetTime()+10.6, RemoveMyWeapon,(helm.Name,))
			print "El casco se convertira en polvo"
		
			
			
	def RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded):
		me=Bladex.GetEntity(EntityName)
		if DamageZone==Reference.BODY_HEAD and self.Helmet==1:
			pos=me.Position
			self.headhitsnd.Play(pos[0],pos[1],pos[2],0)
			me.LaunchAnmType("hurt_f_head")
			#print EntityName+">>>Ha-ha! I have got my helmet on"
		else:
			Enm_Def.NPCPerson.RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded)
			
		
		
	def PutOnHelmet(self,EntityName,HelmetName="Casco2"):
		me=Bladex.GetEntity(EntityName)
		me.Freeze()
		angle=me.Angle
		pos=me.Position
		me.Position=62.7485260501,675.343174898,-381.317341156
		me.Angle=2.5
		helm=Bladex.CreateEntity(EntityName+"Helmet",HelmetName,9.63043254182,-131.191397578,-510.539000508,"Weapon")
		helm.Orientation=(0.66446274519,0.664463162422,0.24184525013,-0.24184460938)
		me.LinkToNode(helm, me.GetNodeIndex("Head"))
		me.Angle=angle
		me.Position=pos[0],pos[1],pos[2]
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.1,me.UnFreeze,())
		self.Helmet=1
		me.DamageFunc=SkelHelmetDamage
		

	def PutOnArmour(self,EntityName,ArmourName="Coraza2",ProtectionLevel=0):
		me=Bladex.GetEntity(EntityName)
		me.Freeze()
		angle=me.Angle
		pos=me.Position
		me.Position=62.7485260501,675.343174898,-381.317341156
		me.Angle=2.5
		arm=Bladex.CreateEntity(EntityName+"Armour",ArmourName,42.5946323512,204.519238525,-483.462570737,"Weapon")
		arm.Scale=0.8
		arm.Orientation=(0.409498900175,0.804671466351,0.226191207767,-0.365584492683)
		me.LinkToNode(arm, me.GetNodeIndex("Center"))
		me.Angle=angle
		me.Position=pos[0],pos[1],pos[2]
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.1,me.UnFreeze,())
		#arm.Data=Armour.SkeletonArmour(arm,me)
		self.Bodyarmour=1
		self.armour_prot_factor=ProtectionLevel # This may not be necessary. Range 0-80 for extra toughness# 
		me.DamageFunc=SkelArmourDamage


	def PutOnScaryHead(self,EntityName,HeadName="Cracorn1"):
		me=Bladex.GetEntity(EntityName)
		me.Freeze()
		me.SeverLimb(1)
		angle=me.Angle
		pos=me.Position
		me.Position=62.7485260501,675.343174898,-381.317341156
		me.Angle=2.5
		hed=Bladex.CreateEntity(EntityName+"ScaryHead",HeadName,9.63043254182,-71.1913975785,-530.539000508,"Physic")
		hed.Orientation=(0.914659142494,0.169081702828,0.360423415899,-0.0700359344482)
		hed.Scale=1.4
		me.LinkToNode(hed, me.GetNodeIndex("Head"))
		me.Angle=angle
		me.Position=pos[0],pos[1],pos[2]
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.1,me.UnFreeze,())
		self.Scaryhead=1
		
		
		
		
	def __getstate__(self):
		NPCPerson_state=EnemyChar.__getstate__(self)		
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["ArmouredSkeleton"]=(self.Helmet,self.Bodyarmour,self.Scaryhead,)
		return NPCPerson_state
		

	def __setstate__(self,parm):
		EnemyChar.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["ArmouredSkeleton"]
			self.Helmet=parms[0]
			self.Bodyarmour=parms[1]
			self.Scaryhead=parms[2]
			self.headhitsnd= Bladex.CreateSound ("..\\..\\Sounds\\golpe-arma-escudo.wav","SonidoHeadHit")
			self.headhitsnd.Volume=1
			self.headhitsnd.MinDistance=2000
			self.headhitsnd.MaxDistance=30000
			
			
#####################################################################################################################################################

"""



Bladex.AddParticleGType("DemonCloud","SmokePart3",Reference.B_PARTICLE_GTYPE_MUL,16)

for i in range(16):
	aux=(16.0-i)/16
	r=255
	g=255
	b=255
	a=0
	if aux < 0.5:
		size = aux*512
	else:
		size = (1-aux)*512
	Bladex.SetParticleGVal("DemonCloud",i,r,g,b,a,size)





	
	
	
	
	
Bladex.ReadBitMap("../../Maps/ProsperoArena1/NUFiles/NUVinc_AStuff/VincFireParticle.bmp","VincFireParticle")	
		
Bladex.AddParticleGType("VincFuegoInvocacion","VincFireParticle",Reference.B_PARTICLE_GTYPE_ADD,120)

for i in range(120):
	if i<40:
		traux=i/40.0 
	else:
		traux=1.0
	r=20
	g=10
	b=20
	a=255.0*traux
	
	size=400.0
	Bladex.SetParticleGVal("VincFuegoInvocacion",i,r,g,b,a,size)	




import AniSoundVinc
import VincCombosFX


class Vinculanus (EnemyChar):

	
	FadeOutTime= 5.00
	FadeInTime= 3.00
	TransitTime= 30.0
	Subordinates=[]
	OutOfAction=0
	HealUpFunc=None
	HidePosition=(0,30000,0)
	HealTime=100
	AgeNum=0
	AppearPosList=[]
	RespawnActive=0
	
	def __init__(self, me):
		EnemyChar.__init__(self, me)
		
		
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
	
		
		self.FadeOutTime= 5.00
		self.FadeInTime= 3.00
		self.TransitTime= 30.0
		self.Subordinates=[]
		self.OutOfAction=0
		self.HealUpFunc=None
		self.HidePosition=(0,30000,0)
		self.HealTime=100
		self.AgeNum=0
		self.AppearPosList=[]
		self.RespawnActive=0
		me.ImDeadFunc=self.VinImDeadFunc
	
		VincCombosFX.VinCombosFX(me.Name) 
		
		self.disappsound=Bladex.CreateSound("..\\..\\Sounds\\rugido-demon5.wav", "DisappSound")
		self.disappsound.Volume=1.0
		self.disappsound.MinDistance=10000
		self.disappsound.MaxDistance=30000
		
		self.disappsound2=Bladex.CreateSound("..\\..\\Sounds\\respiracion-SirCaos3.wav", "DisappSound2")
		self.disappsound2.Volume=1.0
		self.disappsound2.MinDistance=10000
		self.disappsound2.MaxDistance=30000
	
	
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		AniSoundVinc.AsignarSonidosVinculanus(EntityName)
		Bladex.ReadBitMap("../../Maps/ProsperoArena1/NUFiles/NUVinc_AStuff/boss.bmp","BossIcon")
		Reference.EnemiesScorerData[self.Name]=("BossIcon","Vin")
		
		
		
	def VinImDeadFunc (self,EntityName):
		print EntityName+": VinImDeadFunc"
		
		me = Bladex.GetEntity(EntityName)
		me.AnmEndedFunc=self.HideMeAway
		me.Wuea=Reference.WUEA_ENDED
		me.LaunchAnmType("vanish")
		me.CastShadows=0
		self.OutOfAction=1
		self.DeathBallBlack(EntityName)
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.3,self.DeathBall,(EntityName,))
		AuxFuncs.FadeObject(me.Name,1.0,0.0,self.FadeOutTime)
		if me.InvRight:
			rwp=Bladex.GetEntity(me.InvRight)
			rwp.CastShadows=0
			AuxFuncs.FadeObject(me.InvRight,1.0,0.0,self.FadeOutTime)
		if me.InvLeft:
			AuxFuncs.FadeObject(me.InvLeft,1.0,0.0,self.FadeOutTime)
			lwp=Bladex.GetEntity(me.InvLeft)
			lwp.CastShadows=0
		x,y,z=me.Position
		self.disappsound.Play(x,y,z,0)
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.4,self.disappsound2.Play,(x,y,z,0,))
		
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
		
			
			
	def MutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		limb= Bladex.GetEntity(obj_name)
		InitDataField.Initialise(limb)
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, RemoveMyWeapon,(obj_name,))
		

	def HideMeAway (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		me.Freeze()
		me.Position=self.HidePosition[0],self.HidePosition[1],self.HidePosition[2]
		me.AnmEndedFunc=None
		print "Boss in Hide Position"
		if self.RespawnActive and len(self.AppearPosList)!=0:
			Bladex.AddScheduledFunc(Bladex.GetTime()+self.TransitTime,self.Respawn,(EntityName,))
		
		
	
	# FX

	def DeathBall (self,EntityName):
		me  = Bladex.GetEntity(EntityName)
		x,y,z=me.Position
		ps=Bladex.CreateEntity(EntityName+"BolaFuego"+`self.AgeNum`, "Entity Particle System D1", x, y, z)
		ps.ParticleType="VincFuegoInvocacion"
		ps.PPS=250
		ps.YGravity=0.0
		ps.Friction=0.1
		ps.Velocity=0.0, 0.0, 0.0
		ps.RandomVelocity=50.0
		ps.Time2Live=40
		ps.DeathTime= Bladex.GetTime()+3.5
		self.AgeNum=self.AgeNum+1
		
		
	def DeathBallBlack(self, EntityName):
		bps=Bladex.CreateEntity(EntityName+"BolaSmoke"+`self.AgeNum`, "Entity Particle System Dperson", 0.0, 0.0, 0.0)
		bps.PersonName=EntityName
		bps.ParticleType="DemonCloud"
		bps.Time2Live=16
		bps.RandomVelocity=2.0
		bps.Velocity=0,0,0
		bps.NormalVelocity=20
		bps.YGravity=0
		bps.DeathTime=Bladex.GetTime()+3.5
		bps.PPS=1024
		
		
	def AppearsFX(self, EntityName):
		wps=Bladex.CreateEntity(EntityName+"WPS"+`self.AgeNum`, "Entity Particle System Dperson", 0.0, 0.0, 0.0)
		wps.PersonName=EntityName
		wps.ParticleType="EnergyConc"
		wps.Time2Live=60
		wps.RandomVelocity=0
		wps.Velocity=0,0,0
		wps.NormalVelocity=-5.0
		wps.YGravity=0
		wps.DeathTime=Bladex.GetTime()+1.5	
		wps.PPS=600
	
		
		
	def ImplosionDemonio (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		impl=Bladex.CreateEntity(me.Name+"ImplosionDemonio"+`self.AgeNum`, "Entity Particle System D1", me.Position[0], me.Position[1], me.Position[2])
		impl.ParticleType="BossEnergia"
		impl.YGravity=0.0
		impl.Friction=0.0
		impl.PPS=300
		impl.Velocity=0.0, 0.0, 0.0
		impl.RandomVelocity=-30.0
		impl.Time2Live=70
		impl.DeathTime=Bladex.GetTime()+1.5
		self.AgeNum=self.AgeNum+1
		
		
			
		
	def Respawn(self,EntityName):
		print "Boss Respawning"
		me = Bladex.GetEntity(EntityName)
		me.Life= CharStats.GetCharMaxLife(me.Kind, me.Level)
		me.ResetWounds()
		self.NameOfEnemy=None
		me.Blind=1
		me.Deaf=1
		if self.LevelupFunc:
			apply(self.LevelupFunc,self.LevelupArgs)
		self.PlaceMe(EntityName)
		
		
	def PlaceMe(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		pos=self.AppearPosList[whrandom.randint(0, len(self.AppearPosList)-1)]
		if darfuncs.ValidAppear(pos):
			me.Position=pos[0],pos[1],pos[2]
			me.Angle= B3DLib.GetEntity2EntityAngle(EntityName,"Player1")
			me.SetOnFloor()
			self.ImplosionDemonio(EntityName)
			Bladex.AddScheduledFunc(Bladex.GetTime()+0.5,self.AppearsFX,(EntityName,))
			Bladex.AddScheduledFunc(Bladex.GetTime()+0.6,self.FadeIn,(EntityName,))
			Bladex.AddScheduledFunc(Bladex.GetTime()+self.FadeInTime,self.ActivateAfterRespawn,(EntityName,))
		else:
			print "Boss Trying to appear but someone in way try again 0.2 secs...."
			Bladex.AddScheduledFunc(Bladex.GetTime()+0.2,self.PlaceMe,(EntityName,))
				
	
			
	def ActivateAfterRespawn(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		me.UnFreeze()
		me.LaunchAnmType("rlx")
		me.Blind=0
		me.Deaf=0
		self.OutOfAction=0
		if self.HealUpFunc:
			apply(self.HealUpFunc)
		
		
	def FadeIn(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		AuxFuncs.FadeObject(me.Name,0.0,1.0,self.FadeInTime)
		if me.InvRight:
			AuxFuncs.FadeObject(me.InvRight,0.0,1.0,self.FadeInTime)
		if me.InvLeft:
			AuxFuncs.FadeObject(me.InvLeft,0.0,1.0,self.FadeOutTime) 	
			

	def ResetCombat (self,EntityName):		
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)	
		if me and me.Life>0:
			inv= me.GetInventory()
			if inv.HoldingShield: 
				me.BlockingPropensity = 1.0
				me.RangeDefenceCapable = TRUE
			else: 
				me.BlockingPropensity = 0.2
				me.RangeDefenceCapable = FALSE
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 100.0
			me.AttackList = BCopy.deepcopy(VinculanusAttackData)
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00		
			


	
	def __getstate__(self):	
		NPCPerson_state=EnemyChar.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["Vinculanus"]=(self.Subordinates,
		                                  self.OutOfAction,
		                                  GameStateAux.SaveFunctionAux(self.HealUpFunc),
		                                  self.HidePosition,
						  self.HealTime,
						  self.FadeOutTime,
						  self.FadeInTime,
						  self.TransitTime,
						  self.AgeNum,
						  self.AppearPosList,
						  self.RespawnActive)
		return NPCPerson_state
	
	def __setstate__(self,parm):
		EnemyChar.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["Vinculanus"]
			self.Subordinates=parms[0]
			self.OutOfAction=parms[1]
			GameStateAux.LoadFunctionAux(parms[2],self,"HealUpFunc")
			self.FadeOutTime=parms[3]
			self.FadeInTime=parms[4]
			self.TransitTime= parms[5]
			self.HidePosition=parms[6]
			self.HealTime=parms[7]
			self.AgeNum=parms[8]
			self.AppearPosList=parms[9]
			self.RespawnActive=parms[10]
		
		me.ImDeadFunc=self.VinImDeadFunc
		
		self.disappsound=Bladex.CreateSound("..\\..\\Sounds\\rugido-demon5.wav", "DisappSound")
		self.disappsound.Volume=1.0
		self.disappsound.MinDistance=10000
		self.disappsound.MaxDistance=30000
		
		self.disappsound2=Bladex.CreateSound("..\\..\\Sounds\\respiracion-SirCaos3.wav", "DisappSound2")
		self.disappsound2.Volume=1.0
		self.disappsound2.MinDistance=10000
		self.disappsound2.MaxDistance=30000
		
			
VinculanusAttackData = [
           # inner zone blocks:
            [Combat.BLOCK,  0.60, (),                   500.0, 1000.0, 3000.0, 0.35],
            [Combat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [Combat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],

           # dodges:
            [Combat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],

           # attacks:
            [Combat.ATTACKDOWN, 0.90, ("STAIRS",),         1200.0, 1400.0, 2500.0, 0.35],

            
            [Combat.ATTACK, 0.20, ("GA1",),                500.0, 1400.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.10, ("GA2",),                500.0, 1600.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.05, ("GA3",),                500.0, 1800.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.20, ("GA4",),                500.0, 1400.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.20, ("GA5",),                500.0, 1200.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.20, ("GA6",),                500.0, 1200.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.20, ("GA7",),                500.0, 1200.0, 2500.0, 0.35],
            
            [Combat.ATTACK, 0.12, ("GM31",),               500.0, 1200.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.12, ("GM32",),               500.0, 1200.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.12, ("GM33",),               500.0, 1200.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.12, ("GM34",),               500.0, 1200.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.12, ("GM35",),               500.0, 1200.0, 2500.0, 0.35],
            
            
            [Combat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
            
            [Combat.DODGE, 0.30, ("GDR",),             500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE, 0.30, ("GDL",),             500.0, 1200.0, 2800.0, 0.35],
           # inner zone moves:
            [Combat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],

           # outer zone moves:
            [Combat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.15, Combat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35, 1],
            #[Combat.MOVE,   0.005, Combat.Laugh,              5000.0, 7000.0, 9000.0, 0.35, 1],
            #[Combat.MOVE,   0.005, Combat.Insult,             5000.0, 7000.0, 9000.0, 0.35, 1],
            #[Combat.MOVE,   0.02, Combat.GiveOrders,          5000.0, 7000.0, 9000.0, 0.35, 1],
            [Combat.MOVE,   0.05, Combat.UsePotion,           3000.0, 7000.0, 9000.0, 1.00],
]


"""


##########################################################################################################################################################
# Ghoulies



Bladex.AddParticleGType("GreenMist","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,128)

for i in range(128):
	if i>64:
		traux=0.0
	else:
		traux=(64.0-i)/64.0
	aux=(128.0-i)/128.0
	r=10
	g=170
	b=60
	a=150.0*(1.0-traux)**0.5
	size=10.0+aux*1200.0
	Bladex.SetParticleGVal("GreenMist",i,r,g,b,a,size)


Bladex.AddParticleGType("PurpleMist","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,128)

for i in range(128):
	if i>64:
		traux=0.0
	else:
		traux=(64.0-i)/64.0
	aux=(128.0-i)/128.0
	r=110
	g=10
	b=120
	a=150.0*(1.0-traux)**0.5
	size=10.0+aux*1200.0
	Bladex.SetParticleGVal("PurpleMist",i,r,g,b,a,size)
	
	
	
	
	
	
#import counter

#def GhoulDead(entity):
#	counter.GhoulDead()



import AniSoundGhoul

class Ghoul (EnemyChar):

	AGE_Number=0
	RightWeapon=None
	LeftWeapon=None
	
	def __init__(self, me):

		EnemyChar.__init__(self, me)
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0

		

		self.DamageFactorLight = 0.25
		self.DamageFactorHeavy = 0.25

		self.RightWeapon=None
		self.LeftWeapon=None
		
		me.ImDeadFunc=self.ImDeadFunc
		me.AddAnmEventFunc("Spit", self.StartSpit)
		self.NoFXOnHit= TRUE

	
	def __getstate__(self):		
		NPCPerson_state=EnemyChar.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			
			return NPCPerson_state
		NPCPerson_state[1]["Ghoul"]=(self.AGE_Number,self.RightWeapon, self.LeftWeapon)
		return NPCPerson_state		

	def __setstate__(self,parm):
		EnemyChar.__setstate__(self,parm)
		me=Bladex.GetEntity(self.Name)
		self.NoFXOnHit= TRUE
		
		version=parm[0]
		if version==1:
			parms=parm[1]["Ghoul"]
			self.AGE_Number= parms[0]
			self.RightWeapon= parms[1]
			self.LeftWeapon= parms[2]
		me.AddAnmEventFunc("Spit", self.StartSpit)
		
		
		
	def ResetSounds(self, EntityName):
		me = Bladex.GetEntity(EntityName)
		AniSoundGhoul.AsignarSonidosGhoul(me.Name)
		if me.MeshName=="Ghoul_B":
			Bladex.ReadBitMap("../../Maps/ProsperoArena1/NUFiles/NUGhoulStuff/GhoulBIcon.bmp","GhoulBIcon")
			Reference.EnemiesScorerData[self.Name]=("GhoulBIcon","Ghl")
		elif me.MeshName=="Ghoul_C":
			Bladex.ReadBitMap("../../Maps/ProsperoArena1/NUFiles/NUGhoulStuff/GhoulCIcon.bmp","GhoulCIcon")
			Reference.EnemiesScorerData[self.Name]=("GhoulCIcon","Ghl")
		elif me.MeshName=="Ghoul_D":
			Bladex.ReadBitMap("../../Maps/ProsperoArena1/NUFiles/NUGhoulStuff/GhoulDIcon.bmp","GhoulDIcon")
			Reference.EnemiesScorerData[self.Name]=("GhoulDIcon","Ghl")
		else:
			Bladex.ReadBitMap("../../Maps/ProsperoArena1/NUFiles/NUGhoulStuff/GhoulIcon.bmp","GhoulIcon")
			Reference.EnemiesScorerData[self.Name]=("GhoulIcon","Ghl")





	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			self.AttackNPCTime = 10.0
			me.BlockingPropensity = 0.0	
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath = 0.00
			me.AttackList = BCopy.deepcopy(GhoulAttackData)
			self.RightWeapon=me.InvRight
			self.LeftWeapon=me.InvLeft
			
			
			
	def RemoveWeapon2(self, weapon):
		wp=Bladex.GetEntity(weapon)
		wp.Position=0,50000,0
		print "Ghoul weapon removed"

			
	def RemoveWeapon(self, weapon):
		wp=Bladex.GetEntity(weapon)
		if wp and not wp.Parent:
			Reference.EntitiesSelectionData[weapon]=(0.0,0.0,"")
			AuxFuncs.FadeObject(weapon, 1.0,0.0,3.0)
			Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, self.RemoveWeapon2,(wp.Name,))
			
			
			
		
	def ImDeadFunc (self,EntityName):
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		me = Bladex.GetEntity(EntityName)
		Bladex.AddScheduledFunc(Bladex.GetTime()+10, dust.EnPolvoPerson,(EntityName,100,0,))
		if self.RightWeapon:
			rwp=Bladex.GetEntity(self.RightWeapon)
			Bladex.AddScheduledFunc(Bladex.GetTime()+12, self.RemoveWeapon,(rwp.Name,))
		if self.LeftWeapon:
			lwp=Bladex.GetEntity(self.LeftWeapon)
			Bladex.AddScheduledFunc(Bladex.GetTime()+12.5, dust.RemoveWeapon,(lwp.Name,))
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
		
		
		
	



	def VomitPrtlHit(self,prtl_name,hit_entity,x,y,z,vx,vy,vz,wcx,wcy,wcz,wdx,wdy,wdz):
		if hit_entity != "BWorld":
			victim=Bladex.GetEntity(hit_entity)
			if victim: 
				if victim.Person and not victim.Kind[:5]=="Ghoul":
					lvldam=Bladex.GetEntity(self.Name).Level+1
					Reference.EntitiesObjectData[prtl_name]= [Reference.OBJ_WEAPON, 0, 0,  1.0,  Reference.THR_STRAIGHT, Reference.W_FLAG_1H, ["Venom", +lvldam]]
					victim.DamageFunc(hit_entity, self.Name, prtl_name, "Vomit", 1, -1, x, y, z, 0)
					if Reference.EntitiesObjectData.has_key(prtl_name):
						del Reference.EntitiesObjectData[prtl_name]
				elif victim.Weapon:
					pass
		# This particle should be removed, as it has collided
		ptcl=Bladex.GetEntity(prtl_name)
		ptcl.RemoveFromWorld()


	def SpitFunc(self, vomit_name,end_time,period):
		vomit=Bladex.GetEntity(vomit_name)
		if(vomit):
			prtl=vomit.GetParticleEntity()
			prtl.HitFunc=self.VomitPrtlHit
			prtl.ObjCTest= 1
			if(Bladex.GetTime()<end_time):
				Bladex.AddScheduledFunc(Bladex.GetTime()+period,self.SpitFunc,(vomit_name,end_time,period))	
				
				
				
	def StartSpit (self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		if me.MeshName in ("Ghoul_C","Ghoul_B"):
			self.FireGas(EntityName)
			return
		self.AGE_Number=self.AGE_Number+1
		end_time=Bladex.GetTime()+0.5
		period= 0.125
		node= me.GetNodeIndex("Head")
		x,y,z= me.GraspPos("Mouth")
		vomit=Bladex.CreateEntity(EntityName+"_Vomit_"+`self.AGE_Number`,"Entity Particle System D1",x,y,z)
		vomit.ParticleType="Vomit"
		vomit.YGravity=9800.0
		vomit.Friction=0.075
		vomit.PPS=512
		vomit.DeathTime=end_time+1.0/60.0;
		vx,vy,vz=me.Rel2AbsVector(0,-9000.0,6500.0)
		vomit.Velocity=vx,vy,vz
		vomit.RandomVelocity=5.0
		me.LinkToNode(vomit,node)
		self.SpitFunc(vomit.Name, end_time, period)

	
	def FireGas(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.10, self.FireGas1,(EntityName,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.35, self.FireGas2,(EntityName,))
		
	
	def FireGas1 (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			if self.NameOfEnemy:
				Actions.QuickTurnToFaceEntity (EntityName, self.NameOfEnemy)		
	
	
	def FireGas2 (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			# Get an angle to the target
			if self.NameOfEnemy:
				target= Bladex.GetEntity(self.NameOfEnemy)
			else:
				return
			PTYPE="GreenMist"
			if me.MeshName=="Ghoul_B":
				PTYPE="PurpleMist"
			target_pos= target.Position
			x,y,z= me.GraspPos("Mouth")
			angle= -B3DLib.GetYAngle(target_pos[0]-x,target_pos[1]-y,target_pos[2]-z)
			duration= 0.3
			self.AGE_Number=self.AGE_Number+1
			end_time=Bladex.GetTime()+duration
			period= duration/10.0
			fireball=Bladex.CreateEntity(EntityName+"_Firefanl_"+`self.AGE_Number`,"Entity Particle System D1",x,y,z)
			fireball.ParticleType=PTYPE     
			fireball.Time2Live=20
			fireball.YGravity=-500.0
			fireball.Friction=0.12
			fireball.PPS=512
			fireball.DeathTime=end_time;
			F= 7000.0             # Vector magnitude
			vx,vy,vz=me.Rel2AbsVector(0.0, -math.cos(angle)*F, -math.sin(angle)*F)
			fireball.Velocity=vx,vy,vz
			fireball.RandomVelocity=55.0
			node= me.GetNodeIndex("Head")
			me.LinkToNode(fireball,node)
			self.SpitFunc(fireball.Name, end_time, period)		
			
				
	
GhoulAttackData =[  
	     [Combat.ATTACKDOWN, 1.00, ("G18",),        2610.0, 3109.0, 3608.0, 0.35],
	     [Combat.ATTACK, 0.35, ("G12",),            2610.0, 3109.0, 3608.0, 0.35],
	     [Combat.ATTACK, 0.20, ("G13",),            1526.0, 1831.0, 2136.0, 0.35],
	     [Combat.ATTACK, 0.35, ("G16",),             750.0, 1610.0, 1965.0, 0.35],
	     [Combat.ATTACK, 0.20, ("G18",),            2418.0, 2763.0, 3108.0, 0.35],
	     [Combat.ATTACKDOWN, 1.00, ("C3",),         1000.0, 2195.0, 2356.0, 0.35],
	     [Combat.ATTACK, 0.10, ("C1",),             1000.0, 2195.0, 2261.0, 0.35],
	     [Combat.ATTACK, 0.05, ("C3",),             1000.0, 2195.0, 2356.0, 0.35],
	     [Combat.ATTACK, 0.10, ("C2",),             1596.0, 2105.0, 2220.0, 0.35],
	     [Combat.ATTACK, 0.05, ("C3",),             1000.0, 2195.0, 2356.0, 0.35],
	     [Combat.ATTACK, 0.05, ("SP1",),             750.0, 3000.0, 4000.0, 3.00]
]



#########################################################################################################################################################
#########################################################################################################################################################
########## Golems


# auxilary funcs


DustAgeNum=0

def GolemImpact(entity, x, y, z, ImpX, ImpY, ImpZ, weapon_entity,WeaponCx, WeaponCy, WeaponCz,WeaponDx, WeaponDy, WeaponDz):
	global DustAgeNum
	DustAgeNum=DustAgeNum+1	
	print "Clunk"
	dust=Bladex.CreateEntity("dust_AGE_"+str(DustAgeNum),"Entity Particle System D1", x, y, z)
	if entity.Kind == "RockGolem":
		dust.ParticleType="Splinter"
		dust.Time2Live=16
		dust.PPS=128
		dust.RandomVelocity=50.0
	elif entity.Kind=="JewelGolem":
		dust.ParticleType="Splinter"
		dust.Time2Live=16
		dust.PPS=128
		dust.RandomVelocity=50.0
	else:
		dust.ParticleType="MediumDust"
		dust.Time2Live=63
		dust.PPS=60
		dust.RandomVelocity=30.0
			
	dust.YGravity=0.0
	dust.Friction=0.1
	dust.Velocity=0.0, 0.0, 0.0
	dust.DeathTime=Bladex.GetTime()+4.0/60.0




import AniSoundRockGolem
import AniSoundJewelGolem

class RockGolem (EnemyChar):

	HitPower=[5,8,15,25,50,80,120,150,185,210,240,280,340,420,540,650,750,850,950,1100]
	RockGolemFX=None

	def __init__(self, me):
		EnemyChar.__init__(self, me)

		self.DamageFactorNone  = 0.25
		self.DamageFactorLight = 0.25

		self.RockGolemFX=None
		
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0

		
		self.HitPower=[5,8,15,25,50,80,120,150,185,210,240,280,340,420,540,650,750,850,950,1100]
		self.NoFXOnHit= TRUE
		self.UpdateMyPower()
		
		
		
	## Bug with hiding Golems with aura/particleFX. FX must be applied AFTER Golem is unhidden or poss CTD
		
	def AddFX(self):
		me=Bladex.GetEntity(self.Name)
		if me.MeshName=="LavaGolem":
			AddJewelGolemFX(me.Name,self)
			me.SelfIlum=0.2

	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if me.Kind=="RockGolem":
			AniSoundRockGolem.AsignarSonidosRockGolem(EntityName)
			
		Bladex.ReadBitMap("../../Maps/ProsperoArena1/NUFiles/NUNWNGolemStuff/RockGolemIcon.bmp","RockGolemIcon")
		Reference.EnemiesScorerData[self.Name]=("RockGolemIcon","Rgm")
		
		

		
	def OnKilledEnemy(self,KilledEntityName):
		print "NWNGolem Leveling up"
		KilledEntity=Bladex.GetEntity(KilledEntityName)
		if KilledEntity is None:
			return
		me=Bladex.GetEntity(self.Name)
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, self.LookForAnotherOpponent,(self.Name,))
		me.PartialLevel=me.PartialLevel+CharStats.GetCharExperienceReward(KilledEntity.CharType,KilledEntity.Level)
		LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
		if me.PartialLevel>=LevelLimit and me.Life>0:
			while me.PartialLevel>=LevelLimit:
				me.PartialLevel=me.PartialLevel-LevelLimit
				me.Level=me.Level+1
				LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
			maxlevel=CharStats.GetMaxLevel()
			maxsize=50+(140/maxlevel)*me.Level 
			maxPPS=120+(600/maxlevel)*me.Level 
			maxint=0.5+(4.5/maxlevel)*me.Level 
			AuraParams=(5, 0, 1, 0, 0, 1)
			AuraGradient=(2, 0.4, 0.6, 1.0, 0.5, 0.0, 0.1, 0.2, 1.0, 0.0, 0.8)
			AuraVar1Args=(5, maxsize, 0, 1, 0.5)
			AuraVar2Args=(maxsize, 5, 1, 0, 1.0)
			print "Levelup PS params set"
			PSParams=(self.NPCLevelUpParticleData, "NPCLevelUpParticle", 30, 50, 150, 255, maxPPS, -600, 0.0, 2, 2, 0.4, 30, 0.5)
			GenFX.LevelUpFX(me.Name, 1, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, maxint, "Timer15", 15)
			if me.Life >0: # If an enemy death by poison or trowed weapons and.. You are death!
				me.ResetWounds()
				me.Life = CharStats.GetCharMaxLife(me.Kind, me.Level)
			self.lupsnd1.Play(me.Position[0],me.Position[1],me.Position[2],0)
			if self.LevelupFunc:
				apply(self.LevelupFunc,self.LevelupArgs)
			self.UpdateMyPower()
	
		
		
	def UpdateMyPower(self):
		me=Bladex.GetEntity(self.Name)
		LEVEL=me.Level
		if not Reference.EntitiesObjectData.has_key(me.Name):
			Reference.EntitiesObjectData[me.Name]=BCopy.deepcopy(Reference.DefaultObjectData[me.Kind])
		if LEVEL>19:
			hitpower=1200
		else:
			hitpower=self.HitPower[LEVEL]
		Reference.EntitiesObjectData[me.Name][1]=hitpower
		if me.MeshName=="LavaGolem":
			Reference.EntitiesObjectData[me.Name].append(['Fire',+hitpower])
		print "Golem Power Increased"
		
		
		
	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 100.0
			me.BlockingPropensity = 0.2
			me.AttackList = BCopy.deepcopy(RockGolemAttackData)
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath = 0.0


	def HitFunc (self, EntityName, WeaponName, Cx, Cy, Cz, Px, Py, Pz, WeaponCx, WeaponCy, WeaponCz,WeaponDx, WeaponDy, WeaponDz):
		GolemImpact(Bladex.GetEntity(EntityName), Cx, Cy, Cz, Px, Py, Pz,Bladex.GetEntity(WeaponName),WeaponCx, WeaponCy, WeaponCz,WeaponDx, WeaponDy, WeaponDz)
			
	
		
	
	
	def __getstate__(self):
		NPCPerson_state=EnemyChar.__getstate__(self)
		me=Bladex.GetEntity(self.Name)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["RockGolem"]=(self.HitPower,self.RockGolemFX)
		return NPCPerson_state
		

	def __setstate__(self,parm):
		EnemyChar.__setstate__(self,parm)
		me=Bladex.GetEntity(self.Name)

		version=parm[0]
		if version==1:
			parms=parm[1]["RockGolem"]
			HitPower=parms[0]
			self.RockGolemFX=parms[1]
		self.NoFXOnHit= TRUE
		
		
		
		

			
RockGolemAttackData = [
            #[Combat.ATTACK,  0.25, ("g_01",),          1000.0, 1600.0, 3500.0, 0.50],
            [Combat.ATTACK,  0.05, ("g_114",),         1500.0, 2700.0, 4000.0, 0.50],
            [Combat.ATTACK,  0.15, ("g_12",),          1500.0, 2700.0, 3500.0, 0.50],
            [Combat.ATTACK,  0.15, ("g_21",),          1500.0, 2500.0, 3000.0, 0.50],
            [Combat.ATTACK,  0.15, ("g_21_27",),       3500.0, 5000.0, 9000.0, 0.50],# this one does not connect properly
            [Combat.ATTACK,  0.05, ("g_31",),          1500.0, 2600.0, 3500.0, 0.50],
]




############################################################################################################################################################

class JewelGolem (EnemyChar):

	JewelGolemFX=None
	HitPower=[15,28,40,78,100,135,150,165,185,210,240,280,340,420,540,650,750,850,950,1100]
	ChestEdge=""
	
	
	def __init__(self, me):
		EnemyChar.__init__(self, me)

		self.DamageFactorNone  = 0.25
		self.DamageFactorLight = 0.25

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		me.AddAnmEventFunc("Start_ChestWeapon", self.StartChestDamage)
		me.AddAnmEventFunc("Stop_ChestWeapon", self.StopChestDamage)
		

				
		me.ImDeadFunc=self.NUImDeadFunc
		self.NoFXOnHit= TRUE
		self.JewelGolemFX=None
		self.HitPower=[15,28,40,78,100,135,150,165,185,210,240,280,340,420,540,650,750,850,950,1100]
		
		me.Alpha=0.6
		me.SelfIlum=0.8
		
		self.ChestEdge=""
		#AddJewelGolemFX(me.Name,self)
		
		
		
		
	def AddFX(self):
		me=Bladex.GetEntity(self.Name)
		AddJewelGolemFX(me.Name,self)
		
		

	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if me.Kind=="JewelGolem":
			AniSoundJewelGolem.AsignarSonidosJewelGolem(EntityName)
		if me.MeshName=="JewelGolemRuby":
			Bladex.ReadBitMap("../../Maps/ProsperoArena1/NUFiles/NUNWNGolemStuff/RuGolemIcon.bmp","RubyGolemIcon")
			Reference.EnemiesScorerData[self.Name]=("RubyGolemIcon","Jgm")
		elif me.MeshName=="JewelGolemEmerald":
			Bladex.ReadBitMap("../../Maps/ProsperoArena1/NUFiles/NUNWNGolemStuff/EmGolemIcon.bmp","EmeraldGolemIcon")
			Reference.EnemiesScorerData[self.Name]=("EmeraldGolemIcon","Jgm")
		elif me.MeshName=="JewelGolemAmethyst":
			Bladex.ReadBitMap("../../Maps/ProsperoArena1/NUFiles/NUNWNGolemStuff/AmGolemIcon.bmp","AmethystGolemIcon")
			Reference.EnemiesScorerData[self.Name]=("AmethystGolemIcon","Jgm")
		else:
			Bladex.ReadBitMap("../../Maps/ProsperoArena1/NUFiles/NUNWNGolemStuff/JewelGolemIcon.bmp","JewelGolemIcon")
			Reference.EnemiesScorerData[self.Name]=("JewelGolemIcon","Jgm")
		
		
		

		
	def OnKilledEnemy(self,KilledEntityName):
		print "NWNGolem Leveling up"
		KilledEntity=Bladex.GetEntity(KilledEntityName)
		if KilledEntity is None:
			return
		me=Bladex.GetEntity(self.Name)
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, self.LookForAnotherOpponent,(self.Name,))
		me.PartialLevel=me.PartialLevel+CharStats.GetCharExperienceReward(KilledEntity.CharType,KilledEntity.Level)
		LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
		if me.PartialLevel>=LevelLimit and me.Life>0:
			while me.PartialLevel>=LevelLimit:
				me.PartialLevel=me.PartialLevel-LevelLimit
				me.Level=me.Level+1
				LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
			maxlevel=CharStats.GetMaxLevel()
			maxsize=50+(140/maxlevel)*me.Level 
			maxPPS=120+(600/maxlevel)*me.Level 
			maxint=0.5+(4.5/maxlevel)*me.Level 
			AuraParams=(5, 0, 1, 0, 0, 1)
			AuraGradient=(2, 0.4, 0.6, 1.0, 0.5, 0.0, 0.1, 0.2, 1.0, 0.0, 0.8)
			AuraVar1Args=(5, maxsize, 0, 1, 0.5)
			AuraVar2Args=(maxsize, 5, 1, 0, 1.0)
			print "Levelup PS params set"
			PSParams=(self.NPCLevelUpParticleData, "NPCLevelUpParticle", 30, 50, 150, 255, maxPPS, -600, 0.0, 2, 2, 0.4, 30, 0.5)
			GenFX.LevelUpFX(me.Name, 1, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, maxint, "Timer15", 15)
			if me.Life >0: # If an enemy death by poison or trowed weapons and.. You are death!
				me.ResetWounds()
				me.Life = CharStats.GetCharMaxLife(me.Kind, me.Level)
			self.lupsnd1.Play(me.Position[0],me.Position[1],me.Position[2],0)
			if self.LevelupFunc:
				apply(self.LevelupFunc,self.LevelupArgs)
			self.UpdateMyPower()
	
	
	def StartChestDamage(self,EntityName,EventName):
		if self.ChestEdge:
			chestedge=Bladex.GetEntity(self.ChestEdge)
			chestedge.MessageEvent(Reference.MESSAGE_START_WEAPON,0,0)
			#print "Chest Damage On"
		
	def StopChestDamage(self,EntityName,EventName):
		if self.ChestEdge:
			chestedge=Bladex.GetEntity(self.ChestEdge)
			chestedge.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
			#print "Chest Damage Off"
	
	
	def UpdateMyPower(self):
		me=Bladex.GetEntity(self.Name)
		rwp=Bladex.GetEntity(me.InvRight)
		if not rwp:
			return
		LEVEL=me.Level
		hitpower=2
		if LEVEL>19:
			hitpower=1200
		else:
			hitpower=self.HitPower[LEVEL]
		Reference.EntitiesObjectData[rwp.Name][1]=hitpower
		if self.ChestEdge:
			Reference.EntitiesObjectData[self.ChestEdge][1]=hitpower
		print "Golem Weapon Power Increased"
		
		
		
	def ToolUp(self,WeaponType="TopazMace"):
		print "Golem tooling up"
		me=Bladex.GetEntity(self.Name)
		if me.MeshName=="JewelGolemRuby":
			WeaponType="RubyMace"
		elif me.MeshName=="JewelGolemAmethyst":
			WeaponType="AmethystMace"
		elif me.MeshName=="JewelGolemEmerald":
			WeaponType="EmeraldMace"
		else:
			if whrandom.random()<0.6:
				WeaponType="TopazMace2"
			else:
				WeaponType="TopazMace"
		rwp=Bladex.CreateEntity(self.Name+" RightWeapon",WeaponType,0,20000,0,"Weapon")
		Reference.EntitiesObjectData[rwp.Name]=BCopy.deepcopy(Reference.DefaultObjectData[rwp.Kind])
		rwp.Alpha=0.6
		rwp.SelfIlum=0.8
		Actions.TakeObject(me.Name,rwp.Name)
		inv=me.GetInventory()
		chestedge=Bladex.CreateEntity(self.Name+"ChestEdge","Jgolemedge2",0,20000,0,"Weapon")
		Reference.EntitiesObjectData[chestedge.Name]=BCopy.deepcopy(Reference.DefaultObjectData[chestedge.Kind])
		self.ChestEdge=chestedge.Name
		chestedge.Alpha=0.0
		chestedge.CastShadows=0
		chestedge.RasterMode  ="AdditiveAlpha"
		chestedge.RasterMode  ="Read"
		inv.AddWeapon(chestedge.Name)
		me.LinkAnchors("Front",chestedge,"1H_R")
		self.UpdateMyPower()
		print "Golem tooled up"
		
		
	def NUImDeadFunc (self,EntityName):
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
		me = Bladex.GetEntity(EntityName)
		inv=me.GetInventory()
		rwp=Bladex.GetEntity(me.InvRight)
		lwp=Bladex.GetEntity(me.InvLeft)
		if self.ChestEdge:
			chestedge=Bladex.GetEntity(self.ChestEdge)
			Actions.RemoveFromInventory(me, chestedge,"DropRightEvent")
			chestedge.Alpha=0.0
			chestedge.Position=0,50000,0
			print "Jewel Golem chest edge disposed of"
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		if self.Dusted:
			Bladex.AddScheduledFunc(Bladex.GetTime()+15,RemoveMyCorpse,(EntityName,100,0,))
			if rwp:
				Reference.EntitiesSelectionData[rwp.Name]=()
				Bladex.AddScheduledFunc(Bladex.GetTime()+15,RemoveMyWeapon,(rwp.Name,))
			if lwp:
				Reference.EntitiesSelectionData[lwp.Name]=()
				Bladex.AddScheduledFunc(Bladex.GetTime()+16,RemoveMyWeapon,(lwp.Name,))
		print "Jewel Golem dead func complete"
		
		
		
		
	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			self.AttackNPCTime = 100.0
			me.BlockingPropensity = 0.2
			me.AttackList = BCopy.deepcopy(JewelGolemAttackData)
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath = 0.0
		
		
	
		
	def HitFunc (self, EntityName, WeaponName, Cx, Cy, Cz, Px, Py, Pz, WeaponCx, WeaponCy, WeaponCz,WeaponDx, WeaponDy, WeaponDz):
		#GolemImpact(Bladex.GetEntity(EntityName), Cx, Cy, Cz, Px, Py, Pz,Bladex.GetEntity(WeaponName),WeaponCx, WeaponCy, WeaponCz,WeaponDx, WeaponDy, WeaponDz)
		pass		
	
	
	def __getstate__(self):
		NPCPerson_state=EnemyChar.__getstate__(self)
		me=Bladex.GetEntity(self.Name)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["JewelGolem"]=(self.JewelGolemFX,self.HitPower)
		return NPCPerson_state
		

	def __setstate__(self,parm):
		EnemyChar.__setstate__(self,parm)
		me=Bladex.GetEntity(self.Name)
		version=parm[0]
		if version==1:
			parms=parm[1]["JewelGolem"]
			self.JewelGolemFX=parms[0]
			self.HitPower=parms[1]
			
		self.NoFXOnHit= TRUE
		me.Alpha=0.6
		me.SelfIlum=0.8
		me.AddAnmEventFunc("Start_ChestWeapon", self.StartChestDamage)
		me.AddAnmEventFunc("Stop_ChestWeapon", self.StopChestDamage)
		me.ImDeadFunc=self.NUImDeadFunc
	
	
	
			
JewelGolemAttackData = [
	    [Combat.ATTACK,  0.05, ("g_31",),         0.0, 1000.0, 1489.0, 0.50],
            [Combat.ATTACK,  0.20, ("G11",),          1490.0, 2195.0, 2900.0, 0.35],
            [Combat.ATTACK,  0.15, ("G22",),          1410.0, 2105.0, 2800.0, 0.35],
            [Combat.ATTACK,  0.10, ("G51",),          1550.0, 2225.0, 2900.0, 0.35],
            [Combat.ATTACK,  0.10, ("G27",),          1700.0, 2375.0, 3050.0, 0.35],
            [Combat.ATTACK,  0.07, ("G28",),          1850.0, 2525.0, 3200.0, 0.35],
            [Combat.ATTACK,  0.07, ("G32",),          3050.0, 3600.0, 3850.0, 0.35],
            [Combat.ATTACK,  0.05, ("G38",),          2450.0, 3600.0, 3850.0, 0.35],
]



############### FX for jewel golems

class JewelGolemFX:

	def __init__(self, GolemName, prtldata,auraparams, auragradient):
		self.ObjId= ObjStore.GetNewId()
		ObjStore.ObjectsStore[self.ObjId]= self
		pers=Bladex.GetEntity(GolemName)
		self.GolemName=GolemName
		self.Vapour=None
		self.Aura=None
		
		if prtldata:
			pt, pps, v, nv, rv, g, fr, ff, t2l=prtldata
			self.Vapour=Bladex.CreateEntity(GolemName+"Vapour", "Entity Particle System Dperson", 0, 0, 0)
			self.Vapour.PersonName=GolemName
			self.Vapour.ParticleType=pt
			self.Vapour.PPS=pps
			self.Vapour.Velocity=v
			self.Vapour.NormalVelocity=nv
			self.Vapour.RandomVelocity=rv
			self.Vapour.YGravity=g
			self.Vapour.Friction=fr
			self.Vapour.FollowFactor=ff
			self.Vapour.Time2Live=t2l
		if auraparams:
			s, a, ci, f, b, am=auraparams
			m, r1, g1, b1, a1, imd, r2, g2, b2, a2, emd=auragradient
			self.Aura=Bladex.CreateEntity(GolemName+"Aura", "Entity Aura", 0, 0, 0)
			self.Aura.SetAuraParams(s, a, ci, f, b, am)
			self.Aura.SetAuraGradient(m, r1, g1, b1, a1, imd, r2, g2, b2, a2, emd)
			pers.Link(self.Aura)
			self.Aura.SetAuraActive(1)


	def persistent_id(self):
		return self.ObjId

	def __getstate__(self):
		return (1,
				self.ObjId,
				self.GolemName,
				GameStateAux.SaveEntityAux(self.Vapour),
				GameStateAux.SaveEntityAux(self.Aura)
			)


	def __setstate__(self,parm):
		if parm[0]==1:
			self.ObjId= parm[1]
			ObjStore.ObjectsStore[self.ObjId]=self
			self.GolemName=parm[2]
			self.Vapour=GameStateAux.LoadEntityAux(parm[3])
			self.Aura=GameStateAux.LoadEntityAux(parm[4])
		else:
			self.GolemName=""
			self.Vapour=""
			self.Aura=""
			self.ObjId= ObjStore.GetNewId()
			ObjStore.ObjectsStore[self.ObjId]=self
			
			
 # (PrtlType, PPS, Vel=(v1, v2, v3), NormalVel, RndVel, YGrav, Friction, FollowFactor, Time2Live)
			
def AddJewelGolemFX(GolemName, data):
	pers=Bladex.GetEntity(GolemName)
	if not pers:
		print "El golem especificada no existe!"
		return
	if pers.MeshName =="JewelGolem":  # Base model 'Topaz'
		auraparams=(50, 1, 1, 0, 0, 1)
		auragradient=(2, 0.9, 1.0, 0.0, 0.2, 0.1,  0.4, 0.3, 0.0, 0.0, 0.8)
		prtldata=()                                                          
	elif pers.MeshName =="JewelGolemRuby" or pers.MeshName =="LavaGolem":  
		auraparams=(50, 1, 1, 0, 0, 1)
		auragradient=(2, 0.9, 0.3, 0.0, 0.2, 0.1,  0.6, 0.0, 0.0, 0.0, 0.8)
		prtldata=()                     
	elif pers.MeshName =="JewelGolemAmethyst":  
		auraparams=(50, 1, 1, 0, 0, 1)
		auragradient=(2, 0.2, 0.3, 0.9, 0.2, 0.1,  0.0, 0.0, 0.6, 0.0, 0.8)
		prtldata=()                  
	elif pers.MeshName =="JewelGolemEmerald":  
		auraparams=(50, 1, 1, 0, 0, 1)
		auragradient=(2, 0.2, 0.9, 0.3, 0.2, 0.1,  0.0, 0.6, 0.0, 0.0, 0.8)
		prtldata=()                        
	else:
		prtldata=()
		auraparams=()
		auragradient=()
		
	data.JewelGolemFX=JewelGolemFX(GolemName, prtldata, auraparams, auragradient)



##########################################################################################################################################################
######### Iron Warrior

import AniSoundIronWarrior




class IronWarrior (EnemyChar):

	HitPower=[15,28,40,78,100,135,150,165,185,210,240,280,340,420,540,650,750,850,950,1100]

	def __init__(self, me):
			
		EnemyChar.__init__(self, me)

		self.DamageFactorNone  = 0.15
		self.DamageFactorLight = 0.25
		self.DamageFactorHeavy = 0.35
		
		self.HitPower=[15,28,40,78,100,135,150,165,185,210,240,280,340,420,540,650,750,850,950,1100]

		# Set up specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0

		self.UpdateMyPower()
	
	
	# Functions for loading and saving state
	def __getstate__(self):
		NPCPerson_state=EnemyChar.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["IronWarrior"]=()
		return NPCPerson_state		

	def __setstate__(self,parm):
		EnemyChar.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["IronWarrior"]
			
			
	

	def ResetSounds(self, EntityName):
		AniSoundIronWarrior.AsignarSonidosIronWarrior(EntityName)
		Bladex.ReadBitMap("../../Maps/ProsperoArena1/NUFiles/NUNWNGolemStuff/IronWarriorIcon.bmp","IronWarriorIcon")
		Reference.EnemiesScorerData[self.Name]=("IronWarriorIcon","Iwr")




	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			me.AttackList = BCopy.deepcopy(IronWarriorAttackData)


	def OnKilledEnemy(self,KilledEntityName):
		print "IronWarrior Leveling up"
		KilledEntity=Bladex.GetEntity(KilledEntityName)
		if KilledEntity is None:
			return
		me=Bladex.GetEntity(self.Name)
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, self.LookForAnotherOpponent,(self.Name,))
		me.PartialLevel=me.PartialLevel+CharStats.GetCharExperienceReward(KilledEntity.CharType,KilledEntity.Level)
		LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
		if me.PartialLevel>=LevelLimit and me.Life>0:
			while me.PartialLevel>=LevelLimit:
				me.PartialLevel=me.PartialLevel-LevelLimit
				me.Level=me.Level+1
				LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
			maxlevel=CharStats.GetMaxLevel()
			maxsize=50+(140/maxlevel)*me.Level 
			maxPPS=120+(600/maxlevel)*me.Level 
			maxint=0.5+(4.5/maxlevel)*me.Level 
			AuraParams=(5, 0, 1, 0, 0, 1)
			AuraGradient=(2, 0.4, 0.6, 1.0, 0.5, 0.0, 0.1, 0.2, 1.0, 0.0, 0.8)
			AuraVar1Args=(5, maxsize, 0, 1, 0.5)
			AuraVar2Args=(maxsize, 5, 1, 0, 1.0)
			print "Levelup PS params set"
			PSParams=(self.NPCLevelUpParticleData, "NPCLevelUpParticle", 30, 50, 150, 255, maxPPS, -600, 0.0, 2, 2, 0.4, 30, 0.5)
			GenFX.LevelUpFX(me.Name, 1, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, maxint, "Timer15", 15)
			if me.Life >0: # If an enemy death by poison or trowed weapons and.. You are death!
				me.ResetWounds()
				me.Life = CharStats.GetCharMaxLife(me.Kind, me.Level)
			self.lupsnd1.Play(me.Position[0],me.Position[1],me.Position[2],0)
			if self.LevelupFunc:
				apply(self.LevelupFunc,self.LevelupArgs)
			self.UpdateMyPower()
			
			
			
	def UpdateMyPower(self):
		me=Bladex.GetEntity(self.Name)
		rwp=Bladex.GetEntity(me.InvRight)
		if not rwp:
			return
		LEVEL=me.Level
		hitpower=2
		if LEVEL>19:
			hitpower=1500
		else:
			hitpower=self.HitPower[LEVEL]
		if not Reference.EntitiesObjectData.has_key(rwp.Name):
			Reference.EntitiesObjectData[rwp.Name]=BCopy.deepcopy(Reference.DefaultObjectData[rwp.Kind])
		Reference.EntitiesObjectData[rwp.Name][1]=hitpower
		print "ironWarrior Weapon Power Increased"
			
			
	def ToolUp(self,WeaponType="IronHammer"):
		me=Bladex.GetEntity(self.Name)
		rwp=Bladex.CreateEntity(self.Name+" RightWeapon",WeaponType,0,0,0,"Weapon")
		Reference.EntitiesObjectData[rwp.Name]=BCopy.deepcopy(Reference.DefaultObjectData[rwp.Kind])
		Actions.TakeObject(me.Name,rwp.Name)
		self.UpdateMyPower()
		print "IronWarrior tooled up"	
			


IronWarriorAttackData =	[ 
           # inner zone blocks:
            #[BLOCK,  0.85, (),                   500.0, 1000.0, 3000.0, 0.35],
			         
           # attacks:
            [Combat.ATTACK, 0.20, ("G01",),            1490.0, 2195.0, 2900.0, 0.35],
            [Combat.ATTACK, 0.15, ("G02",),            1410.0, 2105.0, 2800.0, 0.35],
            [Combat.ATTACK, 0.10, ("G07",),            1550.0, 2225.0, 2900.0, 0.35],
            [Combat.ATTACK, 0.10, ("G08",),            1700.0, 2375.0, 3050.0, 0.35],
            [Combat.ATTACK, 0.07, ("G12",),            2850.0, 3425.0, 3900.0, 0.35],
            [Combat.ATTACK, 0.07, ("G18",),            3050.0, 3600.0, 3850.0, 0.35],
            [Combat.ATTACK, 0.05, ("G31",),            3400.0, 3700.0, 4000.0, 0.35],
]



###########################################################################################################################################################


import AniSoundBzw


def BzwLaugh (EntityName):
	me=Bladex.GetEntity(EntityName)
	if me and me.Life>0 and me.CombatGroup:
		memberlist = me.GetGroupMembers()
		for member_name in memberlist:
			member = Bladex.GetEntity(member_name)
			if member and member.Life > 0:
				if member.AnimName == "laugh":
					return 0
	me.Wuea=Reference.WUEA_ENDED
	me.LaunchAnmType("laugh")
	return me.AnimName=="laugh"




class BronzeWarrior (EnemyChar):

	FootWep=""


	HitPower=[15,28,40,78,100,135,150,165,185,210,240,280,340,420,540,650,750,850,950,1100]

	def __init__(self, me):
			
		EnemyChar.__init__(self, me)
		
		self.FootWep=""

		self.DamageFactorNone  = 0.15
		self.DamageFactorLight = 0.25
		self.DamageFactorHeavy = 0.35
		
		me.AddAnmEventFunc("Start_LegWeapon", self.StartLegDamage)
		me.AddAnmEventFunc("Stop_LegWeapon", self.StopLegDamage)
		
		me.ImDeadFunc=self.NUImDeadFunc
		
		self.HitPower=[15,28,40,78,100,135,150,165,185,210,240,280,340,420,540,650,750,850,950,1100]

		# Set up specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0


	def ResetSounds(self, EntityName):
		AniSoundBzw.AsignarSonidosBronzeWarrior(EntityName)
		me = Bladex.GetEntity(EntityName)
		if me.MeshName=="TempleGuard":
			Bladex.ReadBitMap("../../Maps/ProsperoArena1/NUFiles/NUBronzeWarriorStuff/TempleGuardIcon.bmp","TempleGuardIcon")
			Reference.EnemiesScorerData[self.Name]=("TempleGuardIcon","Bzw")
		else:
			Bladex.ReadBitMap("../../Maps/ProsperoArena1/NUFiles/NUBronzeWarriorStuff/BronzeWarriorIcon.bmp","BronzeWarriorIcon")
			Reference.EnemiesScorerData[self.Name]=("BronzeWarriorIcon","Bzw")




	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			me.AttackList = BCopy.deepcopy(BronzeWarriorAttackData)
			if me.Level==6:
				me.AttackList.append([Combat.ATTACK, 0.05, ("GM7_1H",),            2200.0, 2600.0, 3000.0, 0.35],) 
			if me.Level==9:
				me.AttackList.append([Combat.ATTACK, 0.05, ("GM9_1H",),            2200.0, 2600.0, 3000.0, 0.35],) 
			
			
	def NUImDeadFunc (self,EntityName):
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
		me = Bladex.GetEntity(EntityName)
		inv=me.GetInventory()
		rwp=Bladex.GetEntity(me.InvRight)
		lwp=Bladex.GetEntity(me.InvLeft)
		if self.FootWep:
			rlegwp=Bladex.GetEntity(self.FootWep)
			Actions.RemoveFromInventory(me, rlegwp,"DropRightEvent")
			rlegwp.Alpha=0.0
			rlegwp.Position=0,50000,0
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		if self.Dusted:
			Bladex.AddScheduledFunc(Bladex.GetTime()+15,RemoveMyCorpse,(EntityName,100,0,))
			if rwp:
				Reference.EntitiesSelectionData[rwp.Name]=()
				Bladex.AddScheduledFunc(Bladex.GetTime()+15,RemoveMyWeapon,(rwp.Name,))
			if lwp:
				Reference.EntitiesSelectionData[lwp.Name]=()
				Bladex.AddScheduledFunc(Bladex.GetTime()+16,RemoveMyWeapon,(lwp.Name,))


	def OnKilledEnemy(self,KilledEntityName):
		print "IronWarrior Leveling up"
		KilledEntity=Bladex.GetEntity(KilledEntityName)
		if KilledEntity is None:
			return
		me=Bladex.GetEntity(self.Name)
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, self.LookForAnotherOpponent,(self.Name,))
		me.PartialLevel=me.PartialLevel+CharStats.GetCharExperienceReward(KilledEntity.CharType,KilledEntity.Level)
		LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
		if me.PartialLevel>=LevelLimit and me.Life>0:
			while me.PartialLevel>=LevelLimit:
				me.PartialLevel=me.PartialLevel-LevelLimit
				me.Level=me.Level+1
				LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
			maxlevel=CharStats.GetMaxLevel()
			maxsize=50+(140/maxlevel)*me.Level 
			maxPPS=120+(600/maxlevel)*me.Level 
			maxint=0.5+(4.5/maxlevel)*me.Level 
			AuraParams=(5, 0, 1, 0, 0, 1)
			AuraGradient=(2, 0.4, 0.6, 1.0, 0.5, 0.0, 0.1, 0.2, 1.0, 0.0, 0.8)
			AuraVar1Args=(5, maxsize, 0, 1, 0.5)
			AuraVar2Args=(maxsize, 5, 1, 0, 1.0)
			print "Levelup PS params set"
			PSParams=(self.NPCLevelUpParticleData, "NPCLevelUpParticle", 30, 50, 150, 255, maxPPS, -600, 0.0, 2, 2, 0.4, 30, 0.5)
			GenFX.LevelUpFX(me.Name, 1, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, maxint, "Timer15", 15)
			if me.Life >0: # If an enemy death by poison or trowed weapons and.. You are death!
				me.ResetWounds()
				me.Life = CharStats.GetCharMaxLife(me.Kind, me.Level)
			self.lupsnd1.Play(me.Position[0],me.Position[1],me.Position[2],0)
			if self.LevelupFunc:
				apply(self.LevelupFunc,self.LevelupArgs)
			self.UpdateMyPower()
			

			
			
	def UpdateMyPower(self):
		me=Bladex.GetEntity(self.Name)
		rwp=Bladex.GetEntity(me.InvRight)
		if not rwp:
			return
		LEVEL=me.Level
		hitpower=2
		if LEVEL>19:
			hitpower=1500
		else:
			hitpower=self.HitPower[LEVEL]
		if not Reference.EntitiesObjectData.has_key(rwp.Name):
			Reference.EntitiesObjectData[rwp.Name]=BCopy.deepcopy(Reference.DefaultObjectData[rwp.Kind])
		Reference.EntitiesObjectData[rwp.Name][1]=hitpower
		if self.FootWep:
			rlegwp=Bladex.GetEntity(self.FootWep)
			if not Reference.EntitiesObjectData.has_key(rlegwp.Name):
				Reference.EntitiesObjectData[rlegwp.Name]=BCopy.deepcopy(Reference.DefaultObjectData[rlegwp.Kind])
			Reference.EntitiesObjectData[rlegwp.Name][1]=hitpower
		
		print "BronzeWarrior Weapon Power Increased"
			
			
	def ToolUp(self,WeaponType="GorgonHammer", ShieldType="BronzeShield1"):
		me=Bladex.GetEntity(self.Name)
		rwp=Bladex.CreateEntity(self.Name+" RightWeapon",WeaponType,0,0,0,"Weapon")
		Reference.EntitiesObjectData[rwp.Name]=BCopy.deepcopy(Reference.DefaultObjectData[rwp.Kind])
		lwp=Bladex.CreateEntity(self.Name+" LeftWeapon",ShieldType,0,0,0,"Weapon")
		ItemTypes.ItemDefaultFuncs(lwp)
		Actions.TakeObject(me.Name,rwp.Name)
		Actions.TakeObject(me.Name,lwp.Name)
		self.FixFootWeapon() # update power func called at end of this func
		
		print "BronzeWarrior tooled up"	
			


	def FixFootWeapon(self):
		print "BZ fix footwep"
		me=Bladex.GetEntity(self.Name)
		inv=me.GetInventory()
		rlegwp=Bladex.CreateEntity(self.Name+" RightLegWeapon","BZfootwep",0,0,0,"Weapon")
		Reference.EntitiesObjectData[rlegwp.Name]=BCopy.deepcopy(Reference.DefaultObjectData[rlegwp.Kind])
		self.FootWep=rlegwp.Name
		rlegwp.Alpha=0.0
		rlegwp.CastShadows=0
		rlegwp.RasterMode  ="AdditiveAlpha"
		rlegwp.RasterMode  ="Read"
		inv.AddWeapon(rlegwp.Name)
		me.LinkAnchors("R_Leg",rlegwp,"Foot")
		self.UpdateMyPower()
		


	def StartLegDamage(self,EntityName,EventName):
		if self.FootWep:
			rlegwp=Bladex.GetEntity(self.FootWep)
			rlegwp.MessageEvent(Reference.MESSAGE_START_WEAPON,0,0)
			print "BZleg Damage On"
		
	def StopLegDamage(self,EntityName,EventName):
		if self.FootWep:
			rlegwp=Bladex.GetEntity(self.FootWep)
			rlegwp.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
			print "BZleg Damage Off"
	

	# Functions for loading and saving state
	def __getstate__(self):
		NPCPerson_state=EnemyChar.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["BronzeWarrior"]=(self.FootWep,)
		return NPCPerson_state		

	def __setstate__(self,parm):
		EnemyChar.__setstate__(self,parm)
		me=Bladex.GetEntity(self.Name)
		version=parm[0]
		if version==1:
			parms=parm[1]["BronzeWarrior"]
			self.FootWep=parms[0]
		me.AddAnmEventFunc("Start_LegWeapon", self.StartLegDamage)
		me.AddAnmEventFunc("Stop_LegWeapon", self.StopLegDamage)
		me.ImDeadFunc=self.NUImDeadFunc
	


BronzeWarriorAttackData =	[ 
           # inner zone blocks:
            [Combat.BLOCK,  0.85, (),                   500.0, 1000.0, 3000.0, 0.35],
            
           # dodges:
            #[Combat.DODGE,  0.30, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            #[Combat.DODGE,  0.30, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.40, "d_b",                500.0, 1200.0, 2000.0, 0.35],
			         
           # attacks:
            
            [Combat.ATTACK, 0.20, ("GI_1H",),             1500.0, 2100.0, 3600.0, 0.35],
            [Combat.ATTACK, 0.12, ("GM1_1H",),            1810.0, 2400.0, 3800.0, 0.35],
            [Combat.ATTACK, 0.10, ("GM2_1H",),            1550.0, 2225.0, 2900.0, 0.35],
            [Combat.ATTACK, 0.10, ("GM3_1H",),            1550.0, 2225.0, 2900.0, 0.35],
            [Combat.ATTACK, 0.07, ("GM4_1H",),            2050.0, 2425.0, 3000.0, 0.35],
            [Combat.ATTACK, 0.05, ("GM5_1H",),            1750.0, 2300.0, 2800.0, 0.35],
            [Combat.ATTACK, 0.12, ("GM6_1H",),            1650.0, 1801.0, 2600.0, 0.35], # stab
            
            [Combat.ATTACK, 0.20, ("GM8_1H",),            200.0,  1200.0, 1900.0, 0.35], # kick
            [Combat.ATTACK, 1.00, "RespectDistance",      0.0,  800.0, 2200.0, 1.00],
            [Combat.MOVE,   0.005, BzwLaugh,                5000.0, 7000.0, 9000.0, 0.35, 1],
            
]


##########################################################################################################################################################


Bladex.AddParticleGType("BossEnergia","GenericParticle",Reference.B_PARTICLE_GTYPE_ADD,80)

for i in range(80):
	if i>60:
		traux=1-((i-60.0)/20.0) 
	elif i<20:
		traux=i/20.0 
	else:
		traux=1.0
	r=10
	g=5
	b=100
	a=255.0*traux
	size=40.0
	Bladex.SetParticleGVal("BossEnergia",i,r,g,b,a,size)
	
	

import AniSoundVmk
import VMBlackKnightComboFX




class VMBlackKnight (EnemyChar):

	HitPower=[5,8,15,25,35,50,65,85,100,120,150,190,240,300,380,460,550,650,820,950]
	DefPower=[0,-3, -5, -10, -15, -20, -25,-30, -35, -40, -45, -50, -55, -60, -65, -70,-75, -80,-85]
	
	def __init__(self, me):
		EnemyChar.__init__(self, me)
		
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		VMBlackKnightComboFX.VMBlackKnightCombosFX(me.Name)
		self.HitPower=[5,8,15,25,35,50,65,85,100,120,150,190,240,300,380,460,550,650,820,950]
		self.DefPower=[0,-3, -5, -10, -15, -20, -25,-30, -35, -40, -45, -50, -55, -60, -65, -70,-75, -80,-85]
		
		self.DamageFactorNone  = 0.25
		self.DamageFactorLight = 0.25
		

	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		AniSoundVmk.AsignarSonidosVMBlackKnight(EntityName)
		Bladex.ReadBitMap("../../Maps/ProsperoArena1/NUFiles/VMBlackKnightStuff/VMBlackKnightIcon.bmp","VMBlackKnightIcon")
		Reference.EnemiesScorerData[self.Name]=("VMBlackKnightIcon","Vmk")
		

	def ToolUp(self,WeaponType="Gladius", ShieldType="Escudo1"):
		me=Bladex.GetEntity(self.Name)
		rwp=Bladex.CreateEntity(self.Name+" RightWeapon",WeaponType,0,0,0,"Weapon")
		Reference.EntitiesObjectData[rwp.Name]=BCopy.deepcopy(Reference.DefaultObjectData[rwp.Kind])
		lwp=Bladex.CreateEntity(self.Name+" LeftWeapon",ShieldType,0,0,0,"Weapon")
		ItemTypes.ItemDefaultFuncs(lwp)
		Actions.TakeObject(me.Name,rwp.Name)
		Actions.TakeObject(me.Name,lwp.Name)
		self.UpdateMyPower()


	def UpdateMyPower(self):
		me=Bladex.GetEntity(self.Name)
		rwp=Bladex.GetEntity(me.InvRight)
		if not rwp:
			return
		LEVEL=me.Level
		hitpower=2
		if LEVEL>19:
			hitpower=1100
		else:
			hitpower=self.HitPower[LEVEL]
		if not Reference.EntitiesObjectData.has_key(rwp.Name):
			Reference.EntitiesObjectData[rwp.Name]=BCopy.deepcopy(Reference.DefaultObjectData[rwp.Kind])
		Reference.EntitiesObjectData[rwp.Name][1]=hitpower
		
		print "VMBlack Knight Weapon Power Increased"
	
	
	def ResetCombat (self,EntityName):		
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			self.AttackNPCTime = 100
			me.AttackList = BCopy.deepcopy(VMBlackKnightAttackData)
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00
			me.BlockingPropensity = 0.6
			if me.Level>2:
				me.AttackList.append ([Combat.ATTACK, 0.2, ("GM4_1H",),1000.0, 1400.0, 2500.0, 0.35],)
				me.AttackList.append ([Combat.ATTACK, 0.2, ("GM7_1H",),1000.0, 1500.0, 2500.0, 0.35],)
			if me.Level>3:
				me.AttackList.append ([Combat.ATTACK, 0.2, ("GM9_1H",),1200.0, 1600.0, 2500.0, 0.35],)
				me.AttackList.append ([Combat.ATTACK, 0.2, ("GM2_1H",),1200.0, 1600.0, 2500.0, 0.35],)
				
			if me.Level>5:
				me.AttackList.append ([Combat.ATTACK, 0.2, ("GM38_1H",),1200.0, 1600.0, 2500.0, 0.35],) # Gladius
				me.AttackList.append ([Combat.ATTACK, 0.2, ("GM23_1H",),1200.0, 1600.0, 2500.0, 0.35],)
			if me.Level>8:
				me.AttackList.append ([Combat.ATTACK, 0.2, ("GM35_1H",),1200.0, 1600.0, 2500.0, 0.35],) # Combat Sword
			if me.Level>11:
				me.AttackList.append ([Combat.ATTACK, 0.2, ("GM5_1H",),1200.0, 1600.0, 2500.0, 0.35],)
				me.AttackList.append ([Combat.ATTACK, 0.2, ("GM23_1H","GM24_1H"),1200.0, 1600.0, 2500.0, 0.35],) # North Cross
			if me.Level>12:
				me.AttackList.append ([Combat.ATTACK, 0.2, ("GM39_1H",),1200.0, 1600.0, 2500.0, 0.35],) # Hooksword
			if me.Level>13:
				me.AttackList.append ([Combat.ATTACK, 0.2, ("GM20_1H",),1200.0, 1600.0, 2500.0, 0.35],) # Mace
			if me.Level>17:
				me.AttackList.append ([Combat.ATTACK, 0.2, ("GM21_1H",),1200.0, 1600.0, 2500.0, 0.35],)
			
			
			
			
VMBlackKnightAttackData = [
	# inner zone blocks:
	[Combat.BLOCK,  0.20, "tr",                 750.0, 1500.0, 3500.0, 0.50],
	[Combat.BLOCK,  0.20, "tl",                 750.0, 1500.0, 3500.0, 0.50],
	[Combat.BLOCK,  0.20, "tb",                 750.0, 1500.0, 3500.0, 0.50],
    	[Combat.BLOCK,  0.40, "tf",                 750.0, 1500.0, 3500.0, 0.50],

    	# outer zone blocks:
    	[Combat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
    	[Combat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
    	[Combat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
    	[Combat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],

	# dodges
    	[Combat.DODGE,  0.15, "d_r",                0.0, 1200.0, 2800.0, 0.35],
    	[Combat.DODGE,  0.15, "d_l",                0.0, 1200.0, 2800.0, 0.35],
    	[Combat.DODGE,  0.10, "d_b",                0.0, 1200.0, 2800.0, 0.35],
    	
    	#[Combat.DODGE,  0.20, "RDA",                0.0, 1200.0, 2800.0, 0.35],
    	#[Combat.DODGE,  0.20, "LDA",                0.0, 1200.0, 2800.0, 0.35],

	# basic attacks
	[Combat.ATTACK, 0.05, ("GI_1H",),             1000.0, 1400.0, 2500.0, 0.35], 
	[Combat.ATTACK, 0.05, ("GM1_1H",),            1000.0, 1400.0, 2500.0, 0.35], 
	[Combat.ATTACK, 0.05, ("GM3_1H",),            1000.0, 1400.0, 2500.0, 0.35], 
	[Combat.ATTACK, 0.05, ("GM30_1H",),            1000.0, 1400.0, 2500.0, 0.35], # replaced Knight Left attack
	[Combat.ATTACK, 0.05, ("GM8_1H",),            1000.0, 1400.0, 2500.0, 0.35], 

    	# inner zone moves:
    	[Combat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
    	[Combat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
    	[Combat.MOVE,   0.15, "tb",                   0.0, 2000.0, 5000.0, 0.35],
    	[Combat.MOVE,   0.10, "tf",                   0.0, 2000.0, 5000.0, 0.35],
        [Combat.MOVE,   0.25, Combat.TempMoveInProc,      5000.0, 7000.0, 9000.0, 0.35],
    	[Combat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
]