import Bladex
import AllyCombat
import Ally_Def
import Reference
import BCopy


import AllyNPCTypes
import AniSoundIrDwarf


TRUE = 1==1
FALSE = not TRUE



class AllyIrDwarf (AllyNPCTypes.AllyChar):
	def __init__(self, me):
		
		AllyNPCTypes.AllyChar.__init__(self, me)
		

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		
	
	def ResetSounds(self, EntityName):
		me = Bladex.GetEntity(EntityName)
		Bladex.ReadBitMap("../../Maps/DwarfWarsTest/IrlichDwarfStuff/IrDwarf_NIcon.bmp","IrDwarfIcon")
		Reference.EnemiesScorerData[self.Name]=("IrDwarfIcon","Ird")	





	def ResetCombat (self,EntityName):		
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			me.BlockingPropensity = 0.8
			self.AttackNPCTime = 100
			me.AttackList = BCopy.deepcopy(AllyIrDwarfAttackData)
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00
			if me.Level>1:
				me.AttackList.append([AllyCombat.ATTACK, 0.08, ("GM43_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>3:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM30_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>5:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM31_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>7:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM15_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>9:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM17_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>12:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM26_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>12:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM11_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
			if me.Level>17:
				me.AttackList.append([AllyCombat.ATTACK, 0.12, ("GM22_1H",), 	  800.0, 1200.0, 2500.0, 0.35],)
							
					
					
					
			
AllyIrDwarfAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],

           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],

            # basic attacks
	    [AllyCombat.ATTACK, 0.1, ("GI_1H",),            500, 1500.0, 2500.0, 0.35], # Light Attack 
	    [AllyCombat.ATTACK, 0.1, ("GM12_1H",),          500, 1500.0, 2500.0, 0.35], # Light High Attack 
	    [AllyCombat.ATTACK, 0.1, ("GM18_1H",),          500, 1500.0, 2500.0, 0.35], # Light Low Attack 
	    [AllyCombat.ATTACK, 0.1, ("GM16_1H",),          500, 1500.0, 2500.0, 0.35], # Light Left Attack 
	    [AllyCombat.ATTACK, 0.1, ("GM14_1H",),          500, 1500.0, 2500.0, 0.35], # Light Right Attack 
	    
	    [AllyCombat.MOVE,   0.03, "tr",                5000.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.MOVE,   0.03, "tl",                5000.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.MOVE,   0.05, "tb",                5000.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.MOVE,   0.03, "tf",                5000.0, 7000.0, 9000.0, 0.50],
            
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
            
            [AllyCombat.MOVE,   0.25, AllyCombat.TempMoveInProc,      3000.0,  7000.0, 9000.0, 0.35, 1],
]
