import Bladex
import ItemTypes
import Actions
import Reference
import MenuText
import InitDataField
import Change
import OnInitTake
import CharStats
import whrandom
import GenFX
import AuxFuncs
import darfuncs
import Auras
import ObjStore
import GameStateAux
import copy


class PersonGemFX:

	def __init__(self, PersonName, ItemName, TimeEffect):
		pers=Bladex.GetEntity(PersonName)
		item=Bladex.GetEntity(ItemName)
		time=Bladex.GetTime()
		self.PersonName=PersonName
		self.ItemName=ItemName

		AuraParams0=(240, 0.01, 1.0, 0, 1, 1)
		AuraParams1=(50 , 1.0 , 1.0, 0, 1, 1)
		AuraParams2=(40 , 0.6 , 1.0, 0, 1, 1)

		XtraParam0=('Bladex.GetEntity("'+PersonName+'").SelfIlum', 0.0)
		XtraParam1=('Bladex.GetEntity("'+PersonName+'").SelfIlum', 0.3)
		XtraParam2=('Bladex.GetEntity("'+PersonName+'").SelfIlum', 0.7)

		if item.Kind=="Gemaazul":

			AuraGradient0=(2,  0.2, 0.4, 0.8, 1.0, 0.2  ,  0.0, 0.2, 0.8, 0.0, 0.7)
			AuraGradient1=(2,  0.8, 0.9, 1.0, 1.0, 0.2  ,  0.0, 0.2, 0.9, 0.1, 1.0)

			self.Aura=Auras.MakeAura(PersonName, TimeEffect, AuraParams0, (), (), AuraGradient0  ,  1,  XtraParam0)
			self.Aura.Data.AddEvent (time+1.0,               AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-4.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-3.6,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-3.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-2.7,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-2.3,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-2.0,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.7,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.5,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.3,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.2,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.05,   AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.0,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect,        AuraParams0, (), (), AuraGradient0  ,  1,  XtraParam0)

		elif item.Kind=="Gemapurpura": # this is blue - should be purple

			AuraGradient0=(2,  0.2, 0.4, 0.8, 1.0, 0.2  ,  0.0, 0.2, 0.8, 0.0, 0.7)
			AuraGradient1=(2,  0.8, 0.9, 1.0, 1.0, 0.2  ,  0.0, 0.2, 0.9, 0.1, 1.0)

			self.Aura=Auras.MakeAura(PersonName, TimeEffect, AuraParams0, (), (), AuraGradient0  ,  1,  XtraParam0)
			self.Aura.Data.AddEvent (time+1.0,               AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-4.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-3.6,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-3.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-2.7,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-2.3,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-2.0,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.7,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.5,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.3,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.2,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.05,   AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.0,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect,        AuraParams0, (), (), AuraGradient0  ,  1,  XtraParam0)

		elif item.Kind=="Gemayell":

			AuraGradient0=(2,  0.8, 0.6, 0.0, 1.0, 0.2  ,  0.4, 0.3, 0.0, 0.0, 0.7)
			AuraGradient1=(2,  1.0, 0.9, 0.5, 1.0, 0.1  ,  0.4, 0.3, 0.0, 0.0, 1.0)

			self.Aura=Auras.MakeAura(PersonName, TimeEffect, AuraParams0, (), (), AuraGradient0  ,  1,  XtraParam0)
			self.Aura.Data.AddEvent (time+1.0,               AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-4.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-3.6,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-3.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-2.7,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-2.3,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-2.0,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.7,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.5,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.3,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.2,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.05,   AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.0,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect,        AuraParams0, (), (), AuraGradient0  ,  1,  XtraParam0)
			
	def __getstate__(self):
		return (1,
				self.PersonName,
				self.ItemName,
				GameStateAux.SaveEntityAux(self.Aura),
			)


	def __setstate__(self,parm):
		if parm[0]==1:
			self.PersonName=parm[1]
			self.ItemName=parm[2]
			self.Aura=GameStateAux.LoadEntityAux(parm[3])
		else:
			print "GemFX.__setstate__() -> Version mismatch"
			self.PersonName=""
			self.ItemName=""
			self.Aura=""



def AddPersonGemFX(PersonName, ItemName, TimeEffect):
	pers=Bladex.GetEntity(PersonName)
	item=Bladex.GetEntity(ItemName)
	if ((not item) or (item.Kind not in ("Gema", "GemaRoja", "Gemaazul", "Gemapurpura","Gemayell"))):
		print "El item especificado no existe no hay efecto definido para este tipo de item!"
		return
	pers.Data.PersonGemFX=PersonGemFX(PersonName, ItemName, TimeEffect)
	


class MagicGem:
	def __init__ (self, me):
		me.UseFunc= self.UseStart
		self.Age_num= 0
		self.UsedBy= "Player1"
		self.UseTime= 15.0
		self.OldFDefense = 0.0
		self.OldFAttack	= 0.0
		self.FDefense = 4.0
		self.FAttack = 4.0
		self.nUses= 3
		self.Name= me.Name
		self.ObjId=ObjStore.GetNewId() 
		ObjStore.ObjectsStore[self.ObjId]=self


	def persistent_id(self):
		return self.ObjId


	def __getstate__(self):
		return (1,
					self.ObjId, 
					self.Age_num,
					self.UsedBy,
					self.UseTime,
					self.OldFDefense,
					self.OldFAttack,
					self.FDefense,
					self.FAttack,
					self.nUses,
					self.Name
				)


	def __setstate__(self,parm):
		if parm[0]==1:
			self.ObjId=parm[1]
			ObjStore.ObjectsStore[self.ObjId]=self
			self.Age_num=parm[2]
			self.UsedBy=parm[3]
			self.UseTime=parm[4]
			self.OldFDefense=parm[5]
			self.OldFAttack=parm[6]
			self.FDefense=parm[7]
			self.FAttack=parm[8]
			self.nUses=parm[9]
			self.Name=parm[10]
		else:
			print "MagicGem.__setstate__() -> Version mismatch"
			self.UsedBy= "Player1"
			self.UseTime= 15.0
			self.OldFDefense = 0.0
			self.OldFAttack	= 0.0
			self.FDefense = 4.0
			self.FAttack = 4.0
			self.nUses= 3
			self.Name= me.Name
			self.ObjId=ObjStore.GetNewId() 
			ObjStore.ObjectsStore[self.ObjId]=self
		
		
	def UseStart (self, ObjectName, use_from):
		if use_from==Actions.USE_FROM_INV:
			object= Bladex.GetEntity(ObjectName)
			if object: object.UseFunc= 0
			Bladex.AddScheduledFunc(Bladex.GetTime()+self.UseTime, self.UseEnd,(ObjectName,self.UsedBy), ObjectName+"_UseEnd")
			

	def UseEnd (self,ObjectName, UserName):
		
		self.nUses= self.nUses-1
		if self.nUses<1:
			user= Bladex.GetEntity(UserName)
			if user:
				inv= user.GetInventory()
				if inv:
					inv.RemoveObject(ObjectName)
					object= Bladex.GetEntity(ObjectName)
					if object: object.SubscribeToList("Pin")
					return
		
			# In case of any problems obtaining handles etc...
			Bladex.AddScheduledFunc(Bladex.GetTime()+self.UseTime, self.UseEnd,(ObjectName, UserName), ObjectName+"_UseEnd")
		else:
			object= Bladex.GetEntity(ObjectName)
			if object: object.UseFunc=self.UseStart
			
			
			
class PowerGem (MagicGem):
	def __init__ (self, me):
		MagicGem.__init__(self, me)
		self.UsedBy= "Player1"
		self.UseTime= 90.0
		self.OldFDefense = 0.0
		self.OldFAttack	= 0.0
		self.FDefense = 4.0
		self.FAttack = 4.0
		self.nUses= 3
		
		Reference.EntitiesSelectionData[self.Name]=(7,4000,MenuText.GetMenuText('Power Gem'))
		

	def UseStart (self, ObjectName, use_from):
		me=Bladex.GetEntity(self.UsedBy)
		if me.Data.Resistances["Slash"]>0.1:
			Actions.ReportMsg("No Powerup with Extra Protection")
			return
		MagicGem.UseStart (self, ObjectName, use_from)
		
		self.OldFAttack = 1.0
		me.Data.FAttack = self.FAttack
		AddPersonGemFX(self.UsedBy, ObjectName, self.UseTime)
		Actions.ReportMsg("You Have Extra Power!")
		print"power on"

	def UseEnd (self,ObjectName, UserName):
		me=Bladex.GetEntity(UserName)
		me.Data.FAttack = self.OldFAttack
		MagicGem.UseEnd (self, ObjectName, UserName)
		Actions.ReportMsg("The Power Has Left You")
		print"power off"
		



class ProtectionGem (MagicGem):
	def __init__ (self, me):
		MagicGem.__init__(self, me)
		self.UsedBy= "Player1"
		self.UseTime= 90.0
		self.nUses= 3
		
		Reference.EntitiesSelectionData[self.Name]=(7,4000,MenuText.GetMenuText('Protection Gem'))
		

	def UseStart (self, ObjectName, use_from):
		me=Bladex.GetEntity(self.UsedBy)
		if me.Data.FAttack>1.0:
			Actions.ReportMsg("No Extra Protection while Powered Up")
			return
		MagicGem.UseStart (self, ObjectName, use_from)
		me.Data.Resistances['Impale']= 0.95
		me.Data.Resistances['Slash'] = 0.95
		me.Data.Resistances['Crush'] = 0.95
		AddPersonGemFX(self.UsedBy, ObjectName, self.UseTime)
		Actions.ReportMsg("You Have Extra Protection!")
		print"power on"

	def UseEnd (self,ObjectName, UserName):
		me=Bladex.GetEntity(UserName)
		me.Data.Resistances= copy.copy(CharStats.GetCharResistances(me.Kind))
		MagicGem.UseEnd (self, ObjectName, UserName)
		Actions.ReportMsg("The Protection Has Left You")
		print"protection off"
		





		
def CreatePowerGem (name,pos):
	gem=Bladex.CreateEntity(name,"Gemaazul",pos[0],pos[1],pos[2], "Weapon")
	gem.Scale=1.0
	gem.SelfIlum=-1
	gem.Impulse(0,0,0)
	gem.Data=PowerGem(gem)
	return gem.Data
			
	
def CreateProtectionGem (name,pos):
	gem=Bladex.CreateEntity(name,"Gemayell",pos[0],pos[1],pos[2], "Weapon")
	gem.Scale=1.1
	gem.SelfIlum=-1
	gem.Impulse(0,0,0)
	gem.Data=ProtectionGem(gem)
	return gem.Data
			
	
	
	
	


class WeaponSuriken(ItemTypes.PersistantItemType):

	def __init__ (self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		
		self.OwnerName= "Player1"
		self.Name= me.Name
		self.SpecialExtraDamage= []
		
		
	def DropReleaseEventHandler (self,EntityName,EventName):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		self.OwnerName= weapon.Parent
		if not self.OwnerName:
			return		
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return	
		if weapon.TestHit:
			return
		Actions.RemoveFromInventory (owner, weapon, EventName)
		ix, iy, iz = owner.Rel2AbsVector(-1000.0, -1500.0, 0.0)
		weapon.Impulse(ix, iy, iz)
		weapon.ExcludeHitFor(owner)
		weapon.OnStopFunc=None
		owner.DelAnmEventFunc(EventName)
		Reference.EntitiesObjectData[weapon.Name]= [Reference.OBJ_ITEM]
		weapon.Data=ItemSuriken(weapon)
		
		
	
	def SurikenStopFunc(self, EntityName):
		weapon= Bladex.GetEntity(EntityName)
	
		if weapon:
			weapon.MessageEvent(Actions.MESSAGE_STOP_WEAPON,0,0)
			weapon.MessageEvent(Actions.MESSAGE_STOP_TRAIL,0,0)
			
			Reference.EntitiesObjectData[weapon.Name]= [Reference.OBJ_ITEM]
			weapon.Data=ItemSuriken(weapon)
			try:
				if weapon.Data.PrevHitFunc:
					weapon.HitFunc= weapon.Data.PrevHitFunc
					weapon.Data.PrevHitFunc= None
					weapon.HitFunc (EntityName)
			except AttributeError:
				pass
			if Reference.EntitiesObjectData.has_key (self.Name):
				print self.SpecialExtraDamage
				for damage in self.SpecialExtraDamage:
					print damage
					if damage in Reference.EntitiesObjectData[self.Name]:
						Reference.EntitiesObjectData[self.Name].remove (damage)
						print "Suriken damage restored"
			print"Suriken Stopped"
	
		
		
		
	def ThrowReleaseEventHandler (self,EntityName,EventName):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		self.OwnerName= weapon.Parent
		if not self.OwnerName:
			return
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return
		
		if weapon.TestHit:
			return
		
		weapon.ExcludeHitFor(owner)
		weapon.OnStopFunc=self.SurikenStopFunc
		
		lvl=owner.Level+1
		if lvl<=20:
			damfact=lvl*5
		else:
			damfact=100
		self.SpecialExtraDamage=[["Venom",+damfact],]
		if not Reference.EntitiesObjectData.has_key(self.Name):
			if weapon:
				Reference.EntitiesObjectData[self.Name]= BCopy.deepcopy(Reference.DefaultObjectData[weapon.Kind])
				print "Suriken data established"
		for damage in self.SpecialExtraDamage:
			Reference.EntitiesObjectData[self.Name].append (damage)
			print damage
				
		Actions.RemoveFromInventory (owner, weapon, EventName)

		if owner.Name=="Player1":
			F= owner.Data.ThrowForce*34000.0

			if owner.InCombat:
				target= Bladex.GetEntity(owner.ActiveEnemy)
				target_pos= target.Position
				source_pos= weapon.Position
				x= target_pos[0]-source_pos[0]
				y= target_pos[1]-source_pos[1]
				z= target_pos[2]-source_pos[2]

				angle, time= Actions.AutoCalcThrow (math.sqrt(x*x+z*z), y, F/weapon.Mass,+9800.0)
			elif EventName == "ThrowLightFacingEvent":
				angle= -PI*0.0625 
			elif EventName == "ThrowHeavyFacingEvent":
				angle= -PI*0.125 
			else:
				angle= -PI*0.0625 

			impulse = owner.Rel2AbsVector(0.0, -math.cos(angle)*F, -math.sin(angle)*F)

			if owner.InCombat:
				angle= B3DLib.Pos2PosXZAngle(source_pos[0], source_pos[1], source_pos[2],target_pos[0], target_pos[1], target_pos[2])
				diff_angle= min (max (B3DLib.DiffAngle(angle, owner.Angle), -Actions.FACINGANGLE), Actions.FACINGANGLE)
				x,y,z= impulse
				cos_ang= math.cos(diff_angle); sin_ang= math.sin(diff_angle)
				impulse = (x*cos_ang-z*sin_ang, y, x*sin_ang+z*cos_ang)

			weapon.Impulse(impulse[0], impulse[1], impulse[2])
			weapon.ExclusionMask= weapon.ExclusionMask | Actions.B_SOLID_MASK_PERSON

			axis= weapon.GetDummyAxis("1H_R", 0.0, 1.0, 0.0)
			mass= 2.0
			
			scale = TWOPI*10/mass
			weapon.AngularVelocity=axis[0]*scale,axis[1]*scale,axis[2]*scale
			weapon.MessageEvent(Actions.MESSAGE_START_WEAPON,0,0)
			weapon.MessageEvent(Actions.MESSAGE_START_TRAIL,0,0)
			InitDataField.Initialise(weapon)
			weapon.Data.PrevHitFunc= None
		
			
			weapon.Data.PrevInflictHitFunc= weapon.InflictHitFunc
			weapon.InflictHitFunc= Actions.ThrownWeaponInflictHitFunc
			weapon.Data.ThrownBy= owner
			owner.DelAnmEventFunc(EventName)
		
		
		
	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		state[1]["WeaponSuriken"]=(self.Name,self.OwnerName,self.SpecialExtraDamage)
		return state
		
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["WeaponSuriken"]
			self.Name= parms[0]
			self.OwnerName= parms[1]
			self.SpecialExtraDamage=parms[2]
		else:
			self.Name= ""
			self.OwnerName= ""
			self.SpecialExtraDamage=[]
		
		
		
		
class ItemSuriken (ItemTypes.PersistantItemType):

	def __init__(self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		me.Weapon= 1
		self.Name= me.Name
		self.OwnerName=""
		Reference.EntitiesObjectData[self.Name]= [Reference.OBJ_ITEM]
		Reference.EntitiesSelectionData[self.Name]=(8,4000,MenuText.GetMenuText('Suriken'))
		Reference.StackObjects['ProSuriken1']= 6
		weapon= Bladex.GetEntity(self.Name)
		InitDataField.Initialise(weapon)
		me.UseFunc = self.UseSuriken
	
	def UseSuriken(self, SurikenName, TipoUso):
		skn=Bladex.GetEntity(SurikenName)
		if TipoUso == Actions.USE_FROM_INV:
		   	ownerName= skn.Data.UsedBy
		   	Actions.FreeBothHands(ownerName)
		   	owner=Bladex.GetEntity(ownerName)
		   	if owner and owner.Life >0:
		   		owner.Data.throw_weapon = None
      	              	inv=owner.GetInventory()
      	              	inv.RemoveObject(SurikenName)
   	              	Change.ChangeObject(ownerName, SurikenName, self.FinishChange)
   	        elif TipoUso == Actions.USE_FROM_TAKE:
		   	Actions.StdUse (ownerName)


	def FinishChange(self, EntityName,ObjectName):
		skn=Bladex.GetEntity(ObjectName)
		newowner=Bladex.GetEntity(skn.Parent)
		if newowner.Name=="Player1":
	       		Reference.EntitiesObjectData[ObjectName]= [Reference.OBJ_STANDARD,   10, 0, 1.0, Reference.THR_SPINNING, []]
	       	else:
	       		Reference.EntitiesObjectData[ObjectName]= [Reference.OBJ_WEAPON,   10, 0, 1.0, Reference.THR_SPINNING, []]
		skn.Data=WeaponSuriken(skn)   
		
		
	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		state[1]["ItemSuriken"]=   (				self.Name,
									self.OwnerName
								)
		return state
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["ItemSuriken"]
			self.Name=parms[0]
			self.OwnerName=  parms[1]		
		else:
			self.Name=""
			self.OwnerName= "Player1"
		
		
		
def MakeSuriken(name,pos,ori):
	su=Bladex.CreateEntity(name,"ProSuriken1",pos[0],pos[1],pos[2], "Weapon")
	su.Scale=1.0
	su.Orientation=(ori[0],ori[1],ori[2],ori[3])
	su.Impulse(0,0,0)
	su.Data=ItemSuriken(su)
	


#######################################################################################################################################################

XPOTION_STATE_USED = 0
XPOTION_STATE_UNUSED = 1

XPOTION_TYPE_EAT = 0
XPOTION_TYPE_DRINK_RIGHT = 1
XPOTION_TYPE_GULP = 2
XPOTION_TYPE_DRINK_LEFT = 3



class MorphinePotion:
	def __init__(self,pot):
		self.Hand = 0
		self.Estado = XPOTION_STATE_UNUSED
		self.Sonido=0
		self.Type = XPOTION_TYPE_DRINK_RIGHT
		self.OHand = ""		
		self.FadeDelta = (0.2 /60.0)
		self.Takeable=1


	def FadeOut(self,entity,timer):		
		poc = Bladex.GetEntity(entity)
		poc.Alpha = poc.Alpha - poc.Data.FadeDelta
		if len(poc.Lights):
			poc.Lights = [(poc.Alpha/2, poc.Lights[0][1], poc.Lights[0][2])]

		if poc.Alpha <= 0:
			poc.SubscribeToList("Pin")




def RestoreMyHand(entidad):	
	char = Bladex.GetEntity(entidad)
	char.AddAnmEventFunc("ChangeREvent",Actions.ToggleWEvent)
	char.LaunchAnmType("Chg_r")

def TakeMorphinePotionUsed():
	pass

def MorphinePotionNoSoltada(entidad):
	Reference.debugprint("MorphinePotionNoSoltada")
	char = Bladex.GetEntity(entidad)	
	object = Bladex.GetEntity(char.Data.obj_used)
	
	if object.Data.Estado == XPOTION_STATE_USED:
		SoltarMorphinePotion(entidad,0)
	else:
		object.ExcludeHitFor(char)
		inv = char.GetInventory()

		
		object.Data.Estado = POTION_STATE_USED
		object.Data.Takeable= 0
		inv.LinkRightHand("None")		
		if object.Data.Hand == 1:
			char.AnmEndedFunc = RestoreMyHand
		inv.RemoveObject(char.Data.obj_used)
		impulse = char.Rel2AbsVector(-1000.0 * object.Mass, -1000.0 * object.Mass, 0.0)	
		object.Impulse(impulse[0],impulse[1],impulse[2])	



def SoltarMorphinePotion(Entidad,Evento = 0):
	char = Bladex.GetEntity(Entidad)
	char.AnmEndedFunc = ""
	if Evento:
		char.DelAnmEventFunc(Evento)
	object = Bladex.GetEntity(char.Data.obj_used)
	object.ExcludeHitFor(char)
	object.TimerFunc = object.Data.FadeOut
	object.SubscribeToList("Timer60")
	object.Data.Takeable=0
	inv = char.GetInventory()

	if object.Data.Type == XPOTION_TYPE_DRINK_LEFT:
		# In Combat and using left hand's second slot
		inv.LinkLeftHand2("None")
		inv.RemoveObject(char.Data.obj_used)
		impulse = char.Rel2AbsVector(1000.0 * object.Mass, -1000.0 * object.Mass, 0.0)
		object.Impulse(impulse[0],impulse[1],impulse[2])
	else:
		inv.LinkRightHand("None")		
		
		if object.Data.Hand == 1:			
			char.AnmEndedFunc = RestoreMyHand
		else:
			char.AnmEndedFunc= Actions.TakeStraightRecover
		inv.RemoveObject(char.Data.obj_used)
		impulse = char.Rel2AbsVector(-1000.0 * object.Mass, -1000.0 * object.Mass, 0.0)	
		object.Impulse(impulse[0],impulse[1],impulse[2])

	darfuncs.SetHint(object,"")
	OnInitTake.AddOnInitTakeEvent(object.Name,TakeMorphinePotionUsed)
	



def BeberMorphinePotion(Entidad,Evento):
	char = Bladex.GetEntity(Entidad)
	char.DelAnmEventFunc(Evento)
	Poti = Bladex.GetEntity(char.Data.obj_used)
	Pot = Poti.Data	
	Pot.Estado = XPOTION_STATE_USED
	Pot.Takeable=0
	char.Data.DamageFactorNone  = 0.15
	char.Data.DamageFactorLight  = 0.25
	time=Bladex.GetTime()
	aura= Auras.MakeAura (Entidad,1.5,    (55,1.0,1.0,1,0,0),  (),(),(2,  0.3,0.0,0.8, 0.5, 0.0  , 0.6,0.0,0.0, 0.1, 0.1))	
	aura.Data.AddEvent(time+1.0,          (55,0.8,1.0,1,0,0),  (),(),(2,  0.5,0.0,0.5, 0.5, 0.0  , 0.6,0.0,0.0, 0.1, 1.0))
	aura.Data.AddEvent(time+1.5,          (255,0.0,1.0,1,0,0), (),(),(2,  0.6,0.0,0.4, 0.5, 0.0  , 0.6,0.0,0.0, 0.1, 1.0))
	print "I feel no pain now"
	Pot.Sonido.Play(char.Position[0],char.Position[1],char.Position[2],0)

	




def UseMorphinePotion3(Entity):	
	char = Bladex.GetEntity(Entity)	
	UseMorphinePotion2(char.Data.obj_used)



def UseMorphinePotion2(NombreMorphinePotion):	
	MorphinePotion = Bladex.GetEntity(NombreMorphinePotion)
	Char = Bladex.GetEntity(MorphinePotion.Data.UsedBy)
	Char.AnmEndedFunc= Actions.TakeStraightRecover
	
	Char.LaunchAnmType("gulp00")
	#Char.LaunchAnmType("drink")	
	Char.AddAnmEventFunc("PickBottle",PickPotion)
	Char.AddAnmEventFunc("drinkingEvent",BeberMorphinePotion)
	#print 'should throw bottle with event ThrowBottle in animation '+Char.AnimName
	Char.AddAnmEventFunc("ThrowBottle",SoltarMorphinePotion)
	
	
	
	
	
def TryToUseMorphinePotion(me, object):
	if Reference.DefaultObjectData[object.Kind][0] == Reference.OBJ_ITEM:
		return 1
	return CanIUseTheMorphinePotion(me,object)


def CanIUseTheMorphinePotion(me,object):
	if object.Kind!="MorphinePot1":
		print "WTF is this function being called"
		return 1
	
	if me.Kind=="Wizard_A" or me.Kind=="Fem1Wiz" and object.Kind=="MorphinePot1":
		import GameText
		import MenuText
		GameText.WriteTextAux(MenuText.GetMenuText("I have no use for such medicines"),2.0,255,255,255,[],None,1)
		return 0

	if me.Data.DamageFactorLight> 0.1 and object.Kind=="MorphinePot1":
		import GameText
		import MenuText
		GameText.WriteTextAux(MenuText.GetMenuText("I have had one dose already"),2.0,255,255,255,[],None,1)
		return 0
	else:
		print "I CAN use the morphine"
		return 1



#Actions.TryToTakeCallBacks.append(TryToUseMorphinePotion)
  
  
  
def UseMorphinePotion(NombreMorphinePotion,TipoUso):
	print"Using Morphine Potion"
	MorphinePotion = Bladex.GetEntity(NombreMorphinePotion)
	Char = Bladex.GetEntity(MorphinePotion.Data.UsedBy)
	
	if not CanIUseTheMorphinePotion(Char,MorphinePotion):
		print "Morphine Not OK to drink. returning......"
		return
	
	if (TipoUso == Actions.USE_FROM_INV and MorphinePotion.Data.Estado == XPOTION_STATE_UNUSED):
		print "This should not happen"
		pass
		
	elif (TipoUso == Actions.USE_FROM_TAKE and MorphinePotion.Data.Estado == XPOTION_STATE_UNUSED):
		# Automatic use from take 		
		MorphinePotion.Data.Hand = 0
		Char.Data.obj_used = NombreMorphinePotion	
		#MorphinePotion.Data.Type = XPOTION_TYPE_GULP
		Char.AnmEndedFunc=UseMorphinePotion3
		


def PickPotion(Entidad,Evento):
	char=Bladex.GetEntity(Entidad)
	char.DelAnmEventFunc(Evento)
	MorphinePotion = char.Data.obj_used		
	object = Bladex.GetEntity(char.Data.obj_used)

	inv = char.GetInventory()
	if object.Data.Type==3:
		inv.LinkLeftHand2(MorphinePotion)
	else:
		inv.LinkRightHand(MorphinePotion)


def CreateMorphinePotion(Nombre):
	Pot = Bladex.GetEntity(Nombre)
	Pot.Static = 0
	spot = AuxFuncs.GetSpot(Pot)
	if spot:
		spot.Visible      = 0
		spot.CastShadows  = 0
		spot.Intensity=0.1
		spot.Color=70, 0, 20
	
	Pot.Data = MorphinePotion(Pot)
	Pot.UseFunc = UseMorphinePotion	
	
	Pot.Data.Sonido = Bladex.CreateSound('..\\..\\Sounds\\Drink.wav', 'MorphineDrinking')
	Pot.Data.Sonido.Volume=1
	Pot.Data.Sonido.MinDistance=10000
	Pot.Data.Sonido.MaxDistance=20000
	
	return Pot.Data

